2015-11-09 15:52  robert

	* CMakeLists.txt: Cleaned up OSX option selection code.
	  
	  Updated version for 3.5.1 dev release

2015-11-09 15:13  robert

	* src/osg/Geometry.cpp: Fixed warning message.

2015-11-09 15:10  robert

	* src/osgPlugins/shp/ESRIShapeReaderWriter.cpp: Addded setting of
	  the Locator CoordinateSystemType

2015-11-09 10:43  robert

	* src/osg/DisplaySettings.cpp: From Jannik Heller, fix typo of
	  OSG_COMPILE_CONTEXTS.

2015-11-05 14:38  robert

	* src/osgViewer/GraphicsWindowX11.cpp: From Mathias Froehlich,
	  "Avoid per frame X11 roundtrips"

2015-10-26 11:41  robert

	* src/osgUtil/CullVisitor.cpp: Restructed the setting of the
	  RenderStage ClearColor/ClearMask to make the code more readable
	  and to avoid double setting of the ClearMask.

2015-10-23 15:04  robert

	* src/osg/DisplaySettings.cpp, src/osgPlugins/osc/CMakeLists.txt:
	  From Alberto Luaces, "here are two minimal capitalization fixes
	  for mingw cross-compilation, where case sensitivity matters."

2015-10-23 11:07  robert

	* src/osgQt/GraphicsWindowQt.cpp: From Sebastian Messershmidt, "The
	  uncommented pointer type QTimerEvent */*event*/ leads to a
	  compiler error under visual studio 2010"

2015-10-22 13:42  robert

	* CMakeLists.txt, applications/osgarchive/osgarchive.cpp,
	  applications/osgconv/osgconv.cpp,
	  applications/osgfilecache/osgfilecache.cpp,
	  applications/osgviewer/osgviewer.cpp,
	  applications/present3D/ReadShowFile.cpp,
	  applications/present3D/present3D.cpp,
	  examples/osg2cpp/osg2cpp.cpp, examples/osgSSBO/osgSSBO.cpp,
	  examples/osganalysis/osganalysis.cpp,
	  examples/osganimate/osganimate.cpp,
	  examples/osganimationhardware/osganimationhardware.cpp,
	  examples/osganimationmorph/osganimationmorph.cpp,
	  examples/osganimationtimeline/osganimationtimeline.cpp,
	  examples/osganimationviewer/AnimtkViewer.cpp,
	  examples/osgatomiccounter/osgatomiccounter.cpp,
	  examples/osgautocapture/osgautocapture.cpp,
	  examples/osgbillboard/osgbillboard.cpp,
	  examples/osgblenddrawbuffers/osgblenddrawbuffers.cpp,
	  examples/osgblendequation/osgblendequation.cpp,
	  examples/osgcallback/osgcallback.cpp,
	  examples/osgcamera/osgcamera.cpp, examples/osgcatch/osgcatch.cpp,
	  examples/osgclip/osgclip.cpp, examples/osgcluster/osgcluster.cpp,
	  examples/osgcompositeviewer/osgcompositeviewer.cpp,
	  examples/osgcomputeshaders/osgcomputeshaders.cpp,
	  examples/osgcopy/osgcopy.cpp, examples/osgcubemap/osgcubemap.cpp,
	  examples/osgdatabaserevisions/osgdatabaserevisions.cpp,
	  examples/osgdelaunay/osgdelaunay.cpp,
	  examples/osgdepthpartition/osgdepthpartition.cpp,
	  examples/osgdepthpeeling/osgdepthpeeling.cpp,
	  examples/osgdistortion/osgdistortion.cpp,
	  examples/osgdrawinstanced/osgdrawinstanced.cpp,
	  examples/osgfadetext/osgfadetext.cpp,
	  examples/osgfont/osgfont.cpp, examples/osgforest/osgforest.cpp,
	  examples/osgfpdepth/osgfpdepth.cpp,
	  examples/osgfxbrowser/osgfxbrowser.cpp,
	  examples/osggameoflife/osggameoflife.cpp,
	  examples/osggeometry/osggeometry.cpp, examples/osggpx/osggpx.cpp,
	  examples/osggraphicscost/osggraphicscost.cpp,
	  examples/osghangglide/base.cpp, examples/osghangglide/sky.cpp,
	  examples/osghangglide/tank.cpp,
	  examples/osghangglide/terrain.cpp,
	  examples/osghangglide/trees.cpp, examples/osghud/osghud.cpp,
	  examples/osgimagesequence/osgimagesequence.cpp,
	  examples/osgimpostor/osgimpostor.cpp,
	  examples/osgintersection/osgintersection.cpp,
	  examples/osgkdtree/osgkdtree.cpp,
	  examples/osgkeyboardmouse/osgkeyboardmouse.cpp,
	  examples/osgkeystone/osgkeystone.cpp,
	  examples/osglauncher/osglauncher.cpp,
	  examples/osglight/osglight.cpp,
	  examples/osglightpoint/osglightpoint.cpp,
	  examples/osglogicop/osglogicop.cpp, examples/osglogo/osglogo.cpp,
	  examples/osgmanipulator/osgmanipulator.cpp,
	  examples/osgmotionblur/osgmotionblur.cpp,
	  examples/osgmovie/osgmovie.cpp,
	  examples/osgmultiplemovies/osgmultiplemovies.cpp,
	  examples/osgmultitexture/osgmultitexture.cpp,
	  examples/osgmultitexturecontrol/osgmultitexturecontrol.cpp,
	  examples/osgmultitouch/osgmultitouch.cpp,
	  examples/osgmultiviewpaging/osgmultiviewpaging.cpp,
	  examples/osgoccluder/osgoccluder.cpp,
	  examples/osgocclusionquery/osgocclusionquery.cpp,
	  examples/osgoit/osgoit.cpp,
	  examples/osgoscdevice/osgoscdevice.cpp,
	  examples/osgoutline/osgoutline.cpp,
	  examples/osgpagedlod/osgpagedlod.cpp,
	  examples/osgparametric/osgparametric.cpp,
	  examples/osgparticleeffects/osgparticleeffects.cpp,
	  examples/osgphotoalbum/ImageReaderWriter.cpp,
	  examples/osgphotoalbum/ImageReaderWriter.h,
	  examples/osgphotoalbum/PhotoArchive.cpp,
	  examples/osgphotoalbum/PhotoArchive.h,
	  examples/osgpick/osgpick.cpp, examples/osgplanets/osgplanets.cpp,
	  examples/osgpoints/osgpoints.cpp,
	  examples/osgpointsprite/osgpointsprite.cpp,
	  examples/osgposter/PosterPrinter.cpp,
	  examples/osgposter/osgposter.cpp,
	  examples/osgprecipitation/osgprecipitation.cpp,
	  examples/osgprerender/osgprerender.cpp,
	  examples/osgreflect/osgreflect.cpp,
	  examples/osgscreencapture/osgscreencapture.cpp,
	  examples/osgscribe/osgscribe.cpp,
	  examples/osgsequence/osgsequence.cpp,
	  examples/osgshadercomposition/oldshadercomposition.cpp,
	  examples/osgshadercomposition/osgshadercomposition.cpp,
	  examples/osgshadergen/osgshadergen.cpp,
	  examples/osgshaderterrain/osgshaderterrain.cpp,
	  examples/osgshadow/osgshadow.cpp, examples/osgshape/osgshape.cpp,
	  examples/osgsidebyside/osgsidebyside.cpp,
	  examples/osgsimplegl3/osgsimplegl3.cpp,
	  examples/osgsimplifier/osgsimplifier.cpp,
	  examples/osgsimulation/osgsimulation.cpp,
	  examples/osgslice/osgslice.cpp,
	  examples/osgspheresegment/osgspheresegment.cpp,
	  examples/osgspotlight/osgspotlight.cpp,
	  examples/osgstereoimage/osgstereoimage.cpp,
	  examples/osgstereomatch/osgstereomatch.cpp,
	  examples/osgteapot/osgteapot.cpp,
	  examples/osgterrain/osgterrain.cpp,
	  examples/osgtessellate/osgtessellate.cpp,
	  examples/osgtext/osgtext.cpp, examples/osgtext3D/osgtext3D.cpp,
	  examples/osgtexture1D/osgtexture1D.cpp,
	  examples/osgtexture2D/osgtexture2D.cpp,
	  examples/osgtexture2DArray/osgtexture2DArray.cpp,
	  examples/osgtexture3D/osgtexture3D.cpp,
	  examples/osgtexturecompression/osgtexturecompression.cpp,
	  examples/osgtexturerectangle/osgtexturerectangle.cpp,
	  examples/osgthirdpersonview/osgthirdpersonview.cpp,
	  examples/osgthreadedterrain/osgthreadedterrain.cpp,
	  examples/osgtransferfunction/osgtransferfunction.cpp,
	  examples/osguniformbuffer/osguniformbuffer.cpp,
	  examples/osgunittests/MultiThreadRead.cpp,
	  examples/osguserdata/osguserdata.cpp,
	  examples/osguserstats/osguserstats.cpp,
	  examples/osgvertexattributes/osgvertexattributes.cpp,
	  examples/osgvertexprogram/osgvertexprogram.cpp,
	  examples/osgviewerGLUT/osgviewerGLUT.cpp,
	  examples/osgviewerQt/osgviewerQt.cpp,
	  examples/osgviewerSDL/osgviewerSDL.cpp,
	  examples/osgvirtualprogram/CreateAdvancedHierachy.cpp,
	  examples/osgvirtualprogram/osgvirtualprogram.cpp,
	  examples/osgvolume/osgvolume.cpp,
	  examples/osgwidgetbox/osgwidgetbox.cpp,
	  examples/osgwidgetframe/osgwidgetframe.cpp,
	  examples/osgwidgetmenu/osgwidgetmenu.cpp,
	  examples/osgwidgetmessagebox/osgwidgetmessagebox.cpp,
	  examples/osgwidgetscrolled/osgwidgetscrolled.cpp,
	  examples/osgwidgetwindow/osgwidgetwindow.cpp,
	  examples/osgwindows/osgwindows.cpp, include/osg/Drawable,
	  include/osg/Geode, include/osg/Group, include/osg/Image,
	  include/osg/ImageSequence, include/osg/LOD, include/osg/Node,
	  include/osg/NodeVisitor, include/osg/Object,
	  include/osg/PagedLOD, include/osg/Program, include/osg/ProxyNode,
	  include/osg/Sequence, include/osg/Shape,
	  include/osg/ShapeDrawable, include/osg/StateSet,
	  include/osg/Switch, include/osg/Texture, include/osg/Texture1D,
	  include/osg/Texture2D, include/osg/Texture2DArray,
	  include/osg/Texture2DMultisample, include/osg/Texture3D,
	  include/osg/TextureCubeMap, include/osg/TextureRectangle,
	  include/osg/UserDataContainer, include/osgDB/ImagePager,
	  include/osgDB/Input, include/osgDB/InputStream,
	  include/osgDB/ReadFile, include/osgDB/ReaderWriter,
	  include/osgDB/Serializer, include/osgManipulator/Dragger,
	  include/osgParticle/Particle, include/osgParticle/ParticleEffect,
	  include/osgPresentation/SlideShowConstructor,
	  include/osgShadow/ShadowedScene, include/osgSim/LineOfSight,
	  include/osgSim/OverlayNode, include/osgTerrain/Layer,
	  include/osgTerrain/TerrainTile, include/osgText/Font,
	  include/osgText/Font3D, include/osgUtil/IntersectionVisitor,
	  include/osgUtil/Optimizer, include/osgViewer/CompositeViewer,
	  include/osgViewer/View, include/osgViewer/Viewer,
	  include/osgVolume/Layer, include/osgVolume/Locator,
	  include/osgVolume/Property, include/osgWidget/Frame,
	  include/osgWidget/Widget, src/osg/Config.in,
	  src/osg/ImageSequence.cpp, src/osgDB/FileCache.cpp,
	  src/osgDB/ImagePager.cpp, src/osgDB/Input.cpp,
	  src/osgDB/InputStream.cpp, src/osgDB/ReadFile.cpp,
	  src/osgFX/BumpMapping.cpp, src/osgParticle/ParticleSystem.cpp,
	  src/osgPlugins/Inventor/ConvertFromInventor.cpp,
	  src/osgPlugins/OpenFlight/PaletteRecords.cpp,
	  src/osgPlugins/OpenFlight/ReaderWriterFLT.cpp,
	  src/osgPlugins/bsp/VBSPEntity.cpp,
	  src/osgPlugins/bsp/VBSPReader.cpp,
	  src/osgPlugins/fbx/fbxMaterialToOsgStateSet.cpp,
	  src/osgPlugins/gles/ReaderWriterGLES.cpp,
	  src/osgPlugins/glsl/ReaderWriterGLSL.cpp,
	  src/osgPlugins/ive/DataInputStream.cpp,
	  src/osgPlugins/ive/HeightFieldLayer.cpp,
	  src/osgPlugins/ive/Layer.cpp, src/osgPlugins/ive/ProxyNode.cpp,
	  src/osgPlugins/lua/LuaScriptEngine.cpp,
	  src/osgPlugins/lws/SceneLoader.cpp,
	  src/osgPlugins/normals/ReaderWriterNormals.cpp,
	  src/osgPlugins/osg/ReaderWriterOSG2.cpp,
	  src/osgPlugins/osgjs/ReaderWriterJSON.cpp,
	  src/osgPlugins/osgjs/WriteVisitor.cpp,
	  src/osgPlugins/osgtgz/ReaderWriterOSGTGZ.cpp,
	  src/osgPlugins/p3d/ReaderWriterP3D.cpp,
	  src/osgPlugins/revisions/ReaderWriterRevisions.cpp,
	  src/osgPlugins/rot/ReaderWriterROT.cpp,
	  src/osgPlugins/scale/ReaderWriterSCALE.cpp,
	  src/osgPlugins/shadow/ReaderWriterOsgShadow.cpp,
	  src/osgPlugins/terrain/ReaderWriterOsgTerrain.cpp,
	  src/osgPlugins/tgz/ReaderWriterTGZ.cpp,
	  src/osgPlugins/trans/ReaderWriterTRANS.cpp,
	  src/osgPlugins/trk/ReaderWriterTRK.cpp,
	  src/osgPlugins/txp/TXPArchive.cpp,
	  src/osgPlugins/vrml/ConvertToVRML.cpp,
	  src/osgPresentation/Cursor.cpp,
	  src/osgPresentation/SlideShowConstructor.cpp,
	  src/osgSim/LineOfSight.cpp, src/osgSim/ScalarBar.cpp,
	  src/osgTerrain/GeometryPool.cpp, src/osgTerrain/TerrainTile.cpp,
	  src/osgText/Font.cpp, src/osgUI/Style.cpp,
	  src/osgViewer/CompositeViewer.cpp, src/osgViewer/Keystone.cpp,
	  src/osgViewer/Viewer.cpp, src/osgWidget/Browser.cpp,
	  src/osgWidget/Frame.cpp, src/osgWidget/PdfReader.cpp,
	  src/osgWidget/VncClient.cpp, src/osgWidget/Widget.cpp,
	  src/osgWrappers/deprecated-dotosg/osg/ProxyNode.cpp,
	  src/osgWrappers/deprecated-dotosg/osg/Shader.cpp,
	  src/osgWrappers/deprecated-dotosg/osg/Texture1D.cpp,
	  src/osgWrappers/deprecated-dotosg/osg/Texture2D.cpp,
	  src/osgWrappers/deprecated-dotosg/osg/Texture2DArray.cpp,
	  src/osgWrappers/deprecated-dotosg/osg/Texture3D.cpp,
	  src/osgWrappers/deprecated-dotosg/osg/TextureCubeMap.cpp,
	  src/osgWrappers/deprecated-dotosg/osg/TextureRectangle.cpp,
	  src/osgWrappers/deprecated-dotosg/osgFX/IO_AnisotropicLighting.cpp,
	  src/osgWrappers/deprecated-dotosg/osgTerrain/HeightFieldLayer.cpp,
	  src/osgWrappers/deprecated-dotosg/osgTerrain/TerrainTile.cpp,
	  src/osgWrappers/serializers/osg/Camera.cpp,
	  src/osgWrappers/serializers/osg/CompositeShape.cpp,
	  src/osgWrappers/serializers/osg/Geode.cpp,
	  src/osgWrappers/serializers/osg/HeightField.cpp,
	  src/osgWrappers/serializers/osg/ImageSequence.cpp,
	  src/osgWrappers/serializers/osg/Object.cpp,
	  src/osgWrappers/serializers/osg/PagedLOD.cpp,
	  src/osgWrappers/serializers/osg/Program.cpp,
	  src/osgWrappers/serializers/osg/ProxyNode.cpp,
	  src/osgWrappers/serializers/osg/StateSet.cpp,
	  src/osgWrappers/serializers/osg/Texture2DArray.cpp,
	  src/osgWrappers/serializers/osg/TriangleMesh.cpp,
	  src/osgWrappers/serializers/osg/Uniform.cpp,
	  src/osgWrappers/serializers/osg/UserDataContainer.cpp,
	  src/osgWrappers/serializers/osgAnimation/AnimationManagerBase.cpp,
	  src/osgWrappers/serializers/osgAnimation/MorphGeometry.cpp,
	  src/osgWrappers/serializers/osgAnimation/UpdateMatrixTransform.cpp,
	  src/osgWrappers/serializers/osgFX/AnisotropicLighting.cpp,
	  src/osgWrappers/serializers/osgManipulator/CompositeDragger.cpp,
	  src/osgWrappers/serializers/osgManipulator/Dragger.cpp,
	  src/osgWrappers/serializers/osgManipulator/Scale1DDragger.cpp,
	  src/osgWrappers/serializers/osgManipulator/Scale2DDragger.cpp,
	  src/osgWrappers/serializers/osgParticle/CompositePlacer.cpp,
	  src/osgWrappers/serializers/osgParticle/ModularProgram.cpp,
	  src/osgWrappers/serializers/osgParticle/Particle.cpp,
	  src/osgWrappers/serializers/osgParticle/ParticleEffect.cpp,
	  src/osgWrappers/serializers/osgParticle/ParticleSystemUpdater.cpp,
	  src/osgWrappers/serializers/osgSim/LightPointNode.cpp,
	  src/osgWrappers/serializers/osgSim/ScalarBar.cpp,
	  src/osgWrappers/serializers/osgTerrain/CompositeLayer.cpp,
	  src/osgWrappers/serializers/osgTerrain/TerrainTile.cpp,
	  src/osgWrappers/serializers/osgText/TextBase.cpp,
	  src/osgWrappers/serializers/osgVolume/CompositeLayer.cpp,
	  src/osgWrappers/serializers/osgVolume/CompositeProperty.cpp,
	  src/osgWrappers/serializers/osgVolume/Locator.cpp: Introduced
	  CMake option OSG_PROVIDE_READFILE option that defaults to ON, but
	  when switched to OFF disables the building of the
	  osgDB::read*File() methods,
	  forcing users to use osgDB::readRef*File() methods. The later is
	  preferable as it closes a potential threading bug when using
	  paging databases in conjunction
	  with the osgDB::Registry Object Cache. This threading bug occurs
	  when one thread gets an object from the Cache via an
	  osgDB::read*File() call where only
	  a pointer to the object is passed back, so taking a reference to
	  the object is delayed till it gets reassigned to a ref_ptr<>, but
	  at the same time another
	  thread calls a flush of the Object Cache deleting this object as
	  it's referenceCount is now zero. Using osgDB::readREf*File()
	  makes sure the a ref_ptr<> is
	  passed back and the referenceCount never goes to zero.
	  
	  To ensure the OSG builds when OSG_PROVIDE_READFILE is to OFF the
	  many cases of osgDB::read*File() usage had to be replaced with a
	  ref_ptr<> osgDB::readRef*File()
	  usage. The avoid this change causing lots of other client code to
	  be rewritten to handle the use of ref_ptr<> in place of C pointer
	  I introduced a serious of
	  templte methods in various class to adapt ref_ptr<> to the
	  underly C pointer to be passed to old OSG API's, example of this
	  is found in include/osg/Group:
	  
	  bool addChild(Node* child); // old method which can only be used
	  with a Node*
	  
	  tempalte<class T> bool addChild(const osg::ref_ptr<T>& child) {
	  return addChild(child.get()); } // adapter template method
	  
	  These changes together cover 149 modified files, so it's a large
	  submission. This extent of changes are warrent to make use of the
	  Object Cache
	  and multi-threaded loaded more robust.

2015-10-09 08:44  robert

	* ChangeLog: updated ChangeLog

2015-10-08 15:58  robert

	* src/osg/GraphicsContext.cpp: Added osg::flushAllDeletedGLObjects
	  to clean up of graphics context after the existing
	  osg::deleteAllGLObjects() to catch any cases where delete doesn't
	  flush GL objects.

2015-10-05 10:58  robert

	* src/osgDB/DatabasePager.cpp, src/osgDB/Registry.cpp,
	  src/osgViewer/ViewerBase.cpp: Introduced usage of
	  OSG_INIT_SINGLETON_PROXY into DatabasePager::prototype() and
	  Registry::instance(), removing the InitRegistry proxy object in
	  src/osgViewer/ViewerBase.cpp.

2015-09-25 15:20  robert

	* include/osg/BoundingSphere: From Kristofer Tingdahl, "we had a
	  minor shadow problem with the osg-3.4 that pollutes our
	  continuous integration"

2015-09-25 11:15  robert

	* src/osgViewer/Renderer.cpp: Added fix for case when Renderer is
	  assigned to a Camera that has now View

2015-09-25 10:11  robert

	* src/OpenThreads/pthreads/PThread.cpp: From Curtis Rubel, "I would
	  like to submit the attached file for inclusion in future releases
	  of
	  OpenSceneGraph and the OpenThreads library.
	  
	  The changes in the file simply remove a few ifndef's that
	  currently
	  do not allow Linux systems to fully utilize the PThread real-time
	  scheduling API.
	  
	  Since Linux now fully supports the PThread scheduling API it
	  would
	  be beneficial to have it available to use as necessary. I have
	  been testing this change since OSG release 3.3.7 and have not
	  seen
	  any ill affects.
	  
	  The Priority scheduling api is further protected by another
	  ifdef:
	  
	  #ifdef ALLOW_PRIORITY_SCHEDULING
	  
	  that only appears to be defined in the pthreads implementation as
	  well. This would make it unlikely that anyone would be affected
	  by this unless they are intentionally wanting to run with
	  priority
	  scheduling. In which case on Linux they would need to make
	  these same modifications themselves to utilize it to its full
	  extent.
	  
	  Attached file is for the current trunk as of this date.
	  "

2015-09-25 10:09  robert

	* include/osgUtil/SceneView, src/osgViewer/Renderer.cpp: Refactored
	  the way that FrameStamp is managed in osgViewer::Renderer to
	  avoid thread conflicts

2015-09-24 14:14  robert

	* src/osgWrappers/deprecated-dotosg/osg/LibraryWrapper.cpp,
	  src/osgWrappers/deprecated-dotosg/osg/Texture2DArray.cpp: From
	  John Hedström,"Texture2DArray support for the .osg serializer"

2015-09-24 10:52  robert

	* include/osg/Camera, src/osgWrappers/serializers/osg/Camera.cpp:
	  Added support for serializing
	  Camera::ImplicitBufferAttachmentRenderMask and
	  ImplicitBufferAttachmentResolveMask properties.

2015-09-24 10:48  robert

	* src/osg/Drawable.cpp: Quietened down debug messages

2015-09-24 09:29  robert

	* src/osgWrappers/serializers/osg/Camera.cpp: Fixed line endings.

2015-09-23 10:41  robert

	* include/osg/ContextData: Added missing OSG_EXPORT to fix Windows
	  build

2015-09-23 09:47  robert

	* examples/osganalysis/osganalysis.cpp,
	  examples/osgfpdepth/osgfpdepth.cpp, include/osg/BufferObject,
	  include/osg/ContextData, include/osg/Drawable,
	  include/osg/FragmentProgram, include/osg/FrameBufferObject,
	  include/osg/GLObjects, include/osg/Program, include/osg/Shader,
	  include/osg/State, include/osg/Texture,
	  include/osg/VertexProgram, src/CMakeLists.txt,
	  src/osg/BufferObject.cpp, src/osg/CMakeLists.txt,
	  src/osg/ContextData.cpp, src/osg/Drawable.cpp,
	  src/osg/FragmentProgram.cpp, src/osg/FrameBufferObject.cpp,
	  src/osg/GLObjects.cpp, src/osg/GraphicsContext.cpp,
	  src/osg/OcclusionQueryNode.cpp, src/osg/Program.cpp,
	  src/osg/Shader.cpp, src/osg/State.cpp, src/osg/Texture.cpp,
	  src/osg/Texture1D.cpp, src/osg/Texture2D.cpp,
	  src/osg/Texture2DArray.cpp, src/osg/Texture2DMultisample.cpp,
	  src/osg/Texture3D.cpp, src/osg/TextureCubeMap.cpp,
	  src/osg/TextureRectangle.cpp, src/osg/VertexProgram.cpp,
	  src/osgUtil/RenderStage.cpp, src/osgUtil/SceneView.cpp:
	  Refactored the GL object deletion management to use new
	  osg::GraphicsObjectManager/GLObjectManager base classes, and
	  osg::ContextData container.
	  
	  This approach unifies much of the code handling the clean up of
	  OpenGL graphics data, avoids lots of local mutexes and static
	  variables that were previously required,
	  and enables the clean up scheme to be easily extended by users
	  providing their own GraphicsObjectManager subclasses.

2015-09-04 15:35  robert

	* src/osg/Geometry.cpp: From Jannik Heller, "I've hit what I
	  believe to be a bug (or at the very least, an unintuitive
	  behaviour) in the osg::Geometry copy constructor. I noticed it
	  when using osg::clone on a Geometry with vertex buffer objects,
	  and the copy flags DEEP_COPY_ARRAYS. To be precise, I add a
	  Geometry to an osgUtil::IncrementalCompileOperation, then
	  osg::clone the Geometry. I was getting reports from users of
	  random crashes happening.
	  
	  I believe the offending lines are in the osg::Geometry copy
	  constructor:
	  
	  if ((copyop.getCopyFlags() & osg::CopyOp::DEEP_COPY_ARRAYS))
	  {
	  if (_useVertexBufferObjects)
	  {
	  // copying of arrays doesn't set up buffer objects so we'll need
	  to force
	  // Geometry to assign these, we'll do this by switching off VBO's
	  then renabling them.
	  setUseVertexBufferObjects(false);
	  setUseVertexBufferObjects(true);
	  }
	  }
	  
	  Toggling the vertex buffer objects off then on again actually
	  touches not only the arrays controlled by DEEP_COPY_ARRAYS, but
	  also the PrimitiveSets which are controlled by
	  DEEP_COPY_PRIMITIVES. This means if the user has copyflags of
	  only DEEP_COPY_ARRAYS, we are modifying arrays that belong to the
	  original const Geometry& we are copying from. I believe this
	  shouldn't be allowed to happen because we are using a const&
	  specifier for the original Geometry.
	  
	  In my case the osgUtil::IncrementalCompileOperation was trying to
	  compile the geometry, while in the main thread a clone operation
	  toggled the VBO's off and on, a crash ensues.
	  
	  In the attached patch, you will find a more efficient handling of
	  VBO's in the osg::Geometry copy constructor, so that only the
	  Arrays that were actually deep copied have their VBO assigned,
	  and no changes are made to Arrays that already had a valid VBO
	  assigned. In addition, the DEEP_COPY_PRIMITIVES flag is now
	  honored so that VBO's are set up correctly should a user copy a
	  Geometry with only that flag.
	  "

2015-09-04 15:04  robert

	* include/osgDB/ImagePager: From Laurens Voerman, "I found that
	  using an ImageSequence with mode PAGE_AND_DISCARD_USED_IMAGES
	  triggers the (3) imageThreads to run and never stop, even when no
	  more work is to be done. This is due to a bug in the stop
	  condition currently setting the thread to stop and wait for a
	  signal only when no work needs to be done AND the databasepager
	  is paused.
	  It should stop and wait for a signal on either of those two. Due
	  to a few logical inversions it boils down to replacing || with &&
	  
	  OLD _block->set((!_requestList.empty() ||
	  !_pager->_databasePagerThreadPaused));
	  NEW _block->set((!_requestList.empty() &&
	  !_pager->_databasePagerThreadPaused));//release the threads to
	  run IF (work_to_be_done && not_paused)
	  
	  This bug is present since svn rev 8663 (just before 2.6.0
	  release)
	  
	  
	  attached is a zip with the files:
	  
	  OpenSceneGraph\include\osgDB\ImagePager
	  
	  
	  
	  This file is valid for svn branch and stable 3.2 and 3.4
	  branches 2.6 - 3.0 have the same bug, but other differences in
	  the file."

2015-09-04 14:50  robert

	* applications/osgconv/osgconv.cpp: From Laurens Voerman, "I
	  crashed osgconv while compressing textures:
	  
	  osgconv --compressed-dxt1 cow.osg cow.ive
	  
	  due to different handling of the extentions in osg 3.4 and up.
	  
	  attached is a zip with the files:
	  
	  OpenSceneGraph\applications\osgconv\osgconv.cpp
	  
	  
	  
	  This file is valid for svn branch and stable3.4."

2015-09-04 14:34  robert

	* src/osg/Geometry.cpp: From Julien Valentin, "Serializing custom
	  geometry i ran into a crash due to a
	  setVertexAttribArrayList(array) with array containing NULL
	  vertexAttrib.
	  I added a test in order to avoid it
	  
	  
	  Code:
	  void Geometry::setVertexAttribArrayList(const ArrayList&
	  arrayList)
	  {
	  _vertexAttribList = arrayList;
	  
	  dirtyDisplayList();
	  
	  if (_useVertexBufferObjects)
	  {
	  for(ArrayList::iterator itr = _vertexAttribList.begin();
	  itr != _vertexAttribList.end();
	  ++itr)
	  {
	  if(itr->get())//ADDED
	  addVertexBufferObjectIfRequired(itr->get());
	  }
	  }
	  }
	  "
	  
	  and
	  
	  "The bug i ran into is a crash reading osgt Geometry with null
	  vertexattribs.
	  The only thing i added is a not nul check on array passed to
	  setVertexAttribArrayList."
	  
	  --------------------This line, and those below, will be ignored--
	  
	  M src/osg/Geometry.cpp

2015-09-04 14:24  robert

	* CMakeLists.txt: Updated SO version for svn/trunk.

2015-09-04 14:24  robert

	* include/osg/OperationThread: Fixed warning

2015-09-04 14:23  robert

	* include/osgDB/OutputStream: Fixed warning by removing redundent
	  check

2015-08-14 15:25  robert

	* include/osg/Texture2D, src/osg/Texture2D.cpp: Corrected the
	  Subload::generateTextureObject() return type to make it
	  consistent with Texture::generateTextureObject(..)

2015-08-12 10:18  robert

	* src/osgVolume/Shaders/volume_frag.cpp,
	  src/osgVolume/Shaders/volume_iso_frag.cpp,
	  src/osgVolume/Shaders/volume_lit_frag.cpp,
	  src/osgVolume/Shaders/volume_lit_tf_frag.cpp,
	  src/osgVolume/Shaders/volume_mip_frag.cpp,
	  src/osgVolume/Shaders/volume_tf_frag.cpp,
	  src/osgVolume/Shaders/volume_tf_iso_frag.cpp,
	  src/osgVolume/Shaders/volume_tf_mip_frag.cpp: Updated shaders
	  from OpenSceneGraph-Data with refactor of workaround to NVidia
	  driver bug

2015-08-12 06:39  robert

	* CMakeLists.txt, README.txt: Added GL1 to the docs of the
	  GL_PROFILE string
	  Updated the date of the 3.4.0 release in the README.

2015-08-11 20:06  robert

	* src/osgVolume/Shaders/volume_frag.cpp,
	  src/osgVolume/Shaders/volume_iso_frag.cpp,
	  src/osgVolume/Shaders/volume_lit_frag.cpp,
	  src/osgVolume/Shaders/volume_lit_tf_frag.cpp,
	  src/osgVolume/Shaders/volume_mip_frag.cpp,
	  src/osgVolume/Shaders/volume_tf_frag.cpp,
	  src/osgVolume/Shaders/volume_tf_iso_frag.cpp,
	  src/osgVolume/Shaders/volume_tf_mip_frag.cpp: Refactored
	  workaround of NVidia nan lenght() bug.

2015-08-11 08:43  robert

	* CMakeLists.txt, CMakeModules/FindAsio.cmake,
	  CMakeModules/FindLIBLAS.cmake, src/osgPlugins/CMakeLists.txt:
	  Moved FIND_PACKAGE(Boost) to within the individual Find scripts
	  that actually need it rather in the root CMakeLists.txt.

2015-08-10 19:55  robert

	* src/osg/State.cpp: Removed spaces

2015-08-10 19:40  robert

	* CMakeLists.txt: Fixed line endings

2015-08-10 19:39  robert

	* src/osgVolume/Shaders/volume_frag.cpp,
	  src/osgVolume/Shaders/volume_iso_frag.cpp,
	  src/osgVolume/Shaders/volume_lit_frag.cpp,
	  src/osgVolume/Shaders/volume_lit_tf_frag.cpp,
	  src/osgVolume/Shaders/volume_mip_frag.cpp,
	  src/osgVolume/Shaders/volume_tf_frag.cpp,
	  src/osgVolume/Shaders/volume_tf_iso_frag.cpp,
	  src/osgVolume/Shaders/volume_tf_mip_frag.cpp: Updated built-in
	  shaders from OpenSceneGraph-Data vesion that introduce
	  #pragma(tic) shaders that resolve the NVidia loop iteration bug.

2015-08-10 19:18  robert

	* src/osg/Shader.cpp: Quietened down #pragma(tic) shader
	  composition messages

2015-08-10 17:42  robert

	* include/osg/State, src/osg/State.cpp: Added support for injecting
	  GL_VENDOR strings into GLSL shaders via the new #pragma(tic)
	  shader composition

2015-08-10 05:04  robert

	* include/osg/Types, src/osg/CMakeLists.txt: Build fix for VS and
	  installing Types

2015-08-09 09:42  robert

	* src/osg/GL.in: Changed GLint64 and GLuint64 setup to use int64_t
	  and uint64_t resptectivly respectively to avoid issues with
	  compiling against Qt5

2015-08-09 09:07  robert

	* include/osgViewer/api/X11/PixelBufferX11,
	  src/osgViewer/PixelBufferX11.cpp: Added #ifdef guards around SGIX
	  specific parts to avoid build problems with GLES

2015-08-08 08:49  robert

	* src/osgPlugins/zip/ZipArchive.cpp: From Glenn Waldron, fix error
	  in ZIP plugin handling of memory buffer

2015-08-06 15:03  robert

	* src/osgText/Text.cpp: Added checks for the validity of chached
	  coordinate arrays.

2015-08-06 10:09  robert

	* src/osgVolume/Shaders/volume_frag.cpp,
	  src/osgVolume/Shaders/volume_iso_frag.cpp,
	  src/osgVolume/Shaders/volume_lit_frag.cpp,
	  src/osgVolume/Shaders/volume_lit_tf_frag.cpp,
	  src/osgVolume/Shaders/volume_mip_frag.cpp,
	  src/osgVolume/Shaders/volume_tf_frag.cpp,
	  src/osgVolume/Shaders/volume_tf_iso_frag.cpp,
	  src/osgVolume/Shaders/volume_tf_mip_frag.cpp: Updated shaders
	  from OpenSceneGraph-Data.

2015-08-03 19:14  robert

	* include/osgViewer/api/X11/PixelBufferX11,
	  src/osgViewer/PixelBufferX11.cpp: From Andy Skinner, "Someone was
	  using our code on a system that does not seem to have the SGIX
	  symbols used in osgViewer.cpp.
	  
	  
	  
	  I used osgSetGLExtensionsFuncPtr to remove the symbols. I don't
	  know how to test this path, but it did remove the symbols from
	  libosgViewer.so. I have also not been able yet to see if that was
	  sufficient for our customer.
	  
	  
	  
	  I did this by looking at other cases, and I tried to follow some
	  of the same practices in PixelBufferX11, like using _useSGIX in a
	  similar way to the previous _useGLX1_3."

2015-07-31 13:46  robert

	* CMakeModules/OsgAndroidMacroUtils.cmake: From Terry Welsh, "I
	  downloaded the Android 3rdparty deps from here
	  http://www.openscenegraph.org/index.php/download-section/dependencies
	  but was not able to use them for a while. Attached are changes to
	  OsgAndroidMacroUtils.cmake that allow the deps to be found by
	  cmake.
	  
	  Specifically, all FIND_PATH commands require the
	  NO_CMAKE_FIND_ROOT_PATH option to actually find paths. This is
	  odd
	  because if you inspect CMAKE_FIND_ROOT_PATH it appears to be
	  empty. I
	  would expect it to have no effect at all.
	  
	  I also needed to remove quotes from this line in order for
	  headers to be found:
	  
	  set(FREETYPE_INCLUDE_DIRS "${FREETYPE_DIR}/include
	  ${FREETYPE_DIR}/include/freetype/config")
	  
	  Assuming this script worked in the past, it seems like cmake
	  behavior
	  may have changed at some point. I'm using cmake version
	  2.8.12.2."

2015-07-31 13:44  robert

	* src/osg/GLExtensions.cpp: From Jannik Heller, "Here is a patch
	  for the S3TC capability check.
	  
	  On a Intel HD graphics Linux system with Mesa 10.1.3, I found
	  that osg's Extensions::isTextureCompressionS3TCSupported()
	  returned false, even though S3TC compressed textures *are* in
	  fact working. I tested this by loading and rendering various
	  DXT1, DXT3 and DXT5 compressed textures in the OSG.
	  
	  "glxinfo | grep s3tc" gives:
	  GL_S3_s3tc
	  
	  Note, if I install the package "libtxc-dxtn-s2tc0", I get in
	  addition:
	  
	  glxinfo | grep s3tc
	  GL_EXT_texture_compression_s3tc
	  GL_S3_s3tc
	  
	  However, S3TC compressed textures worked correctly within the OSG
	  even without libtxc-dxtn-s2tc0 installed.
	  
	  I'm not sure what the differences between these extensions are,
	  but based on the description at
	  https://www.opengl.org/registry/specs/S3/s3tc.txt I would assume
	  that both will work for OSG's purposes. The attached patch
	  changes isTextureCompressionS3TCSupported() to accept either
	  extension."

2015-07-31 10:59  robert

	* include/osgText/Text: Warning fix

2015-07-31 10:54  robert

	* src/osg/Image.cpp, src/osgPlugins/3ds/ReaderWriter3DS.cpp,
	  src/osgPlugins/lua/LuaScriptEngine.cpp,
	  src/osgViewer/ViewerEventHandlers.cpp: From Kristofer Tingdahl,
	  warning fixes.

2015-07-31 10:27  robert

	* src/osg/GL.in: Compile fix for Mingw.

2015-07-23 15:46  robert

	* examples/osganalysis/osganalysis.cpp,
	  examples/osgcatch/osgcatch.cpp,
	  examples/osggraphicscost/osggraphicscost.cpp,
	  examples/osgmotionblur/osgmotionblur.cpp,
	  examples/osgshaderterrain/osgshaderterrain.cpp,
	  examples/osgtext/osgtext.cpp,
	  examples/osgthreadedterrain/osgthreadedterrain.cpp,
	  examples/osgvolume/osgvolume.cpp, include/osg/GraphicsThread,
	  include/osg/OperationThread, src/osg/GraphicsThread.cpp,
	  src/osg/OperationThread.cpp, src/osgUtil/GLObjectsVisitor.cpp,
	  src/osgUtil/IncrementalCompileOperation.cpp,
	  src/osgUtil/RenderStage.cpp, src/osgViewer/Renderer.cpp: Added
	  explicit initialization of osg::Referenced(true) to
	  osg::Operation subclasses as it uses virtual inhertiance from
	  osg::Referenced.

2015-07-23 14:37  robert

	* include/osg/Types, include/osgViewer/ViewerBase: From Pjotr
	  Svetachov, buid fixes for VS2015.

2015-07-23 14:31  robert

	* src/osgPlugins/osc/osc/OscOutboundPacketStream.cpp: Merged VS2013
	  warning fixes from OSG-3.4 branch

2015-07-23 11:11  robert

	* examples/osgSSBO/osgSSBO.cpp, examples/osgcluster/osgcluster.cpp,
	  examples/osggpucull/AggregateGeometryVisitor.h,
	  examples/osgoit/DepthPeeling.cpp, examples/osgoit/DepthPeeling.h,
	  examples/osgparticleeffects/osgparticleeffects.cpp,
	  examples/osgshadow/osgshadow.cpp,
	  examples/osgspotlight/osgspotlight.cpp,
	  examples/osgwidgetnotebook/osgwidgetnotebook.cpp,
	  src/osg/glu/libutil/mipmap.cpp, src/osgDB/ConvertBase64.cpp,
	  src/osgPlugins/3ds/WriterNodeVisitor.cpp,
	  src/osgPlugins/OpenFlight/FltExportVisitor.cpp,
	  src/osgPlugins/OpenFlight/LightSourcePaletteManager.cpp,
	  src/osgPlugins/OpenFlight/LightSourcePaletteManager.h,
	  src/osgPlugins/OpenFlight/PrimaryRecords.cpp,
	  src/osgPlugins/OpenFlight/expPrimaryRecords.cpp,
	  src/osgPlugins/freetype/FreeTypeLibrary.cpp,
	  src/osgPlugins/osc/OscReceivingDevice.cpp,
	  src/osgPlugins/osc/osc/OscHostEndianness.h,
	  src/osgPlugins/osga/OSGA_Archive.h,
	  src/osgShadow/ConvexPolyhedron.cpp,
	  src/osgShadow/DebugShadowMap.cpp,
	  src/osgShadow/OccluderGeometry.cpp, src/osgShadow/ShadowMap.cpp,
	  src/osgSim/SphereSegment.cpp,
	  src/osgUtil/DelaunayTriangulator.cpp, src/osgUtil/Optimizer.cpp,
	  src/osgUtil/SceneView.cpp, src/osgViewer/View.cpp,
	  src/osgWrappers/deprecated-dotosg/osg/NodeCallback.cpp: Warning
	  fixes for Clang-3.6

2015-07-23 09:23  robert

	* src/osgFX/BumpMapping.cpp, src/osgFX/Cartoon.cpp: Added missing
	  handling of lightnumber and associate lights

2015-07-23 07:39  robert

	* src/osg/GL.in: Changed the GL_HEADER_HAS_GLINT64 and
	  GL_HEADER_HAS_GLUINT64 to use cmakedefine to improve handling of
	  when cmake doesn't find GLint64 and GLuint64.

2015-07-22 17:01  robert

	* AUTHORS.txt, applications/osgversion/Contributors.cpp: Fixed
	  AUTHORS file

2015-07-22 14:55  robert

	* applications/osgversion/Contributors.cpp: Fixed contributors list

2015-07-22 14:52  robert

	* ChangeLog: Updated ChangeLog

2015-07-22 14:03  robert

	* include/osg/AlphaFunc, include/osg/GLDefines: Moved GL_ALPHA_TEST
	  from AlphaFunc header to GLDefines header

2015-07-22 13:49  robert

	* CMakeLists.txt, src/osg/GL.in: Added CMake test for presence of
	  GLuint64 and GLint64 in OpenGL/GLES headers to better handle
	  when/where GL defines the 64 bit typedefs

2015-07-21 14:21  robert

	* src/osgPlugins/OpenFlight/PaletteRecords.cpp: Added check for
	  validity of OpenFlight shininess value.

2015-07-21 13:42  robert

	* include/osg/BoundsChecking: Fixed typo

2015-07-20 13:23  robert

	* src/osgViewer/CompositeViewer.cpp, src/osgViewer/Viewer.cpp:
	  Reduced debug message verbosity.

2015-07-20 07:42  robert

	* src/osgPlugins/osgjs/json_stream: Changed the _MSC_VER check to
	  <= 1700 to support VS2012.

2015-07-19 09:51  robert

	* src/osgPlugins/tiff/ReaderWriterTIFF.cpp: Reinstated the
	  TIFFSetField(image, TIFFTAG_ROWSPERSTRIP, rowsperstrip);

2015-07-17 18:31  robert

	* CMakeModules/FindGStreamer.cmake: From KOS, "'ve mentioned in the
	  "osg-users" ML about build error with the newest GStreamer 1.5
	  
	  Please, have a look at the attached patch.
	  
	  CMakeModules/FindGStreamer.cmake"

2015-07-17 09:04  robert

	* AUTHORS.txt, ChangeLog: Updated ChangeLog and AUTHORS

2015-07-17 08:21  robert

	* CMakeLists.txt: Added cmake version check to cmake_policy usage

2015-07-17 08:12  robert

	* src/osgPlugins/tiff/ReaderWriterTIFF.cpp: From Patrick Neary, "To
	  the tiff plugin, add the capability to write tiff images with
	  unsigned short data"

2015-07-16 19:17  robert

	* src/osg/Image.cpp: From Patrick Neary, "Added some lesser used
	  tokens that we use from GL_ARB_texture_rg to
	  computeFormatDataType(), and computeNumComponents() in
	  src/osg/Image.cpp"

2015-07-16 16:06  robert

	* AUTHORS.txt, ChangeLog: Updated ChangeLog and AUTHORS

2015-07-16 15:49  robert

	* src/osgQt/GraphicsWindowQt.cpp: From Cory Slep and Robert
	  Osfield, "When using Open Scene Graph and Qt on Android, the
	  resulting thread that an application developer’s Q*Application is
	  run on is different than what Qt considers the “main” thread,
	  which can cause subtle problems. This is because Qt loads native
	  libraries in one thread, and later runs the application in a
	  different thread. They delay running in the second thread as long
	  as possible as they have a nontrivial bootstrapping process. The
	  motivation for Qt having this second thread is to allow them to
	  remain responsive to both Java and native events, and capture
	  events that would otherwise be “missed”.
	  
	  
	  
	  This gives arise to the requirement that a static initialization
	  of a QObject cannot occur for the Android platform, as Qt
	  incorrectly considers that first thread the “main” one before a
	  client application has even begun executing in its second thread.
	  
	  
	  
	  The HeartBeat in GraphicsWindowQt.cpp is a QObject static global
	  initialized at load time, causing the above issue. This changeset
	  changes it to be a singleton that is constructed upon first
	  access to its “instance” method.
	  
	  
	  
	  I have:
	  
	  - added the static method “instance”,
	  
	  - moved its constructor to be private, and
	  
	  - changed the one place it is accessed to access it through the
	  “instance” method.
	  
	  "
	  
	  Changes by Robert are to adopt QPointer<HeartBeat> rather than
	  use a C pointer to ensure that the HeartBeat object will be
	  cleaned up automatically rather than leaked.

2015-07-16 11:01  robert

	* src/osgText/Text.cpp: Added check to catch cases where the
	  backdrop coordinate cache is too small for the number of contexts
	  being computed.

2015-07-15 10:00  robert

	* src/osgPlugins/ive/DataInputStream.cpp: Added initializers and
	  reverted OSX workaround from 2013.

2015-07-14 13:33  robert

	* CMakeLists.txt: Moved the cmake_policy(SET CMP0043 NEW) to work
	  for all script paths that Qt5 usage could pass through.

2015-07-14 13:26  robert

	* CMakeLists.txt: Added cmake_policy(SET CMP0043 NEW) usage when
	  compiling against Qt5 as it was causing a warning we couldn't fix
	  on the OSG side otherwise.

2015-07-14 08:42  robert

	* AUTHORS.txt, ChangeLog: Updated ChangeLog and AUTHORS.txt

2015-07-14 08:25  robert

	* src/osg/StateSet.cpp: Added _defineList into the
	  osg::StateSet::compare() implementation to address issues with
	  osgUtil::Optimizer ignoring defines.

2015-07-13 16:09  robert

	* include/osgText/Text, src/osgText/Text.cpp: Added
	  Text::GlyphQuads::release/resizeGLObjects() and handling of
	  inconsistent contextID sizes to avoid crashes when viewers and
	  scene graphs aren't initialized correctly to the right number of
	  contexts.

2015-07-13 16:03  robert

	* src/osgViewer/CompositeViewer.cpp, src/osgViewer/Viewer.cpp,
	  src/osgViewer/ViewerBase.cpp: Standardize the call to
	  setUpThreading() in CompositeViewer/Viewer::realize().
	  
	  Standardize the call to scene->resizeGLObjects().

2015-07-13 08:48  robert

	* include/osg/GLDefines: From Terry Welsh, "fThis fixes problem
	  where new glClipControl feature would not compile for GLES2
	  profile"

2015-07-03 06:51  robert

	* CMakeLists.txt: Updated version number to 3.5.0 after 3.4 branch.

2015-07-03 06:28  robert

	* README.txt: Updated for 3.4 branch.

2015-07-02 11:58  robert

	* src/osgPlugins/gdal/CMakeLists.txt: Fixed repeated name in
	  SETUP_PLUGIN.

2015-07-02 10:25  robert

	* CMakeLists.txt, ChangeLog: Updated ChangeLog and AUTHORS file in
	  prep for 3.4 branch.

2015-07-02 08:57  robert

	* src/osgPlugins/osgjs/JSON_Objects: Build fix

2015-07-02 08:52  robert

	* include/osg/GLDefines: Moved the defination of
	  GL_MAX_VARYING_COMPONENTS to GL_3_0 block to avoid warnings of
	  redefinition.

2015-07-01 05:32  robert

	* ChangeLog: Updated ChangeLog

2015-07-01 05:10  robert

	* src/osgWrappers/deprecated-dotosg/osg/ClipControl.cpp,
	  src/osgWrappers/serializers/osg/ClipControl.cpp: From Mathias
	  Froehlich, added seriliazers for new osg::ClipControl

2015-06-30 09:51  robert

	* AUTHORS.txt, ChangeLog: Updated ChangeLog and AUTHORS files

2015-06-30 09:11  robert

	* include/osg/ClipControl, include/osg/GLExtensions,
	  include/osg/StateAttribute, src/osg/CMakeLists.txt,
	  src/osg/ClipControl.cpp, src/osg/GLExtensions.cpp: From Mathias
	  Froehlich, "Attached a new state attribute implementing the
	  glClipControl that appeared with GL4.5."

2015-06-30 08:39  robert

	* src/osgViewer/Viewer.cpp: Quitened down debug for ViewConfig
	  argument parsing

2015-06-30 08:38  robert

	* src/osgPlugins/ogr/ReaderWriterOGR.cpp: Build fix for GLDAL>=2

2015-06-26 09:40  robert

	* include/osg/Vec2f: From Christian Kehl, added Vec2::set(const
	  Vec2) method

2015-06-19 09:51  robert

	* src/osgUtil/RenderStage.cpp: From Jannik Heller, fixed
	  clearReferencesToDependentCameras() calls

2015-06-17 16:25  robert

	* src/osgUtil/GLObjectsVisitor.cpp: Fixed handling of use
	  GLObjectsVisitor for modifying scene graph state without
	  compiling to OpenGL so that the visitor can be run safely without
	  a graphics context being current.

2015-06-16 17:18  robert

	* src/osgQt/CMakeLists.txt: Small tidy up to make script more
	  readable.

2015-06-16 17:17  robert

	* src/osgPlugins/qfont/CMakeLists.txt: Added QT_QTCORE_INCLUDE_DIR
	  entry to qfont plugin build to fix Qt4 build under Linux

2015-06-15 19:59  robert

	* include/osgQt/GraphicsWindowQt,
	  include/osgQt/QFontImplementation,
	  include/osgQt/QGraphicsViewAdapter, include/osgQt/QWebViewImage,
	  include/osgQt/QWidgetImage, src/osgQt/CMakeLists.txt,
	  src/osgQt/Version.in: From Jannik Heller, "I've added the check
	  for Qt version mismatches into osgQt as suggested in
	  http://forum.openscenegraph.org/viewtopic.php?t=14999.
	  
	  When an application is built with Qt4, but osgQt was built with
	  Qt5 (or vice versa), upon #includeing osgQt users will receive an
	  #error aborting the build.
	  
	  This at least provides a proper error message rather than a
	  crash, while we are working on better fixes for the problem."

2015-06-15 13:51  robert

	* include/osg/GLDefines: Experiment with how to define GLsizeiptr.

2015-06-15 13:51  robert

	* CMakeLists.txt: Upated version number

2015-06-12 20:23  robert

	* include/OpenThreads/Exports: Removed old and unused windows code
	  path to avoid confusion

2015-06-12 11:28  robert

	* ChangeLog: Updated ChangeLog

2015-06-12 08:04  robert

	* src/osgText/TextBase.cpp: From Farshid Lashkari, "I've modified
	  some setter methods of TextBase to avoid unnecessary calls to
	  computeGlyphRepresentation() if the value has not changed."

2015-06-11 08:44  robert

	* include/osg/GLDefines: Reverted the typdef GLfloat GLdouble for
	  Andoid as this was causing conflicts.

2015-06-10 18:22  robert

	* AUTHORS.txt, ChangeLog: Updated ChangeLog and AUTHORS file for
	  3.3.8 dev release

2015-06-10 16:48  robert

	* CMakeModules/FindOpenEXR.cmake: From Laurens Voerman, "attached
	  is a zip with the files:
	  
	  OpenSceneGraph\CMakeModules\FindOpenEXR.cmake
	  
	  I introduced a bug in the previous submission pointed out by
	  Dmitry Marakasov:
	  looking for IlmIlf instead of IlmImf (as the previous version did
	  - but using variable OPENEXR_IlmIlf_LIBRARY)
	  
	  For some reason google decided his message was spam, so I just
	  noticed it, and I reply to confirm his remarks and attach a full
	  file.
	  
	  "

2015-06-10 16:47  robert

	* src/osg/GLExtensions.cpp, src/osg/Texture.cpp: From Colin
	  McDonald, "An earlier fix in OSG 3.2 has been inadvertently lost
	  in 3.3.x. The glGenerateMipMap function is part of the
	  GL_EXT_framebuffer_object extension. Just checking if the
	  function is present before using it for texture mipmaps is not
	  sufficient, as on remote X-windows displays the client side
	  capability may be different from the display server. This can
	  lead to mipmapped textures failing to render. I've restored a fbo
	  extension check. I've also tided up the GL version checking a
	  little."

2015-06-10 10:00  robert

	* src/osgGA/NodeTrackerManipulator.cpp: From Philippe Renon, "Fixed
	  potential divide by zero in NodeTrackerManipulator : The divide
	  by zero happens when throwing a NodeTrackerManipulator.
	  The infinite result trickles down and later causes NaN in
	  culling.
	  
	  The fix was to use getThrowScale() as done everywhere else."

2015-06-09 16:49  robert

	* CMakeLists.txt, include/osgDB/Serializer,
	  src/osgWrappers/serializers/osg/Camera.cpp: Added supoort for
	  osg::CullSettings/Camera::InheritanceMaskActionOnAttributeSetting
	  and InheritanceMask properties.

2015-06-09 12:51  robert

	* include/osg/GLDefines: Added namespace around typedef to avoid
	  conflict issues

2015-06-09 10:49  robert

	* include/osg/Node, include/osg/NodeVisitor, include/osg/Object,
	  include/osg/StateAttribute, include/osg/Uniform,
	  src/osg/Callback.cpp: Introduce osg::Object::asNode(),
	  asNodeVisitor(), asStateAttribute() and asUniform() to replace
	  dynamic_cast<> usage in Callback.cpp.

2015-06-09 09:44  robert

	* examples/osghud/osghud.cpp: Added output of HUD scene graph to
	  hud.osgt and hud.osgb for testing purposes.

2015-06-08 11:33  robert

	* AUTHORS.txt, ChangeLog: Updated AUTHORS and ChangeLog for dev
	  release

2015-06-08 11:18  robert

	* include/osgDB/Options, src/osgDB/DatabasePager.cpp,
	  src/osgDB/Options.cpp: From Mike Connell, "Give ReadFileCallback
	  access to parent location : These small changes to the database
	  pager allow user code in the ReadFileCallback to safely determine
	  where the file being loaded is destined to be inserted into the
	  scenegraph.
	  "

2015-06-08 10:20  robert

	* src/osgUtil/SceneView.cpp: Addressed race condition where
	  SceneView::setLightingMode() was setting a shread Master Camera's
	  StateSet.

2015-06-07 11:13  robert

	* src/osgViewer/CompositeViewer.cpp, src/osgViewer/Viewer.cpp:
	  Fixed setReferenceTime() bug where a * eather than the correct /
	  was being used. Bug and fix suggested Benjamin Richter.

2015-06-04 09:35  robert

	* AUTHORS.txt, ChangeLog, applications/osgversion/Contributors.cpp:
	  Updated AUTHORS for dev release

2015-06-04 09:13  robert

	* src/osg/Transform.cpp: From Jannik Heller,
	  Transform::computeBound() optimization.

2015-06-04 09:05  robert

	* include/osgViewer/ViewerEventHandlers: From Jannik Heller,
	  Removed unused StatsHandler::_keyEventToggleVsync

2015-06-04 09:00  robert

	* include/osgAnimation/UpdateUniform: From Jannik Heller, "In the
	  attachment you will find a build fix for the latest trunk.
	  osgAnimation failed to compile when using
	  OSG_USE_REF_PTR_IMPLICIT_OUTPUT_CONVERSION=OFF ."

2015-06-03 10:28  robert

	* include/osgAnimation/UpdateUniform: Removed export that was
	  breaking windows build

2015-06-03 09:14  robert

	* include/osgAnimation/UpdateUniform,
	  src/osgAnimation/CMakeLists.txt,
	  src/osgWrappers/serializers/osgAnimation/LibraryWrapper.cpp,
	  src/osgWrappers/serializers/osgAnimation/UpdateFloatUniform.cpp,
	  src/osgWrappers/serializers/osgAnimation/UpdateMatrixfUniform.cpp,
	  src/osgWrappers/serializers/osgAnimation/UpdateVec3fUniform.cpp:
	  From KOS, "New classes for osgAnimation presented:
	  UpdateFloatUniform, UpdateVec3fUniform and UpdateMatrixfUniform
	  (based on UpdateUniform template)
	  
	  
	  Classes operate like osgAnimation::UpdateMaterial for Material's
	  diffuse component, but change Uniform."

2015-06-03 09:07  robert

	* examples/osggeometryshaders/osggeometryshaders.cpp,
	  examples/osgparametric/osgparametric.cpp,
	  examples/osgshaders/GL2Scene.cpp,
	  examples/osgsimpleshaders/osgsimpleshaders.cpp,
	  examples/osgtransformfeedback/osgtransformfeedback.cpp: From KOS,
	  build fix for osg::Uniform::Callback to osg::UniformCallback
	  change

2015-06-03 09:06  robert

	* include/osg/Uniform: Added doxygen comment for typedef

2015-06-03 08:38  robert

	* src/osgWrappers/serializers/osg/Uniform.cpp: Build fix for when
	  Uniform::Callback isn't defined

2015-06-02 10:25  robert

	* src/osgWrappers/serializers/osg/UniformCallback.cpp: From
	  Konstantin Matveyev, serializer support for UniformCallback

2015-06-02 09:33  robert

	* include/osg/Callback, include/osg/CopyOp, include/osg/Uniform,
	  src/osg/Callback.cpp, src/osg/CopyOp.cpp, src/osg/StateSet.cpp,
	  src/osg/Uniform.cpp,
	  src/osgWrappers/deprecated-dotosg/osg/Uniform.cpp,
	  src/osgWrappers/serializers/osg/LibraryWrapper.cpp: From
	  Konstantin Matveyev, "I've changed osg::Uniform::Callback to
	  osg::UniformCallback.
	  osg::UniformCallback inherits osg::Callback now.
	  
	  I don't really now if this class should be inside
	  osgWrappers/serializers
	  because StateAttributeCallback is not presented there, but i've
	  included it in the patch.
	  
	  
	  Please see archive in the attachment.
	  
	  
	  PS
	  DEEP_COPY_UNIFORMS works for me.
	  "
	  Note from Robert Osfield, added typedef UniformCallback Callback
	  for backwards compatibility.

2015-06-02 09:18  robert

	* examples/osguniformbuffer/osguniformbuffer.cpp: Changed name of
	  UniformCallback to UniformBufferCallback to avoid conflict with
	  changes to come to the osg::Uniform::Callback ->
	  osg::UniformCallback.

2015-06-01 13:40  robert

	* include/OpenThreads/Thread, include/osg/BoundsChecking,
	  include/osg/Geometry, include/osg/Image, include/osg/ImageUtils,
	  include/osg/Object, include/osg/TransferFunction,
	  include/osg/observer_ptr, include/osg/ref_ptr,
	  include/osgDB/ClassInterface, include/osgDB/ExternalFileWriter,
	  include/osgDB/ReaderWriter, include/osgGA/GUIActionAdapter,
	  include/osgManipulator/Dragger,
	  include/osgParticle/ConnectedParticleSystem,
	  include/osgShadow/ViewDependentShadowTechnique,
	  include/osgTerrain/TerrainTile, include/osgText/Glyph,
	  include/osgUI/Widget, include/osgUtil/SceneGraphBuilder,
	  include/osgWidget/Widget,
	  src/OpenThreads/pthreads/PThreadBarrier.cpp,
	  src/OpenThreads/pthreads/PThreadMutex.cpp,
	  src/OpenThreads/win32/Win32Thread.cpp, src/osg/ImageUtils.cpp,
	  src/osg/Sequence.cpp, src/osg/ShadowVolumeOccluder.cpp,
	  src/osg/TexGen.cpp, src/osg/Texture1D.cpp, src/osg/Texture2D.cpp,
	  src/osg/Texture2DArray.cpp, src/osg/Texture3D.cpp,
	  src/osg/TextureCubeMap.cpp, src/osg/TextureRectangle.cpp,
	  src/osg/Uniform.cpp, src/osgAnimation/RigGeometry.cpp,
	  src/osgDB/DynamicLibrary.cpp, src/osgDB/FileNameUtils.cpp,
	  src/osgDB/FileUtils.cpp, src/osgDB/Registry.cpp,
	  src/osgDB/XmlParser.cpp, src/osgManipulator/Dragger.cpp,
	  src/osgPlugins/3ds/ReaderWriter3DS.cpp,
	  src/osgPlugins/Inventor/ConvertFromInventor.cpp,
	  src/osgPlugins/Inventor/ConvertToInventor.cpp,
	  src/osgPlugins/QTKit/OSXCoreVideoTexture.cpp,
	  src/osgPlugins/ac/ac3d.cpp,
	  src/osgPlugins/avfoundation/OSXAVFoundationCoreVideoTexture.cpp,
	  src/osgPlugins/cfg/VisualChooser.cpp,
	  src/osgPlugins/curl/ReaderWriterCURL.cpp,
	  src/osgPlugins/dae/ReaderWriterDAE.cpp,
	  src/osgPlugins/dae/daeRGeometry.cpp,
	  src/osgPlugins/dae/daeRMaterials.cpp,
	  src/osgPlugins/dae/daeReader.cpp,
	  src/osgPlugins/dds/ReaderWriterDDS.cpp,
	  src/osgPlugins/directshow/DirectShowTexture.cpp,
	  src/osgPlugins/dxf/DXFWriterNodeVisitor.cpp,
	  src/osgPlugins/ffmpeg/FFmpegDecoderAudio.cpp,
	  src/osgPlugins/gif/ReaderWriterGIF.cpp,
	  src/osgPlugins/gles/ReaderWriterGLES.cpp,
	  src/osgPlugins/ive/Material.cpp,
	  src/osgPlugins/jpeg/EXIF_Orientation.cpp,
	  src/osgPlugins/ktx/ReaderWriterKTX.cpp,
	  src/osgPlugins/las/ReaderWriterLAS.cpp,
	  src/osgPlugins/logo/ReaderWriterLOGO.cpp,
	  src/osgPlugins/lwo/Object.cpp,
	  src/osgPlugins/lwo/ReaderWriterLWO.cpp,
	  src/osgPlugins/ply/plyfile.cpp,
	  src/osgPlugins/ply/vertexData.cpp,
	  src/osgPlugins/pov/POVWriterNodeVisitor.cpp,
	  src/osgPlugins/quicktime/ReaderWriterQT.cpp,
	  src/osgPlugins/tiff/ReaderWriterTIFF.cpp,
	  src/osgPlugins/trans/ReaderWriterTRANS.cpp,
	  src/osgPlugins/txf/TXFFont.cpp,
	  src/osgPlugins/txp/TXPPagedLOD.cpp,
	  src/osgPlugins/txp/TileMapper.cpp,
	  src/osgPlugins/txp/trpage_geom.cpp,
	  src/osgPlugins/txp/trpage_readbuf.cpp,
	  src/osgPlugins/txp/trpage_warchive.cpp,
	  src/osgPlugins/zip/unzip.cpp,
	  src/osgPresentation/KeyEventHandler.cpp,
	  src/osgPresentation/PickEventHandler.cpp,
	  src/osgPresentation/SlideEventHandler.cpp,
	  src/osgShadow/ConvexPolyhedron.cpp,
	  src/osgShadow/MinimalShadowMap.cpp, src/osgShadow/ShadowMap.cpp,
	  src/osgShadow/StandardShadowMap.cpp,
	  src/osgShadow/ViewDependentShadowMap.cpp,
	  src/osgSim/InsertImpostorsVisitor.cpp, src/osgSim/Sector.cpp,
	  src/osgText/GlyphGeometry.cpp, src/osgText/TextBase.cpp,
	  src/osgUtil/DelaunayTriangulator.cpp, src/osgUtil/Optimizer.cpp,
	  src/osgUtil/RenderStage.cpp, src/osgUtil/Simplifier.cpp,
	  src/osgViewer/CompositeViewer.cpp,
	  src/osgViewer/GraphicsWindowWin32.cpp,
	  src/osgViewer/GraphicsWindowX11.cpp, src/osgViewer/Viewer.cpp,
	  src/osgWidget/Box.cpp, src/osgWidget/StyleManager.cpp,
	  src/osgWidget/Window.cpp: From Albert Luaces, typo fixes.

2015-06-01 13:11  robert

	* CMakeModules/FindSDL2.cmake,
	  applications/present3D/present3D.cpp,
	  examples/osgcluster/osgcluster.cpp,
	  examples/osgdepthpeeling/DePee.h,
	  examples/osgmultitexturecontrol/osgmultitexturecontrol.cpp,
	  examples/osgparticleeffects/osgparticleeffects.cpp,
	  examples/osgscribe/osgscribe.cpp,
	  examples/osgtexture2D/osgtexture2D.cpp,
	  examples/osgunittests/UnitTestFramework.h,
	  examples/osgvolume/osgvolume.cpp, include/osg/GraphicsContext,
	  include/osg/StateAttribute, include/osg/Texture2DArray,
	  include/osg/Texture3D, include/osg/TextureCubeMap,
	  include/osg/Timer, include/osg/TransferFunction,
	  include/osg/Uniform, include/osgAnimation/RigTransformSoftware,
	  include/osgDB/DatabasePager, include/osgDB/ExternalFileWriter,
	  include/osgDB/Registry, include/osgSim/ScalarBar,
	  include/osgViewer/View, src/osg/BufferObject.cpp,
	  src/osg/GraphicsContext.cpp, src/osg/Notify.cpp,
	  src/osg/OperationThread.cpp, src/osg/Texture.cpp,
	  src/osg/dxtctool.h, src/osgDB/FileUtils.cpp,
	  src/osgDB/ImagePager.cpp, src/osgGA/StateSetManipulator.cpp,
	  src/osgPlugins/3ds/ReaderWriter3DS.cpp,
	  src/osgPlugins/ac/ac3d.cpp, src/osgPlugins/cfg/RenderSurface.h,
	  src/osgPlugins/zip/unzip.cpp, src/osgPresentation/Timeout.cpp,
	  src/osgUtil/CullVisitor.cpp, src/osgUtil/IntersectVisitor.cpp,
	  src/osgUtil/RenderBin.cpp, src/osgUtil/SceneView.cpp: From Jannik
	  Heller, typo fixes

2015-06-01 12:14  robert

	* src/osgParticle/ParticleProcessor.cpp: From Jannik Heller, "This
	  patch adds a missing initialization of
	  osgParticle::ParticleProcessor::_frameNumber in the copy
	  constructor.
	  I noticed this because valgrind was complaining about use of
	  uninitialized memory."

2015-06-01 12:07  robert

	* include/osgDB/ObjectWrapper, src/osgDB/ObjectWrapper.cpp: From
	  Frashud Lashkari, "I was getting "Unsupported wrapper class..."
	  error messages when attempting to load osgb models simultaneously
	  from multiple threads. I believe the problem is caused by
	  un-synchronized access to the global osgDB::ObjectWrapperManager
	  class. I've attached a change that adds a mutex to the class and
	  uses it when accessing the internal wrapper/compress maps. This
	  appears to fix the issues I was having."

2015-06-01 10:50  robert

	* include/osg/Texture, include/osg/Texture2D, src/osg/Texture.cpp,
	  src/osg/Texture1D.cpp, src/osg/Texture2D.cpp,
	  src/osg/Texture2DArray.cpp, src/osg/Texture2DMultisample.cpp,
	  src/osg/Texture3D.cpp, src/osg/TextureBuffer.cpp,
	  src/osg/TextureCubeMap.cpp, src/osg/TextureRectangle.cpp,
	  src/osgText/Glyph.cpp: From Jannik Heller, "I have added new
	  functions Texture::generateAndAssignTextureObject mirroring the
	  Texture::generateTextureObject functions.
	  
	  I have left the Texture::generateTextureObject functions intact
	  as I'm not sure if/how it's used outside the core OSG. If you
	  feel that compatibility isn't important in that area feel free to
	  drop it.
	  
	  While testing the build with
	  OSG_USE_REF_PTR_IMPLICIT_OUTPUT_CONVERSION=OFF I found a compile
	  error in GlyphGeometry.cpp that was entirely unrelated to the
	  changes I've made. The fix is included in the patch.
	  
	  There is one thing left to fix and that is
	  Texture2D::SubloadCallback:
	  
	  class OSG_EXPORT SubloadCallback : public Referenced
	  {
	  public:
	  ....
	  virtual TextureObject* generateTextureObject(const Texture2D&
	  texture, State& state) const
	  {
	  return osg::Texture::generateTextureObject(&texture,
	  state.getContextID(), GL_TEXTURE_2D);
	  }
	  ...
	  }"
	  

2015-06-01 10:41  robert

	* src/osgText/GlyphGeometry.cpp: From Jannik Heller, build fix

2015-05-29 07:52  robert

	* include/osg/BufferObject, src/osg/BufferObject.cpp: From Jannik
	  Heller, fix for race condition in orphanded BufferObject
	  handling.

2015-05-26 17:24  robert

	* src/osgUtil/MeshOptimizers.cpp: From Colin McDonald,
	  "rc/osgUtl/MeshOptimizers.cpp won't compile on some systems due
	  to a missing std:: namespace prefix."

2015-05-26 17:22  robert

	* src/osgUtil/SceneView.cpp: From Farshid Lashkari, "attached a
	  small change to osgUtil::SceneView that prevents unnecessary
	  calls to glClear when the split stereo separation is 0."

2015-05-26 17:17  robert

	* src/osgDB/ClassInterface.cpp: From Thomas Hogarth, "Little fix
	  for ClassInterface::getSupportedProperties, before if you set
	  searchAssociates to false then it would return the same
	  BaseSerialiser::Type for every entry in the PropertyMap as i was
	  not being incremented on line 539. Fix attached."

2015-05-26 17:12  robert

	* src/osgUtil/RenderStage.cpp: From We See, "I found a small bug in
	  osgUtil::RenderStage::draw() (osg 3.3.7), which crashes osg. The
	  problem was caused by an access to the object _camera without
	  checking whether the object is valid. So I changed the line:
	  
	  Code:
	  if (_cameraRequiresSetUp ||
	  (_cameraAttachmentMapModifiedCount!=_camera->getAttachmentMapModifiedCount()))
	  
	  to
	  
	  Code:
	  if (_cameraRequiresSetUp || (_camera.valid() &&
	  _cameraAttachmentMapModifiedCount!=_camera->getAttachmentMapModifiedCount()))
	  "

2015-05-26 17:09  robert

	* src/osgUtil/CullVisitor.cpp: From Farshid Lashkari and Robert
	  Osfield, "a small change to the CullVisitor class, which will use
	  cloneType() on the root render stage when creating children
	  render stages. This allows us to pass a custom RenderStage object
	  to the SceneView and have it used for all sub-stages."

2015-05-26 10:05  robert

	* examples/osgtext3D/TextNode.cpp,
	  examples/osgtext3D/osgtext3D.cpp, include/osgText/Style,
	  src/osgText/Glyph.cpp, src/osgText/GlyphGeometry.cpp,
	  src/osgText/GlyphGeometry.h, src/osgText/Style.cpp: Rewrote the
	  Text3D bevel implementation to automatically adjust bevel
	  thickness to avoid overalapping and erronous tesselation.
	  
	  Added osgText::Bevel::s/getRoundedConcaveJunctions(bool) to
	  control how the bevel should be tessellated around concave
	  junctions on the glyph boundary.

2015-05-26 08:48  robert

	* src/osgViewer/CompositeViewer.cpp, src/osgViewer/Viewer.cpp:
	  Added use of ref_ptr<>

2015-05-25 12:39  robert

	* src/osgViewer/CompositeViewer.cpp, src/osgViewer/Viewer.cpp:
	  Changed the EventQueue::frame() event generation to use the
	  generatePointerData/reprojectPointerData() methods in the same
	  way that other events are handled.

2015-05-25 11:33  robert

	* include/osgGA/EventQueue, src/osgGA/EventQueue.cpp: Added
	  osgGA::GUIEventAdapter* returns from various EventQueue event
	  generation methods.

2015-05-21 14:11  robert

	* src/osgText/Text3D.cpp: Fixed memory error associated with
	  reading over the end of container due to an unbounded while loop.

2015-05-06 18:39  robert

	* AUTHORS.txt, ChangeLog, applications/osgversion/Contributors.cpp:
	  Update ChangeLog and AUTHORS file

2015-05-05 11:05  robert

	* CMakeLists.txt: Changed the CMP0020 check to > 2.8.10
	  Updated SO version number

2015-04-30 14:04  robert

	* include/osg/GLDefines: From Christian Kehl, changes for making
	  osgAndroid working with GLES1 enabled

2015-04-30 13:59  robert

	* src/osgViewer/GraphicsWindowWin32.cpp: From Dmitriy Ogalcev, fix
	  for crash when calling setCursor from a non GUI thread

2015-04-28 16:12  robert

	* include/osgShadow/MinimalShadowMap,
	  src/osgShadow/MinimalShadowMap.cpp: Replaced attempt at passing
	  NULL Matrix with two specialized methods.

2015-04-27 19:31  robert

	* include/osg/LineSegment, src/osg/LineSegment.cpp: Renamed
	  LineSegment::intersect(BoundingSphere/Box, double/float&,
	  double/float&) methods to
	  LineSegment::intersectAndComputeRations(..) to avoid confusion
	  with the change in convention for
	  the old intersect(BoundingBox&, float/double&, float/double&)
	  method as it was inconsitent with the rest of the OSG including
	  the intersect(BoundingSphere) method in how the ratio for the
	  second intersection was measure from - original from the end
	  point, but now made consistent with other places in the OSG so be
	  based on ration from start to end of segment.

2015-04-23 14:44  robert

	* src/osgText/GlyphGeometry.cpp: Refactoring GlyphGeometry Boundary
	  class to facilate better bevel overlap detection

2015-04-23 12:58  robert

	* examples/osgtext/osgtext.cpp: Comment out debug notification

2015-04-23 09:49  robert

	* src/osgText/GlyphGeometry.cpp: Removed unused method

2015-04-22 14:25  robert

	* src/osgPlugins/3ds/ReaderWriter3DS.cpp: From Giampaolo Vigano,
	  "please find attached a further fix for 3ds plugin: now
	  reflection map works also with transparent objects (I also
	  removed a redundant setting of BlendFunc)."

2015-04-21 17:29  robert

	* src/osgPlugins/3ds/ReaderWriter3DS.cpp,
	  src/osgPlugins/3ds/lib3ds/lib3ds_util.c: From Chris Denham, "I
	  found a couple of memory leaks in 3DS reader plugin and I have
	  attached corrected files. I have attached an example 3DS file I
	  used to test the leaks/fixes using osgviewer for trunk at rev
	  [14853] and the tagged version 3.2.1.
	  
	  The first leak is in the lib3ds module (yeah, I know that
	  probably should be corrected at http://code.google.com/p/lib3ds/
	  but I'm assuming that as no commits have happened there since
	  2011 that it may be better to fix the copy we have in the OSG of
	  that project) The leak is caused by lib3d's use of realloc(ptr,
	  0) to free up memory allocations, but realloc, when ptr==NULL
	  returns malloc(0) rather than NULL and thus leaks a zero byte
	  allocation. The solution here was to adjust the
	  'lib3ds_util_reserve_array' function so that it realloc is not
	  used to release a NULL pointer.
	  
	  The second leak is in ReaderWriter3DS.cpp and arises when any of
	  the created StateSet objects added to the StateSetMap don't
	  subsequently get applied to a Node. The solution here was just to
	  simply use the osg::ref_ptr around the raw StateSet pointer that
	  was used in the locally defined StateSetInfo struct."

2015-04-20 10:41  robert

	* AUTHORS.txt, ChangeLog, applications/osgversion/Contributors.cpp:
	  Updated AUTHORS

2015-04-20 10:36  robert

	* examples/osgmanipulator/osgmanipulator.cpp: Build fix

2015-04-20 10:19  robert

	* src/osgPlugins/3ds/ReaderWriter3DS.cpp: Build fix

2015-04-20 09:39  robert

	* src/osg/State.cpp: Moved uniform substitution to infront of
	  vertex attribute substituion to make sure gl_Vertex usage is
	  replaced when required.

2015-04-20 09:08  robert

	* include/osgUtil/MeshOptimizers: From Tim Moore, "The
	  order_by_primitive_mode comparer was not providing a strict weak
	  ordering, which was causing a crash in the sort() call in
	  VertexAccessOrderVisitor::optimizeOrder (gcc 4.9, Fedora 21)."

2015-04-17 14:36  robert

	* CMakeLists.txt: Updated dev release number

2015-04-17 13:33  robert

	* include/osgManipulator/AntiSquish: Added implementations for the
	  libraryName and className for the AntiSquish node.

2015-04-17 13:24  robert

	* src/osg/Node.cpp: Fixed CollectParentPaths visitor so that it
	  sets the setNodeMaskOverride(0xffffffff) to make sure all parents
	  are traversed to find parents, even ones that have their NodeMask
	  set to 0x0.

2015-04-17 13:22  robert

	* examples/osgmanipulator/osgmanipulator.cpp: Added --test-NodeMask
	  option to test crash when a parent of osgmanipulator::AntiSquish
	  node has a NodeMask set to 0x0.

2015-04-16 11:19  robert

	* src/osgPlugins/osgjs/json_stream: Changed MSVC version test to <=
	  to enable fallback for VS2010.

2015-04-16 10:07  robert

	* src/osgManipulator/AntiSquish.cpp: Fixed crash when AntiSquish
	  node is the root of the scene graph.

2015-04-15 18:34  robert

	* ChangeLog: Updated ChangeLog

2015-04-15 18:05  robert

	* CMakeLists.txt: Updated version number of dev release

2015-04-15 17:12  robert

	* src/osgPlugins/gles/LineIndexFunctor: Added missing const to find
	  VS2005 build

2015-04-14 18:16  robert

	* src/osgViewer/GraphicsWindowWin32.cpp: Added check for changes to
	  window size during GraphicsWindowWin32::init() to fix bug that
	  occurs when the window manage resizes the window automatically on
	  creation.

2015-04-14 15:50  robert

	* src/osgPlugins/osgjs/JSON_Objects: From Philippe Renon, MingW
	  build fix

2015-04-13 11:48  robert

	* examples/osgprerender/osgprerender.cpp,
	  examples/osgprerendercubemap/osgprerendercubemap.cpp,
	  include/osg/Camera, src/osgSim/ElevationSlice.cpp,
	  src/osgUtil/RenderStage.cpp,
	  src/osgWrappers/deprecated-dotosg/osg/Camera.cpp,
	  src/osgWrappers/serializers/osg/Camera.cpp: Fixed typo of
	  SEPARATE enums

2015-04-13 10:43  robert

	* CMakeModules/FindFFmpeg.cmake, CMakeModules/OsgMacroUtils.cmake,
	  applications/osgconv/osgconv.cpp,
	  applications/osgversion/osgversion.cpp,
	  applications/present3D/Cluster.cpp,
	  applications/present3D/present3D.cpp,
	  examples/osg2cpp/osg2cpp.cpp,
	  examples/osganimationsolid/osganimationsolid.cpp,
	  examples/osganimationtimeline/osganimationtimeline.cpp,
	  examples/osgautocapture/osgautocapture.cpp,
	  examples/osgbillboard/osgbillboard.cpp,
	  examples/osgcamera/osgcamera.cpp, examples/osgclip/osgclip.cpp,
	  examples/osgcopy/osgcopy.cpp,
	  examples/osgdistortion/osgdistortion.cpp,
	  examples/osggeometry/osggeometry.cpp,
	  examples/osgparticleshader/osgparticleshader.cpp,
	  examples/osgreflect/osgreflect.cpp,
	  examples/osgshadercomposition/osgshadercomposition.cpp,
	  examples/osgtexture2DArray/osgtexture2DArray.cpp,
	  examples/osgtexture3D/osgtexture3D.cpp,
	  examples/osgwindows/osgwindows.cpp, include/OpenThreads/Thread,
	  include/osg/Billboard, include/osg/BoundingSphere,
	  include/osg/BufferIndexBinding, include/osg/BufferTemplate,
	  include/osg/ImageSequence, include/osg/ScriptEngine,
	  include/osg/Shader, include/osg/Shape, include/osg/State,
	  include/osg/StateSet, include/osg/ValueObject,
	  include/osgAnimation/Action, include/osgAnimation/RigGeometry,
	  include/osgDB/Callbacks, include/osgManipulator/Dragger,
	  include/osgPresentation/SlideEventHandler,
	  include/osgShadow/OccluderGeometry,
	  include/osgShadow/ViewDependentShadowMap,
	  include/osgUtil/Optimizer, include/osgWidget/EventInterface,
	  src/OpenThreads/pthreads/PThreadBarrierPrivateData.h,
	  src/osg/Referenced.cpp, src/osg/Shader.cpp, src/osg/State.cpp,
	  src/osg/Uniform.cpp, src/osgGA/CameraManipulator.cpp,
	  src/osgPlugins/txp/trpage_geom.h,
	  src/osgPlugins/txp/trpage_pparse.cpp,
	  src/osgPlugins/txp/trpage_write.h,
	  src/osgPresentation/SlideEventHandler.cpp,
	  src/osgShadow/ConvexPolyhedron.cpp,
	  src/osgShadow/DebugShadowMap.cpp,
	  src/osgShadow/ShadowTechnique.cpp,
	  src/osgShadow/ShadowVolume.cpp,
	  src/osgShadow/ViewDependentShadowMap.cpp, src/osgViewer/View.cpp,
	  src/osgWrappers/serializers/osgManipulator/Dragger.cpp: From
	  Jannik Heller, typo fixes

2015-04-13 10:11  robert

	* CMakeLists.txt, README.txt, src/osg/GL.in,
	  src/osgPlugins/imageio/ReaderWriterImageIO.cpp,
	  src/osgViewer/GraphicsWindowIOS.mm: From Konstantin Matveyev,
	  "I've added GLES3 profile, which also enables GLES2 features
	  (OSG_GLES3_AVAILABLE=true => OSG_GLES2_AVAILABLE=true).
	  
	  If OSG_OPENGL_PROFILE="GLES3" =>
	  GraphicsWindowIOS will create gles3 context.
	  If failed, GraphicsWindowIOS will create gles2 context.
	  Multisampling also working.
	  
	  "

2015-04-13 09:50  robert

	* CMakeModules/FindOpenEXR.cmake,
	  src/osgPlugins/exr/CMakeLists.txt: From Laurens Voerman, I have
	  modified the FindOpenEXR.cmake to find the debug libraries, and
	  to define a variable
	  (OPENEXR_LIBRARIES_VARS) with the variable names that might have
	  a _DEBUG version defined.

2015-04-13 08:55  robert

	* examples/osgmanipulator/osgmanipulator.cpp: Added passing of
	  command line arguments to viewer construction to allow one to
	  specify extra controls for the viewer such as window size etc.

2015-04-09 18:42  robert

	* include/osgManipulator/AntiSquish,
	  src/osgManipulator/AntiSquish.cpp: Refactored
	  AntiSquish::computeUnSquishedMatrix() method to use the parent
	  node path of the AntiSquish node
	  to compute the required matrix rather than using the NodePath
	  provided by the NodeVistor. This is required
	  as in osg::computeLocalToWorld() usage case the NodeVisitor
	  pointer is NULL, so the correct matrix isn't possible to compute.

2015-04-09 18:38  robert

	* examples/osgmanipulator/osgmanipulator.cpp: Added
	  WindowSizeHandler to osgmanipulator example

2015-04-07 18:01  robert

	* applications/present3D/present3D.cpp,
	  examples/osgclip/osgclip.cpp,
	  examples/osgkeystone/osgkeystone.cpp,
	  examples/osgmemorytest/osgmemorytest.cpp,
	  examples/osgocclusionquery/osgocclusionquery.cpp,
	  examples/osgposter/PosterPrinter.cpp,
	  examples/osgshadercomposition/oldshadercomposition.cpp,
	  examples/osgshadercomposition/osgshadercomposition.cpp,
	  examples/osgtexture1D/osgtexture1D.cpp,
	  examples/osgtexture2D/osgtexture2D.cpp,
	  examples/osgtexture3D/osgtexture3D.cpp,
	  examples/osgtransferfunction/osgtransferfunction.cpp,
	  include/OpenThreads/Thread, include/osg/Array,
	  include/osg/Callback, include/osg/Camera,
	  include/osg/CullSettings, include/osg/CullingSet,
	  include/osg/DisplaySettings, include/osg/GLU,
	  include/osg/GraphicsContext, include/osg/Image,
	  include/osg/ImageUtils, include/osg/Object, include/osg/State,
	  include/osg/UserDataContainer, include/osg/View,
	  include/osgDB/ClassInterface,
	  include/osgManipulator/Scale2DDragger,
	  include/osgPresentation/PropertyManager,
	  include/osgSim/LightPointNode, include/osgUtil/IntersectVisitor,
	  include/osgUtil/IntersectionVisitor,
	  include/osgUtil/LineSegmentIntersector,
	  include/osgUtil/PositionalStateContainer,
	  include/osgUtil/RayIntersector, include/osgUtil/TriStripVisitor,
	  include/osgViewer/CompositeViewer,
	  include/osgViewer/GraphicsWindow, include/osgViewer/Keystone,
	  include/osgViewer/View, include/osgViewer/Viewer,
	  include/osgViewer/ViewerBase, include/osgWidget/PdfReader,
	  include/osgWidget/VncClient, include/osgWidget/Window,
	  src/OpenThreads/pthreads/PThread.cpp, src/osg/Image.cpp,
	  src/osg/LightSource.cpp, src/osg/OcclusionQueryNode.cpp,
	  src/osg/Texture1D.cpp, src/osg/Texture2D.cpp,
	  src/osg/Texture2DMultisample.cpp, src/osg/TextureRectangle.cpp,
	  src/osgAnimation/Bone.cpp,
	  src/osgPlugins/jpeg/ReaderWriterJPEG.cpp,
	  src/osgPlugins/pic/ReaderWriterPIC.cpp,
	  src/osgPlugins/tga/ReaderWriterTGA.cpp,
	  src/osgPlugins/txp/trpage_geom.h, src/osgText/String.cpp,
	  src/osgUtil/SceneView.cpp, src/osgViewer/View.cpp: From Jannik
	  Heller, typo fixes

2015-04-07 16:58  robert

	* src/osgPlugins/3ds/ReaderWriter3DS.cpp: From Giampaolo Viganò,
	  "you can find in the attached ZIP archive a fix for 3ds plugin
	  transparent/diffuse textures and opacity maps and the support for
	  reflection map"

2015-04-07 15:53  robert

	* applications/osgconv/osgconv.cpp,
	  examples/osganalysis/osganalysis.cpp: From Janik Heller, clean up
	  of drawable/node usage

2015-04-07 15:52  robert

	* examples/osggpucull/ShapeToGeometry.cpp,
	  examples/osggpucull/ShapeToGeometry.h: Removed unused
	  ShapesToGeometriesVisitor.

2015-04-07 15:49  robert

	* include/osgUtil/Optimizer, src/osgDB/SharedStateManager.cpp,
	  src/osgGA/StateSetManipulator.cpp, src/osgUtil/Optimizer.cpp:
	  Cleaned up handling of Drawables so it utilizes the Node
	  inheritance properly.

2015-04-03 15:43  robert

	* src/osgPlugins/stl/ReaderWriterSTL.cpp: Build fix for VS2005.

2015-04-03 13:34  robert

	* include/osg/ImageUtils: Improved the doxygen comment for the new
	  createImageWithOrientationConversion(..) function.

2015-04-03 13:29  robert

	* src/osgPlugins/jpeg/ReaderWriterJPEG.cpp: Added automatic
	  rotation of jpeg image based on EXIF rotation information
	  provided in the header.

2015-04-03 13:19  robert

	* include/osg/ImageUtils, src/osg/ImageUtils.cpp: Implemented an
	  osg::createImageWithOrientationConversion(...) method to aid for
	  changing orientation of images.

2015-04-02 16:11  robert

	* src/osgPlugins/jpeg/CMakeLists.txt,
	  src/osgPlugins/jpeg/EXIF_Orientation.cpp,
	  src/osgPlugins/jpeg/EXIF_Orientation.h,
	  src/osgPlugins/jpeg/ReaderWriterJPEG.cpp: Added reading of
	  EXIF_Orientation tags when present in a jpeg file.

2015-04-02 10:12  robert

	* src/osgPlugins/osgjs/JSON_Objects,
	  src/osgPlugins/osgjs/json_stream: From Wojciech Lewandowski,
	  Windows build fixes, "These are the tweaks I had to make.
	  JSON_Objects / json_stream headers attached. I am not sure how
	  these will behave on VS 2010. Someone with VS 2010 should test
	  it. Should be okay on VS 2008 and below + VS 2012 and above,
	  though."

2015-04-01 09:37  robert

	* src/osg/Image.cpp: From Lionel Largarde, "fix for the
	  Image::computeNumberOfMipmapLevels method. The method did use the
	  float version of the log function and the / operator.
	  It works for most of the input sizes, but fails for 8192,
	  32768...
	  For 8192, the method returns 13 instead of 14."

2015-03-31 19:31  robert

	* src/osg/Texture2DArray.cpp: Fixed crash when using a subload
	  callback, where the _images array is empty by _images[0] was
	  still being accessed.

2015-03-31 19:29  robert

	* examples/osgtexture2DArray/osgtexture2DArray.cpp: Added --subload
	  command line option and test subload callback for testing
	  purposes

2015-03-31 16:23  robert

	* examples/osgdistortion/osgdistortion.cpp, include/osg/Camera,
	  src/osg/Camera.cpp: Introduced osg::Camera::resize(..) method and
	  associated enum thus:
	  
	  enum ResizeMask
	  {
	  RESIZE_VIEWPORT=1,
	  RESIZE_ATTACHMENTS=2,
	  RESIZE_PROJECTIONMATRIX=4,
	  RESIZE_DEFAULT=RESIZE_VIEWPORT|RESIZE_ATTACHMENTS
	  };
	  
	  /** Resize, to the specified width and height, the viewport,
	  attachments and projection matrix according to the resizeMask
	  provided.
	  * Note, the adjustment of the projection matrix is done if the
	  RESIZE_PROJECTIONMATRIX mask to set and according to the rules
	  specified in the ProjectionResizePolicy. */
	  void resize(int width, int height, int
	  resizeMask=RESIZE_DEFAULT);

2015-03-31 15:08  robert

	* examples/osgdistortion/osgdistortion.cpp, include/osg/Camera,
	  src/osg/Camera.cpp: Introduced Camera::resizeAttachments(int
	  width, int height) to resize all the Texture and Image assigned
	  the the Camera attachments.

2015-03-31 10:41  robert

	* examples/osgdistortion/osgdistortion.cpp: Refactor the RTT Camera
	  resize code into a seperate Callback method in prep for this all
	  being done by a single Camera API call.

2015-03-31 10:36  robert

	* include/osg/Camera, include/osgUtil/RenderStage,
	  src/osg/Camera.cpp, src/osgUtil/RenderStage.cpp: Added
	  Camera::dirtyAttachmentMap(),
	  Camera::s/getAttachmentMapModified() value and usage of this in
	  RenderStage as a new mechanism
	  for telling the rendering backend to update itself to reflect new
	  values in the attachments such as new texture or image sizes.

2015-03-23 11:36  robert

	* examples/osgtessellationshaders/osgtessellationshaders.cpp: Added
	  StatsHandler to osgtessellationshaders example to test out
	  rendering bug associated with stats rendering.

2015-03-20 17:58  robert

	* examples/osgdistortion/osgdistortion.cpp: Added event handle to
	  alter the RTT Camera's dimensions to follow the windows resizes.

2015-03-20 15:49  robert

	* src/osgViewer/GraphicsWindowX11.cpp: Fixed resize dimensions of
	  X11 window

2015-03-20 11:48  robert

	* examples/osgviewerQt/osgviewerQt.cpp: From Jannik Heller, "Fix
	  for Qt4 multi-threaded crash. This patch adds the
	  AA_X11InitThreads flag to the QApplication setup, meaning QT will
	  call XInitThreads for us. This also bumps the required QT version
	  to 4.8+, because the AA_X11InitThreads flag was introduced in
	  that version. If that is not acceptable, we could add a
	  QT_VERSION >= 0x040800 guard, or manually call XInitThreads()
	  instead. Let me know what you think."

2015-03-19 10:49  robert

	* examples/osgdistortion/osgdistortion.cpp: Added Texture wrap
	  setting to CLAMP_TO_EDGE to fix rendering problem when running
	  the default osgdistortion example

2015-03-17 18:10  robert

	* src/osgPlugins/osgjs/JSON_Objects.cpp: Fixed VisualStudio warning

2015-03-17 14:50  robert

	* src/osgWrappers/serializers/osg/ComputeBoundingBoxCallback.cpp,
	  src/osgWrappers/serializers/osg/ComputeBoundingSphereCallback.cpp,
	  src/osgWrappers/serializers/osg/LibraryWrapper.cpp,
	  src/osgWrappers/serializers/osg/UpdateCallback.cpp: From
	  Konstantin Matveyev, "Added ComputeBoundingBoxCallback,
	  ComputeBoundingSphereCallback and UpdateCallback implmenentations
	  to serializers"

2015-03-17 09:40  robert

	* AUTHORS.txt, ChangeLog: Updated ChangeLog and AUTHORS file for
	  dev release

2015-03-17 09:09  robert

	* src/osgWrappers/serializers/osg/LibraryWrapper.cpp: Fixed library
	  wrapper

2015-03-17 08:25  robert

	* src/osgWrappers/serializers/osg/LibraryWrapper.cpp: Added
	  ComputeBoundingSphereCallback reference

2015-03-17 08:24  robert

	* src/osgWrappers/serializers/osg/LibraryWrapper.cpp,
	  src/osgWrappers/serializers/osgAnimation/LibraryWrapper.cpp: From
	  Konstantin Matveyev, "More "LibraryWrapper" fixes for osg and
	  osgAnimation NodeKits
	  in the attachment (for 3.3.6 version :)
	  
	  Fixes:
	  
	  osg:
	  Unsupported associated class osg::UpdateCallback
	  (osg_Drawable_UpdateCallback);
	  ComputeBoundingBoxCallback
	  
	  osgAnimation:
	  Unsupported wrapper class
	  osgAnimation::RigComputeBoundingBoxCallback
	  "

2015-03-17 08:19  robert

	* src/osgPlugins/osgjs/json_stream: Changed to using
	  osgDB::ofstream to work around Windows build issue

2015-03-16 17:01  robert

	* src/osgPlugins/osgjs/CMakeLists.txt: Removed unneccessary library
	  link line.

2015-03-16 14:16  robert

	* src/osgUtil/MeshOptimizers.cpp: Removed the using namespace std
	  and replaced with local std:: to make the code clearer

2015-03-16 12:13  robert

	* examples/osgdistortion/osgdistortion.cpp: Refactored the command
	  line setup to enable better control of set up.
	  Added WindowSizeHandler to allow for adjustment of window size.

2015-03-16 10:30  robert

	* src/osgAnimation/Animation.cpp: From Konstantin Matveyev, "Last
	  update in the osgAnimation::Animation ONCE mode bug fix"

2015-03-16 10:07  robert

	* examples/osganimationviewer/AnimtkViewer.cpp: Added --play-mode
	  [ONCE, STAY, LOOP, PPONG] to help with testing.

2015-03-13 08:12  robert

	* src/osgWrappers/serializers/osg/LibraryWrapper.cpp: From
	  Konstantin Matveyev, "Small fix for OSG 3.3.6.119 in the
	  attachment.
	  
	  One line added in osg/LibraryWrapper.cpp
	  
	  USE_SERIALIZER_WRAPPER(Callback)
	  "

2015-03-12 17:11  robert

	* CMakeLists.txt, include/osgAnimation/MorphGeometry,
	  include/osgAnimation/RigGeometry,
	  src/osgAnimation/MorphGeometry.cpp,
	  src/osgAnimation/RigGeometry.cpp,
	  src/osgWrappers/serializers/osgAnimation/LibraryWrapper.cpp,
	  src/osgWrappers/serializers/osgAnimation/UpdateBone.cpp,
	  src/osgWrappers/serializers/osgAnimation/UpdateMaterial.cpp,
	  src/osgWrappers/serializers/osgAnimation/UpdateMatrixTransform.cpp,
	  src/osgWrappers/serializers/osgAnimation/UpdateMorph.cpp,
	  src/osgWrappers/serializers/osgAnimation/UpdateMorphGeometry.cpp,
	  src/osgWrappers/serializers/osgAnimation/UpdateRigGeometry.cpp,
	  src/osgWrappers/serializers/osgAnimation/UpdateSkeleton.cpp,
	  src/osgWrappers/serializers/osgAnimation/UpdateVertex.cpp:
	  Refactored how the callbacks for updating geometry are managed in
	  MorphGeometry and RigGeometry to address bugs in serialization.

2015-03-12 15:12  robert

	* CMakeModules/FindFBX.cmake: From Laurens Voerman, "attached is a
	  zip with a modified version of:
	  OpenSceneGraph\CMakeModules\FindFBX.cmake
	  
	  This version can find fbx sdk 2015.1 and will prefer it over
	  older versions.
	  
	  Tested with Visual Studio Express 2013 on 64bit windows 7"

2015-03-12 13:41  robert

	* src/osgPlugins/osgjs/json_stream: From Mattias Helsing, add
	  copyright notice from other osgjs header to the json_stream
	  header

2015-03-12 13:37  robert

	* src/osgPlugins/osgjs/json_stream: Added using namespace std and
	  removed the std:: prefixes before the std::isfinte and std::isinf
	  function calls to avoid problems with Android builds against
	  older NDK's.

2015-03-11 17:47  robert

	* src/osgPlugins/exr/ReaderWriterEXR.cpp: From Laurens Voerman,
	  warning fixes

2015-03-11 17:36  robert

	* src/osgPlugins/sdl/JoystickDevice.cpp: From Laurens Voerman, "The
	  current version will not compile with SDL version 2, error
	  OpenSceneGraph\src\osgPlugins\sdl\JoystickDevice.cpp(42): error
	  C2664: 'const char *SDL_JoystickName(SDL_Joystick *)' : cannot
	  convert argument 1 from 'int' to 'SDL_Joystick *'
	  due to changes in the SDL api.
	  
	  Tested with Visual Studio Express 2013; SDL 2.0.1"

2015-03-11 17:27  robert

	* examples/osgtexture2DArray/osgtexture2DArray.cpp,
	  include/osg/Texture2DArray, src/osg/Texture2DArray.cpp: Completed
	  support for assigning 3D osg::Image to osg::Texture2DArray.
	  
	  Improved the osgtexture2DArray example to add --mipmap and
	  --packed command line options to help with testing.

2015-03-11 15:44  robert

	* examples/osgtexture3D/osgtexture3D.cpp: Updated the comments to
	  be more relevant

2015-03-10 18:15  robert

	* include/osg/Texture2DArray, src/osg/Texture2DArray.cpp,
	  src/osgWrappers/serializers/osg/Texture2DArray.cpp: Work in
	  progress to allow osg::Texture2DArray to be set up with a single
	  osg::Image containing 3D image data.

2015-03-10 18:07  robert

	* examples/CMakeLists.txt, examples/osgtexture2DArray,
	  examples/osgtexture2DArray/CMakeLists.txt,
	  examples/osgtexture2DArray/osgtexture2DArray.cpp: Work in
	  progress on new osgtexture2DArray example

2015-03-09 11:27  robert

	* src/osgPlugins/CMakeLists.txt, src/osgPlugins/gles,
	  src/osgPlugins/gles/AnimationVisitor,
	  src/osgPlugins/gles/BindPerVertexVisitor,
	  src/osgPlugins/gles/CMakeLists.txt,
	  src/osgPlugins/gles/DetachPrimitiveVisitor,
	  src/osgPlugins/gles/DrawArrayVisitor,
	  src/osgPlugins/gles/EdgeIndexFunctor,
	  src/osgPlugins/gles/GeometryArray,
	  src/osgPlugins/gles/GeometrySplitterVisitor,
	  src/osgPlugins/gles/GeometryUniqueVisitor,
	  src/osgPlugins/gles/IndexMeshVisitor,
	  src/osgPlugins/gles/IndexMeshVisitor.cpp,
	  src/osgPlugins/gles/LineIndexFunctor,
	  src/osgPlugins/gles/OpenGLESGeometryOptimizer,
	  src/osgPlugins/gles/OpenGLESGeometryOptimizer.cpp,
	  src/osgPlugins/gles/PointIndexFunctor,
	  src/osgPlugins/gles/PreTransformVisitor,
	  src/osgPlugins/gles/PrimitiveIndexors,
	  src/osgPlugins/gles/ReaderWriterGLES.cpp,
	  src/osgPlugins/gles/StatLogger,
	  src/osgPlugins/gles/TangentSpaceVisitor,
	  src/osgPlugins/gles/TriangleLinePointIndexFunctor,
	  src/osgPlugins/gles/TriangleStripVisitor,
	  src/osgPlugins/gles/TriangleStripVisitor.cpp,
	  src/osgPlugins/gles/UnIndexMeshVisitor,
	  src/osgPlugins/gles/UnIndexMeshVisitor.cpp,
	  src/osgPlugins/gles/WireframeVisitor,
	  src/osgPlugins/gles/forsythtriangleorderoptimizer.cpp,
	  src/osgPlugins/gles/forsythtriangleorderoptimizer.h,
	  src/osgPlugins/gles/glesUtil, src/osgPlugins/osgjs,
	  src/osgPlugins/osgjs/Adaptator, src/osgPlugins/osgjs/Animation,
	  src/osgPlugins/osgjs/Animation.cpp, src/osgPlugins/osgjs/Base64,
	  src/osgPlugins/osgjs/Base64.cpp,
	  src/osgPlugins/osgjs/CMakeLists.txt,
	  src/osgPlugins/osgjs/CompactBufferVisitor,
	  src/osgPlugins/osgjs/JSON_Objects,
	  src/osgPlugins/osgjs/JSON_Objects.cpp,
	  src/osgPlugins/osgjs/ReaderWriterJSON.cpp,
	  src/osgPlugins/osgjs/WriteVisitor,
	  src/osgPlugins/osgjs/WriteVisitor.cpp,
	  src/osgPlugins/osgjs/json_stream: From Cedric Pinson, gles and
	  osgjs plugins that support conversion of OSG loaded models into a
	  form that can be used with osgjs JavaScript library

2015-03-05 19:53  robert

	* AUTHORS.txt: Update AUTHORS file for 3.3.6 dev release

2015-03-05 19:33  robert

	* CMakeLists.txt: Updated dev release number

2015-03-05 19:26  robert

	* ChangeLog: Updated ChangeLog for dev release

2015-03-05 10:53  robert

	* src/osg/Shader.cpp: Added check for newline at end of version
	  line, and of it's not add a '\n'

2015-03-04 18:39  robert

	* CMakeLists.txt: Updated SO_VERSION after changes to
	  osgPresentation

2015-03-04 18:36  robert

	* applications/present3D/CMakeLists.txt,
	  applications/present3D/Cluster.cpp,
	  applications/present3D/Cluster.h,
	  applications/present3D/ExportHTML.cpp,
	  applications/present3D/ExportHTML.h,
	  applications/present3D/PointsEventHandler.cpp,
	  applications/present3D/PointsEventHandler.h,
	  applications/present3D/ReadShowFile.cpp,
	  applications/present3D/ReadShowFile.h,
	  applications/present3D/SDLIntegration.cpp,
	  applications/present3D/SDLIntegration.h,
	  applications/present3D/ShowEventHandler.cpp,
	  applications/present3D/ShowEventHandler.h,
	  applications/present3D/SpellChecker.cpp,
	  applications/present3D/SpellChecker.h,
	  applications/present3D/deprecated,
	  applications/present3D/present3D.cpp,
	  include/osgPresentation/AnimationMaterial,
	  include/osgPresentation/CompileSlideCallback,
	  include/osgPresentation/KeyEventHandler,
	  include/osgPresentation/PickEventHandler,
	  include/osgPresentation/PropertyManager,
	  include/osgPresentation/SlideEventHandler,
	  include/osgPresentation/SlideShowConstructor,
	  include/osgPresentation/Timeout,
	  include/osgPresentation/deprecated/AnimationMaterial,
	  include/osgPresentation/deprecated/CompileSlideCallback,
	  include/osgPresentation/deprecated/KeyEventHandler,
	  include/osgPresentation/deprecated/PickEventHandler,
	  include/osgPresentation/deprecated/PropertyManager,
	  include/osgPresentation/deprecated/SlideEventHandler,
	  include/osgPresentation/deprecated/SlideShowConstructor,
	  include/osgPresentation/deprecated/Timeout,
	  src/osgPlugins/osc/OscReceivingDevice.cpp,
	  src/osgPlugins/osc/ReaderWriterOscDevice.cpp,
	  src/osgPlugins/p3d/ReaderWriterP3D.cpp,
	  src/osgPlugins/p3d/ReaderWriterPaths.cpp,
	  src/osgPresentation/AnimationMaterial.cpp,
	  src/osgPresentation/CMakeLists.txt,
	  src/osgPresentation/CompileSlideCallback.cpp,
	  src/osgPresentation/KeyEventHandler.cpp,
	  src/osgPresentation/PickEventHandler.cpp,
	  src/osgPresentation/PropertyManager.cpp,
	  src/osgPresentation/SlideEventHandler.cpp,
	  src/osgPresentation/SlideShowConstructor.cpp,
	  src/osgPresentation/Timeout.cpp,
	  src/osgPresentation/deprecated/AnimationMaterial.cpp,
	  src/osgPresentation/deprecated/CompileSlideCallback.cpp,
	  src/osgPresentation/deprecated/KeyEventHandler.cpp,
	  src/osgPresentation/deprecated/PickEventHandler.cpp,
	  src/osgPresentation/deprecated/PropertyManager.cpp,
	  src/osgPresentation/deprecated/SlideEventHandler.cpp,
	  src/osgPresentation/deprecated/SlideShowConstructor.cpp,
	  src/osgPresentation/deprecated/Timeout.cpp: Restructed the
	  osgPresentation and present3D directories back to the structure
	  that was present in OSG-3.2

2015-03-04 17:42  robert

	* examples/CMakeLists.txt, include/osgDB/ClassInterface,
	  include/osgPresentation/Action, include/osgPresentation/Audio,
	  include/osgPresentation/Element, include/osgPresentation/Group,
	  include/osgPresentation/Image, include/osgPresentation/Layer,
	  include/osgPresentation/Model, include/osgPresentation/Movie,
	  include/osgPresentation/Presentation,
	  include/osgPresentation/PresentationInterface,
	  include/osgPresentation/Section, include/osgPresentation/Show,
	  include/osgPresentation/Slide, include/osgPresentation/Text,
	  include/osgPresentation/Volume, src/osgPresentation/Action.cpp,
	  src/osgPresentation/Audio.cpp,
	  src/osgPresentation/CMakeLists.txt,
	  src/osgPresentation/Element.cpp, src/osgPresentation/Group.cpp,
	  src/osgPresentation/Image.cpp, src/osgPresentation/Layer.cpp,
	  src/osgPresentation/Model.cpp, src/osgPresentation/Movie.cpp,
	  src/osgPresentation/Presentation.cpp,
	  src/osgPresentation/PresentationInterface.cpp,
	  src/osgPresentation/Section.cpp, src/osgPresentation/Show.cpp,
	  src/osgPresentation/Slide.cpp, src/osgPresentation/Text.cpp,
	  src/osgPresentation/Volume.cpp,
	  src/osgWrappers/serializers/CMakeLists.txt,
	  src/osgWrappers/serializers/osgPresentation: Removed the
	  experiemental osgPresentation classes. These are only partially
	  functional and not appropriate for the stable OSG-3.4 release

2015-03-03 15:26  robert

	* AUTHORS.txt, ChangeLog, applications/osgversion/Contributors.cpp:
	  Updated AUTHORS for 3.3.5 dev release

2015-03-03 14:59  robert

	* src/osgWrappers/serializers/osg/ClusterCullingCallback.cpp: Fixed
	  ClusterCullingCallback parser problem due to osg::Callback not
	  being included in inheritance list

2015-03-03 12:56  robert

	* src/osgUtil/Optimizer.cpp: Restructed the checks in the
	  CollectLowestTransformsVisitor::removeTransforms() to avoid
	  benign case being flagged as warning.

2015-03-03 12:03  robert

	* include/osgDB/ObjectWrapper, include/osgDB/Serializer,
	  src/osgWrappers/serializers/osg/Camera.cpp,
	  src/osgWrappers/serializers/osg/ClearNode.cpp,
	  src/osgWrappers/serializers/osgText/TextBase.cpp: From Miha
	  Ravselj, "Regarding previous submission it was only partial
	  solution. After further testing I found similar bug also in
	  ClearNode serializer.
	  
	  //GLbitfield mask = GL_COLOR_BUFFER_BIT|GL_DEPTH_BUFFER_BIT;
	  This line was problematic since it produced incorrect result when
	  let's say COLOR flag is serialized
	  it should be null as in Camera serializer or in a proposed
	  BitFlagsSerializer
	  
	  
	  This line of code caused that whenever only GL_COLOR_BUFFER_BIT
	  bit was written and on value read
	  GL_COLOR_BUFFER_BIT|GL_DEPTH_BUFFER_BIT was restored instead of
	  GL_COLOR_BUFFER_BIT only.
	  
	  //GLbitfield mask = 0; //this resolves the issue same as in
	  camera
	  Also same bit-wise comparison bug was also present in write
	  method.
	  -------------------------------------------------------------------------------------
	  
	  As you can see there are total 3 bit mask serializers in OSG and
	  all 3 had bugs so I decided to add ADD_BITFLAGS_SERIALIZER and
	  replace USER serializers in osg::Camera, osg::ClearNode and
	  osgText::TextBase. I have made sure that bitflags serializer does
	  not break backwards-compatibility since it uses same code as user
	  serializer does in all 3 cases. (see tester.cpp on how
	  compatibility test was performed)"

2015-03-03 12:00  robert

	* src/osg/PolygonMode.cpp: Re-organized the #ifdef's to avoid usage
	  of glPolyginMode under GLES

2015-03-02 14:38  robert

	* CMakeLists.txt: Updated SO_VERSION to take account of API changes
	  in osgDB

2015-03-02 12:11  robert

	* include/osgDB/ConvertBase64, src/osgDB/CMakeLists.txt,
	  src/osgDB/ConvertBase64.cpp, src/osgDB/InputStream.cpp,
	  src/osgDB/OutputStream.cpp: From Johannes Scholz, "Attached you
	  find a patch for osgDB::OutputStream and osgDB::InputStream to
	  include osg::Image::data() using Base64 encoding inside the ASCII
	  OSGT, if WriteImageHint=IncludeData is set, only."

2015-03-02 12:09  robert

	* examples/osgtessellationshaders/osgtessellationshaders.cpp,
	  include/osg/GLDefines: From Michael McDonnel, "The tessellation
	  shader example has a small bug.The middle of the
	  geometry is clipped as soon as it is tessellated. The clipping is
	  probably caused by rounding errors because it is only in one
	  spot. The
	  clipping disappears when the camera is moved, and reappears when
	  it is
	  moved back. Expanding the the bounding box fixed the clipping
	  bug."
	  
	  Tweaked by Robert Osfield to expand it to a -1 to 1 unit box.
	  Actual clipping bug is not due to rounding errors but the shaders
	  creating vertices outside the bounding box of the original input
	  vertices

2015-03-01 15:20  robert

	* examples/osgshadercomposition/osgshadercomposition.cpp: Fixed
	  StateSet::Define names to match OpenSceneGraph-Data/shaders.

2015-03-01 11:08  robert

	* src/osgGA/OrbitManipulator.cpp,
	  src/osgGA/StandardManipulator.cpp: From Jannik Heller, "I noticed
	  the rotation in the OrbitManipulator depends on the framerate. To
	  reproduce this issue, start the osganimate example, rotate the
	  model with the left mouse button, then let go of the mouse button
	  while still moving. You will notice that with V-Sync enabled, the
	  model rotates slower.
	  
	  The OrbitManipulator calculates a scale to counteract the
	  framerate dependency, but it turns out this scale wasn't used for
	  the rotation yet."

2015-02-27 10:01  robert

	* CMakeLists.txt: Updated version number after dev release.

2015-02-27 09:47  robert

	* ChangeLog, applications/osgversion/Contributors.cpp: Updated
	  ChangeLog and Contributors to fix trailing spaces

2015-02-27 09:05  robert

	* src/osgPlugins/lua/lua-5.2.3/src/ldo.c,
	  src/osgPlugins/lua/lua-5.2.3/src/lgc.c,
	  src/osgPlugins/lua/lua-5.2.3/src/lparser.c,
	  src/osgPlugins/lua/lua-5.2.3/src/lstrlib.c: Fixed Windows
	  warnings

2015-02-27 04:29  robert

	* examples/osgfpdepth/osgfpdepth.cpp, src/osg/State.cpp: Fixes for
	  warnings

2015-02-26 20:15  robert

	* src/osgText/Text.cpp: Fixed build with auto ptr conversion
	  switched off

2015-02-26 19:51  robert

	* AUTHORS.txt, ChangeLog, applications/osgversion/Contributors.cpp:
	  Updated AUTHORS

2015-02-26 19:14  robert

	* src/osg/Image.cpp: From Bradley Baker Searles, "We had someone
	  replace a DDS texture with a GL_RGB/GL_UNSIGNED_SHORT_5_6_6
	  image, which would trigger a crash in Image.cpp while flipping
	  the mipmap chain. The code was trying to flip the mipmaps using
	  the rowStep for the full-size image (we have "dds_flip" set in
	  the osgDB::ReaderWriter::Options in the osgDB::Registry)."

2015-02-26 18:06  robert

	* src/osgPlugins/dds/ReaderWriterDDS.cpp: From Bradley Baker
	  Searles, "Small patch attached to handle DDS flip when s=4.
	  Currently it will omit flipping and generate a warning: "Vertical
	  flip was skipped. Image dimensions have to be multiple of 4."

2015-02-26 17:49  robert

	* include/osg/GLExtensions, src/osg/GLExtensions.cpp: From Julien
	  Valentin and Alberto Luaces, added support for transform feedback
	  extensions

2015-02-26 17:18  robert

	* AUTHORS.txt, applications/osgversion/Contributors.cpp: Update
	  AUTHORS file

2015-02-26 14:16  robert

	* src/osgPlugins/tiff/ReaderWriterTIFF.cpp: Fixed typo

2015-02-26 13:52  robert

	* AUTHORS.txt: Regenerated AUTHORS.txt to fix missing special
	  characters

2015-02-25 19:59  robert

	* AUTHORS.txt, applications/osgversion/Contributors.cpp: Updated
	  AUTHORS file

2015-02-25 19:52  robert

	* ChangeLog: Updated ChangeLog

2015-02-25 19:38  robert

	* src/osgPlugins/las/ReaderWriterLAS.cpp: From Aitor Moreno,
	  "Attached you will find the modified file without the lines which
	  raises the exception. "

2015-02-25 19:31  robert

	* src/osgSim/ScalarBar.cpp: From Jamie Robertson, "I've been using
	  osgSim::ScalarBar to display fixed range color values (e.g. red
	  from 1-2, green from 3-4 etc), by setting the _numColors the same
	  as the number of actual colors in the ColorRange.
	  
	  Currently if you do this you get strange looking results as the
	  colors are calculated for values in the centre of each color
	  step, so if your steps are large, the colors are interpolated
	  sigificantly (see screen grab of red, green and blue colors for
	  illustration).
	  
	  I've attached a fix which just uses the original color values
	  whenever _numColors equals the number of actual defined colors in
	  the ColorRange. I doubt anyone would want interpolated colors in
	  these circumstances."

2015-02-25 19:25  robert

	* CMakeLists.txt, CMakeModules/FindGStreamer.cmake: From Dmitry
	  Marakasov, "While packaging osg-3.3.3 I've discovered that
	  gstreamer detection is
	  broken:
	  
	  -- Could NOT find GStreamer (missing: GSTREAMER_BASE_INCLUDE_DIRS
	  GSTREAMER_BASE_LIBRARIES GSTREAMER_GSTREAMER-APP_INCLUDE_DIRS
	  GSTREAMER_GSTREAMER-APP_LIBRARIES
	  GSTREAMER_GSTREAMER-PBUTILS_INCLUDE_DIRS
	  GSTREAMER_GSTREAMER-PBUTILS_LIBRARIES) (found version "1.4.5")
	  
	  though all required modules are installed.
	  
	  There are two problems: first, module names are spelled
	  incorrectly in root
	  CMakeLists.txt (e.g. gstreamer-app instead of app), so variables
	  expected
	  for them are e.g. GSTREAMER_GSTREAMER-APP_INCLUDE_DIRS instead of
	  GSTREAMER_APP_INCLUDE_DIRS.
	  
	  Second, gstreamer base component is detected as GSTREAMER while
	  checked
	  later as GSTREAMER_BASE. I've uncommented the detection as
	  GSTREAMER_BASE, but obviously that should be revisited and only
	  one
	  detection left. With this patch, gstreamer is detected properly
	  and
	  the plugins is successfully built and installed."

2015-02-25 19:19  robert

	* examples/osgviewerQt/osgviewerQt.cpp: From Jonathan Greig, "I was
	  testing out the example and it works fine as a standalone
	  example, but I found that it didn't work as expected when adding
	  the class to some existing code I have to test it out. The osg
	  widget was appearing but it didn't appear to be updating. After
	  tweaking it to pass on the parent QWidget pointer from my code,
	  it worked as expected. I added the WindowFlags to the attached
	  file for good measure. If you look at the Qt Documentation for
	  QWidget ( http://doc.qt.io/qt-5/qwidget.html#QWidget ), you'll
	  see that is exactly where I got this from. When subclassing a
	  widget as such, you should allow the user to pass in the parent
	  at least, considering that has a major effect on how or if Qt may
	  clean up the memory."

2015-02-25 18:56  robert

	* examples/osgfont/osgfont.cpp, examples/osgtext/osgtext.cpp,
	  include/osgText/Glyph, include/osgText/Text,
	  src/osgPlugins/freetype/FreeTypeFont.cpp,
	  src/osgQt/QFontImplementation.cpp, src/osgText/DefaultFont.cpp,
	  src/osgText/Glyph.cpp, src/osgText/Text.cpp,
	  src/osgWidget/Input.cpp: From Andreas Henne, Support for GL3 core
	  profile in osgText

2015-02-25 16:59  robert

	* examples/osgtessellationshaders/osgtessellationshaders.cpp: From
	  Michael McDonnell, "I have changed the code so that the plus key
	  increases both the inner
	  and outer tessellation. The minus key decrease both the inner and
	  outer tessellation. You can still use the arrow keys to control
	  inner
	  and outer tessellation separately."
	  
	  From Robert Osfield, clean up the code to fix warnings and make
	  the coding style more consistent with the rest of the OSG.

2015-02-25 14:55  robert

	* include/osgDB/Serializer, src/osgDB/InputStream.cpp,
	  src/osgDB/OutputStream.cpp: Fixed handling of NULL entries in
	  osg::Geometry TexCoordArrayList and VertexAttribArrayList.

2015-02-24 11:06  robert

	* src/osgPlugins/lua/LuaScriptEngine.cpp: Fixed matrix setup.

2015-02-23 20:28  robert

	* src/osg/TransferFunction.cpp: Fixed image allocation operations.

2015-02-23 11:43  robert

	* src/osgWrappers/serializers/osg/Camera.cpp,
	  src/osgWrappers/serializers/osgText/TextBase.cpp: From Miha
	  Ravšelj and Robert Osfield, fix for serializer bug in
	  osgText::TextBase and osg::Camera

2015-02-23 11:07  robert

	* src/osgViewer/StatsHandler.cpp: From Arjun Ramamurthy, fix for
	  use of StatsHandler in multipleviews/windows

2015-02-20 15:12  robert

	* examples/osgterrain/osgterrain.cpp: Changed the toggle of defines
	  so that it works with assumed defaults now set up by the
	  GeometryPool so that when toggling it doesn't have a delay in
	  what the user would expect

2015-02-20 15:04  robert

	* src/osgTerrain/shaders/terrain_displacement_mapping_CCC_frag.cpp,
	  src/osgTerrain/shaders/terrain_displacement_mapping_CC_frag.cpp,
	  src/osgTerrain/shaders/terrain_displacement_mapping_C_frag.cpp,
	  src/osgTerrain/shaders/terrain_displacement_mapping_flat_vert.cpp,
	  src/osgTerrain/shaders/terrain_displacement_mapping_frag.cpp,
	  src/osgTerrain/shaders/terrain_displacement_mapping_geom.cpp,
	  src/osgTerrain/shaders/terrain_displacement_mapping_vert.cpp:
	  Removed redudent shaders, and updated remaining shaders to match
	  OpenSceneGraph-Data/shaders

2015-02-20 15:02  robert

	* examples/osgterrain/osgterrain.cpp, include/osg/StateSet,
	  include/osgTerrain/GeometryPool,
	  src/osgFX/MultiTextureControl.cpp,
	  src/osgTerrain/GeometryPool.cpp, src/osgTerrain/Terrain.cpp:
	  First step of refactoring the osg::Program management in
	  osgTerrain::GeometryPool for better performance by placing
	  default osg::Program and shader defines on a single StateSet
	  below the osgTerrain::Terrain

2015-02-18 10:52  robert

	* include/osgTerrain/DisplacementMappingTechnique,
	  include/osgTerrain/Terrain,
	  src/osgTerrain/DisplacementMappingTechnique.cpp,
	  src/osgTerrain/Terrain.cpp: Moved osgTerrain::GeometryPool from
	  osgTerrain::DisplacementMappingTechnique to the
	  osgTerrain::Terrain

2015-02-18 10:23  robert

	* src/osgPlugins/dds/ReaderWriterDDS.cpp: From Sebastian
	  Messerschmidt, "Attached you find a version of the
	  ReaderWriterDDS with info outputs set to OSG_INFO instead of
	  OSG_NOTICE. The old version spams the console for each loaded DDS
	  file."

2015-02-17 20:42  robert

	* src/osg/StateSet.cpp: Added support for DefineList to
	  StateSet::merge(..)

2015-02-17 19:40  robert

	* src/osg/OperationThread.cpp: From Stephan Wenglorz, "the attached
	  fix corrects a small bug in OperationThread::setDone(bool),
	  calling it had the opposite effect of what was intended, i.e.
	  setting done to false actually finished the thread. The effect
	  was that VPB threads would exit before starting osgdem when a
	  task had been enqueued, because they initially set done to
	  false."

2015-02-17 19:22  robert

	* examples/osgterrain/osgterrain.cpp: Removed GL_ usage in defines

2015-02-17 19:21  robert

	* src/osgTerrain/GeometryPool.cpp: Removed commented out lines

2015-02-17 10:36  robert

	* include/osg/Callback, include/osg/Object,
	  include/osg/ScriptEngine, include/osgDB/Serializer,
	  include/osgGA/EventHandler, include/osgGA/GUIEventHandler,
	  include/osgViewer/ViewerEventHandlers: Cleaned up warning
	  generated when compiling osgocculusviewer

2015-02-13 12:50  robert

	* include/osg/Program, include/osg/State, src/osg/Shader.cpp,
	  src/osg/State.cpp: Improvements to the #pragma(tic) shader
	  composition support

2015-02-13 10:56  robert

	* examples/osgshadercomposition/CMakeLists.txt,
	  examples/osgshadercomposition/oldshadercomposition.cpp,
	  examples/osgshadercomposition/osgshadercomposition.cpp:
	  Deprecated the old ShaderComposition example code so that it's
	  now only invoked if you add a --old to the osgshadercomposition
	  command line.
	  
	  Introduced a new shader composition example based on the new
	  #pragama and #define based GLSL shader/osg::StateSet::setDefine()
	  functionality now built into the core OSG.

2015-02-13 07:45  robert

	* src/osg/glu/libutil/mipmap.cpp: From Farshid Lashkari, "I've
	  attached a fix for some internal glu functions so that they use
	  size_t for computing allocation sizes instead of GLint. I
	  encountered some large images that were triggering integer
	  overflows with the current code."

2015-02-11 19:21  robert

	* src/osgPlugins/ply/vertexData.cpp: Fixed warning

2015-02-11 16:41  robert

	* src/osg/Shader.cpp: Added reassignment of the #version line to
	  the first entry in the source list.

2015-02-11 09:41  robert

	* include/osg/GLDefines: Added GL #define for Windows build

2015-02-10 21:13  robert

	* include/osg/GLDefines: Windows build fix

2015-02-10 18:01  robert

	* include/osgDB/Serializer, src/osgDB/ObjectWrapper.cpp: Added
	  GL_LINES_ADJACENCY_EXT variants back into ObjectWraper to enable
	  backwards compatibility.

2015-02-10 17:53  robert

	* src/osgUtil/GLObjectsVisitor.cpp: Change for new Program API

2015-02-10 17:20  robert

	* examples/osgterrain/osgterrain.cpp,
	  include/osgTerrain/GeometryPool, src/osgTerrain/GeometryPool.cpp:
	  Added support for new #pragam(atic) shader composition to new
	  displacement mapping technique

2015-02-10 17:04  robert

	* include/osg/BufferObject, include/osg/Drawable,
	  include/osg/GLDefines, include/osg/Geometry,
	  include/osg/PrimitiveSet, include/osg/Program,
	  include/osg/Shader, include/osg/State, include/osg/StateSet,
	  src/osg/Geometry.cpp, src/osg/Program.cpp, src/osg/Shader.cpp,
	  src/osg/State.cpp, src/osg/StateSet.cpp: Introduced new shader
	  composition approach that utilizes #pragma requires(), #pragma
	  import_defines() and #ifdef in GLSL to enable multiple different
	  versions of shaders based
	  on defines passed in from osg::StateSet::setDefine(..).

2015-02-04 15:11  robert

	* include/osgGA/EventQueue, src/osgGA/EventQueue.cpp,
	  src/osgQt/GraphicsWindowQt.cpp,
	  src/osgViewer/GraphicsWindowCarbon.cpp,
	  src/osgViewer/GraphicsWindowCocoa.mm,
	  src/osgViewer/GraphicsWindowIOS.mm,
	  src/osgViewer/GraphicsWindowWin32.cpp,
	  src/osgViewer/GraphicsWindowX11.cpp: Fixed typo.

2015-02-03 16:36  robert

	* include/osg/Shader: Removed unncessary _EXT

2015-02-02 09:53  robert

	* CMakeLists.txt, src/osgPlugins/CMakeLists.txt: Commented out the
	  experimental V8 and Python plugins as these plugins only existed
	  as a proof of concept test linkage with these dependenices, and
	  have no functionality beyond this.

2015-01-27 15:07  robert

	* include/osg/GLDefines, include/osg/PrimitiveSet,
	  src/osgDB/ObjectWrapper.cpp: Replaced _EXT defines with GL-3.2
	  versions

2015-01-23 17:15  robert

	* src/osgPlugins/ffmpeg/FFmpegDecoderAudio.cpp: From Javier Taibo,
	  "I have found a "bug" in the new audio decoding code (actually I
	  think the bug is in ffmpeg, but anyway it should be wise to
	  protect the OSG plug-in about it). I am attaching a security
	  check in FFmpegDecoderAudio.cpp.
	  
	  If anybody is curious about the problem, it happens sometimes
	  when decoding an AAC audio stream. It eventually includes a PCE
	  block inside the AAC audio frame and then ffmpeg audio decoding
	  function signals a "new_frame" with 1024 samples, but a null
	  pointer instead of the audio data. It can be easily detected
	  because in these cases number of channels is 0. Maybe this is the
	  intended behaviour for ffmpeg, but I find it quite weird.
	  "
	  
	  " It seems that libav does not have a channels attribute in
	  AVFrame structure. This new version should do."

2015-01-23 13:51  robert

	* include/osgFX/MultiTextureControl,
	  src/osgFX/MultiTextureControl.cpp,
	  src/osgWrappers/serializers/osgFX/MultiTextureControl.cpp:
	  Changed osgFX::MultiTextureControl so that it uses an
	  osg::FloatArray internally to enable sharing with osg::Uniform.

2015-01-23 13:50  robert

	* examples/osgterrain/CMakeLists.txt,
	  examples/osgterrain/osgterrain.cpp: Added MultiTextureControl
	  event handling of shift 012 i.e. ')', '!', '"' and 'A' to toggle
	  full on for each of the respective or all texture units.

2015-01-22 16:49  robert

	* include/osg/GLDefines: Added #define GL_SEPARATE_ATTRIBS and
	  correcte GL_INTERLEAVED_ATTRIBS

2015-01-22 16:41  robert

	* src/osg/DisplaySettings.cpp: From Alexey Pavlov, "Export fix for
	  Windows platform"

2015-01-22 15:08  robert

	* include/osg/GLDefines: Added GL_INTERLEAVED_ATTRIBS for windows
	  build

2015-01-22 15:07  robert

	* examples/osgtransformfeedback/osgtransformfeedback.cpp: Fixed
	  warning

2015-01-21 15:35  robert

	* include/osg/Texture, src/osg/PolygonMode.cpp, src/osg/State.cpp,
	  src/osg/Texture.cpp: From Andreas Henne, OpenGL core profile
	  fixes required for OSX.

2015-01-21 11:09  robert

	* include/osgFX/MultiTextureControl,
	  src/osgFX/MultiTextureControl.cpp,
	  src/osgTerrain/GeometryTechnique.cpp,
	  src/osgWrappers/serializers/osgFX/MultiTextureControl.cpp: Added
	  TextureWeights uniform support and controls to
	  osgFX::MultiTextureControl to support usage with shaders.

2015-01-20 18:01  robert

	* src/osgTerrain/GeometryPool.cpp: Re-enabled texturing and fixed
	  runtime warning

2015-01-20 17:58  robert

	* src/osgTerrain/GeometryPool.cpp,
	  src/osgTerrain/shaders/terrain_displacement_mapping_geom.cpp,
	  src/osgTerrain/shaders/terrain_displacement_mapping_vert.cpp:
	  Added hardwired geometry shaders

2015-01-20 17:40  robert

	* src/osgTerrain/shaders/terrain_displacement_mapping_CCC_frag.cpp,
	  src/osgTerrain/shaders/terrain_displacement_mapping_CC_frag.cpp,
	  src/osgTerrain/shaders/terrain_displacement_mapping_C_frag.cpp,
	  src/osgTerrain/shaders/terrain_displacement_mapping_vert.cpp:
	  Updated shaders

2015-01-20 15:23  robert

	* include/osgTerrain/GeometryPool: Added key
	  osgTerrain::GeometryPool methods virtual to make it easier to
	  override the shaders

2015-01-20 11:24  robert

	* src/osg/State.cpp: Changed the reset of the GLExtensions::Set()
	  in the State destructor so that it checks to see if the local
	  _glExtensions pointer has been set up and taken ownership of the
	  GLExtensions::Set() value

2015-01-19 11:29  robert

	* include/osgTerrain/GeometryPool, src/osgTerrain/GeometryPool.cpp:
	  Added GeometryPool::s/getUseGeometryShader() hint, and
	  OSG_TERRAIN_USE_GEOMETRY_SHADER env var for setting the default
	  value.

2015-01-16 11:03  robert

	* include/osgTerrain/GeometryPool, src/osgTerrain/GeometryPool.cpp:
	  Added support for using geometry shaders to align the quad
	  diagonals with the local terrain

2015-01-12 10:31  robert

	* include/osgTerrain/GeometryPool, src/osgTerrain/GeometryPool.cpp:
	  Added a local Vec3Array cache to the HeightFieldDrawable to
	  facilitate efficient intersection testing

2015-01-12 10:30  robert

	* include/osg/PrimitiveSet, include/osg/TemplatePrimitiveFunctor,
	  include/osg/TriangleFunctor: Added ability to populate a local
	  vertex cache for when one computes final vertex position in a
	  vertex shader but still want to the Primitive functors to work
	  with the transformed positions.

2015-01-07 14:14  robert

	* CMakeModules/FindFFmpeg.cmake,
	  src/osgPlugins/ffmpeg/CMakeLists.txt,
	  src/osgPlugins/ffmpeg/FFmpegDecoder.cpp,
	  src/osgPlugins/ffmpeg/FFmpegDecoderAudio.cpp,
	  src/osgPlugins/ffmpeg/FFmpegDecoderAudio.hpp,
	  src/osgPlugins/ffmpeg/FFmpegHeaders.hpp,
	  src/osgPlugins/ffmpeg/FFmpegImageStream.cpp,
	  src/osgPlugins/ffmpeg/FFmpegImageStream.hpp,
	  src/osgPlugins/ffmpeg/ReaderWriterFFmpeg.cpp: From Javier Taibo,
	  "I have found that since version 1.1, FFMPEG changed the way
	  audio streams are retrieved, from packed to planar format. SDL
	  interprets packed audio, as is used in the osgmovie example. To
	  make the audio work when the OSGffmpeg plug-in is compiled
	  against recent FFMPEG versions, FFmpegDecoderAudio must check for
	  planar formats and in these cases request the samples as packed.
	  This way all works as before. It can be checked with osgmovie
	  example application.
	  
	  $ osgmovie --audio movie.avi.ffmpeg
	  FFmpegImageStream::open audio failed, audio stream will be
	  disabled: unknown audio format
	  
	  With the attached FFmpegDecoderAudio.cpp, audio sounds correctly.
	  
	  I am also attaching a modified version of FindFFmpeg.cmake that
	  allows to set as FFMPEG_DIR the ffmpeg compiled in the source
	  directory structure. It should not break anything as it only adds
	  some additional search paths.
	  "

2015-01-07 10:36  robert

	* src/osg/Image.cpp: From Farshid Lashkari, "small change to
	  osg::Image::readImageFromCurrentTexture to allow reading data
	  from compressed cubemap textures."

2015-01-06 17:23  robert

	* include/osg/TextureBuffer, src/osg/StateSet.cpp,
	  src/osg/TextureBuffer.cpp: Cleaned up GL_TEXTURE_BUFFER_*ARB
	  usage as include/osg/GLDefines now provides the non ARB variants

2015-01-06 17:12  robert

	* examples/CMakeLists.txt, examples/osgtransformfeedback,
	  examples/osgtransformfeedback/CMakeLists.txt,
	  examples/osgtransformfeedback/osgtransformfeedback.cpp,
	  include/osg/GLExtensions, include/osg/Program,
	  src/osg/GLExtensions.cpp, src/osg/Program.cpp,
	  src/osg/StateSet.cpp,
	  src/osgWrappers/serializers/osg/Program.cpp: From Julien
	  Valentin, "To sum up changes, I had:
	  -some extensions in GLExtensions
	  - GL_TEXTURE_BUFFER as target in osg::StateSet
	  - a VBO based transform feed back example
	  "

2015-01-06 17:09  robert

	* CMakeLists.txt: Updates SO_VERSION in prep for API modifications
	  since the 3.3.3 dev release

2015-01-06 14:55  robert

	* src/osgVolume/Property.cpp: From Julien Valentin, added missing
	  initializer

2015-01-06 14:41  robert

	* src/osgWrappers/serializers/osgVolume/VolumeTechnique.cpp: From
	  Julien Valentin, typo fix

2015-01-05 17:39  robert

	* src/osgPlugins/stl/ReaderWriterSTL.cpp: From Jason Beverage,
	  "Here is a fix to the STL plugin that fixes build errors
	  introduced in the last commit. It's just a simple addition of the
	  stdint.h header."

2014-12-24 11:56  robert

	* AUTHORS.txt, ChangeLog, applications/osgversion/Contributors.cpp:
	  Updated ChangeLog and AUTHORS

2014-12-24 11:43  robert

	* CMakeModules/FindCOLLADA.cmake: Removed debug message

2014-12-24 11:25  robert

	* src/osgPlugins/obj/ReaderWriterOBJ.cpp,
	  src/osgPlugins/obj/obj.cpp, src/osgPlugins/obj/obj.h: From Marc
	  Helbling, Clément Léger, Aurélien Chatelain, Paul Cheyrou-Lagrèze
	  :
	  "a last submission for the obj plugin
	  * supports vertex color definition after vertex position by
	  Clément Léger
	  * supports zbrush vertex color definition (as #MRGB comment) by
	  Aurélien Chatelain
	  * adds a noReverseFace option to not mess with face definition by
	  Aurélien Chatelain
	  * makes material parsing case insensitive (by Paul
	  Cheyrou-Lagrèze and me)
	  * makes the plugin resilient to faulty vertex uv/normal
	  definition (i.e. when a too big index is referenced) by Aurélien
	  hatelain
	  "

2014-12-24 11:02  robert

	* src/osgPlugins/ply/plyfile.cpp,
	  src/osgPlugins/ply/vertexData.cpp,
	  src/osgPlugins/ply/vertexData.h: From Aurélien Chatelain, "adds
	  support for
	  * quad primitives
	  * face definition with the "vertex_index" label (previously only
	  "vertex_indices" was supported)
	  * replaces normal computation by the SmoothingVisitor to avoid
	  code duplication
	  "
	  
	  Submitted by Marc Helbling.

2014-12-24 10:55  robert

	* include/osgUtil/MeshOptimizers, src/osgUtil/MeshOptimizers.cpp,
	  src/osgUtil/SmoothingVisitor.cpp: From Aurélien Chatelain, "the
	  smoothing visitor did not handle shared arrays. It may leads to
	  bad geometry arrays when a shared array is involved in the scene.
	  This submission adds shared array duplication (and moves the
	  SharedArrayOptimizer declaration in MeshOptimizer to make it
	  callable from the SmoothingVisitor)."
	  
	  Submitted by Marc Helbling.
	  Edited by Robet Osfield to retain the usual OSG coding style.

2014-12-24 10:47  robert

	* src/osgPlugins/stl/ReaderWriterSTL.cpp: From Aurélien Chatelain,
	  "updates the STL plugin:
	  * fixes vertex color support
	  * adds 'magics' color definition
	  * cleans options to make the plugin more consistent with other
	  plugins
	  * adds options to not tristrip geometries"
	  
	  Submitted by Marc Helbling.

2014-12-24 10:14  robert

	* src/osgTerrain/GeometryPool.cpp,
	  src/osgTerrain/shaders/terrain_displacement_mapping_CCC_frag.cpp,
	  src/osgTerrain/shaders/terrain_displacement_mapping_CC_frag.cpp,
	  src/osgTerrain/shaders/terrain_displacement_mapping_C_frag.cpp,
	  src/osgTerrain/shaders/terrain_displacement_mapping_flat_vert.cpp,
	  src/osgTerrain/shaders/terrain_displacement_mapping_frag.cpp:
	  Aded shaders for various combinations of layers.

2014-12-24 10:13  robert

	* include/osgDB/ReadFile: Added
	  osgDB::readShaderFileWithFallback(..) convinience functions to
	  make it easier to set up reading external shader files with a
	  built in fallback.

2014-12-23 14:20  robert

	* src/osgPlugins/dae/daeRGeometry.cpp: Added support for reading
	  Vec3 colour arrays

2014-12-23 12:10  robert

	* CMakeModules/FindCOLLADA.cmake,
	  src/osgPlugins/dae/CMakeLists.txt,
	  src/osgPlugins/dae/daeRMaterials.cpp,
	  src/osgPlugins/dae/daeRSceneObjects.cpp,
	  src/osgPlugins/dae/daeRTransforms.cpp,
	  src/osgPlugins/dae/daeReader.cpp, src/osgPlugins/dae/daeReader.h,
	  src/osgPlugins/dae/daeWAnimations.cpp,
	  src/osgPlugins/dae/daeWMaterials.cpp,
	  src/osgPlugins/dae/daeWSceneObjects.cpp,
	  src/osgPlugins/dae/daeWTransforms.cpp,
	  src/osgPlugins/dae/daeWriter.h,
	  src/osgPlugins/dae/domSourceReader.h: Changes to allow the
	  COLLADA plugin to compile against the latest COLLADA DOM version
	  2.4 as well as retaining compatibility with the old 2.2 DOM.

2014-12-22 10:35  robert

	* CMakeLists.txt: Added comment about using
	  -DCMAKE_DISABLE_FINDPACKAGE_* command line.

2014-12-22 09:50  robert

	* include/osg/ref_ptr: Added doxygen comment for
	  ref_ptr<>::release().

2014-12-22 09:49  robert

	* CMakeLists.txt: Updated version number after dev release

2014-12-19 11:00  robert

	* src/osg/DisplaySettings.cpp, src/osgPlugins/dae/daeReader.h:
	  Windows build error and warning fixes

2014-12-19 10:25  robert

	* AUTHORS.txt, ChangeLog: Updated ChangeLog and AUTHORS file for
	  dev release

2014-12-19 08:27  robert

	* CMakeModules/FindGLIB.cmake: Added if () block to avoid script
	  variables set to NOT-Found being used in searching

2014-12-19 08:25  robert

	* CMakeModules/FindLIBLAS.cmake: Fixed script warnings

2014-12-18 17:47  robert

	* CMakeLists.txt, CMakeModules/FindLIBLAS.cmake,
	  src/osgPlugins/CMakeLists.txt, src/osgPlugins/las,
	  src/osgPlugins/las/CMakeLists.txt,
	  src/osgPlugins/las/ReaderWriterLAS.cpp: From Aitor Moreno, LAS
	  plugin - depends upon boost and liblas and liblas-c

2014-12-18 16:52  robert

	* PlatformSpecifics/Android/Application.mk.master.in: From Adrian
	  Clark, build fix for recent Android NDK using the old Android
	  build approach.

2014-12-18 15:59  robert

	* CMakeLists.txt: From Mattias Helsing, "CMake have release 3.0 and
	  3.1 and we have some bad checks for cmake
	  major version when settings cmake policies in CMakeLists.txt.
	  This fixes it"

2014-12-18 11:36  robert

	* AUTHORS.txt, applications/osgversion/Contributors.cpp: Updated
	  AUTHORS

2014-12-18 11:19  robert

	* ChangeLog: Updated ChangeLog in prep for dev release

2014-12-18 11:09  robert

	* examples/osgmovie/CMakeLists.txt: Fixed warning

2014-12-18 10:59  robert

	* include/osg/DisplaySettings, src/osg/DisplaySettings.cpp: Added
	  DisplaySettings::s/getNvOptimusEnablement() and
	  OSG_NvOptimusEnablement env var control to control the setting of
	  the NvOptimusEnablement variable

2014-12-18 09:24  robert

	* src/osgPlugins/fbx/ReaderWriterFBX.cpp: From Sukender, "Added
	  options to the FBX writer: an ascii/binary switch, and the
	  ability to select FBX version as the SDK handles it (Ex:
	  "FBX201300").
	  
	  This allows the user to achieve backward compatibility, and debug
	  format issues using text output."

2014-12-18 09:03  robert

	* CMakeModules/FindGStreamer.cmake: From Mattias Helsing, "The
	  addition of the GStreamer cmake find script broke my build
	  because
	  cmake vars weren't passed correctly to find_package_handler_args,
	  so
	  while the find script didn't find a single required GStreamer lib
	  or
	  include path it still reported GSTREAMER_FOUND=TRUE (and then
	  tried to
	  compile the new plugin). This fixes it and correctly reports
	  missing
	  components."

2014-12-17 19:21  robert

	* CMakeLists.txt, CMakeModules/FindSDL2.cmake,
	  examples/osgmovie/CMakeLists.txt, examples/osgmovie/osgmovie.cpp:
	  Added support for using SDL2 to the osgmovie to enable it to
	  handle floating point audio formats

2014-12-17 19:20  robert

	* CMakeModules/FindFFmpeg.cmake,
	  src/osgPlugins/ffmpeg/FFmpegDecoderAudio.cpp: From Javier Taibo,
	  " I have found that since version 1.1, FFMPEG changed the way
	  audio streams are retrieved, from packed to planar format. SDL
	  interprets packed audio, as is used in the osgmovie example. To
	  make the audio work when the OSGffmpeg plug-in is compiled
	  against recent FFMPEG versions, FFmpegDecoderAudio must check for
	  planar formats and in these cases request the samples as packed.
	  This way all works as before. It can be checked with osgmovie
	  example application.
	  
	  $ osgmovie --audio movie.avi.ffmpeg
	  FFmpegImageStream::open audio failed, audio stream will be
	  disabled: unknown audio format
	  
	  With the attached FFmpegDecoderAudio.cpp, audio sounds correctly.
	  
	  I am also attaching a modified version of FindFFmpeg.cmake that
	  allows to set as FFMPEG_DIR the ffmpeg compiled in the source
	  directory structure. It should not break anything as it only adds
	  some additional search paths.
	  
	  "
	  
	  Note from Robert Osfield, I have found in testing that audio
	  quality is not good for planar floating point formats, even with
	  adding support for SDL2 to the osgmovie example. I haven't yet
	  tracked down the cause of these audio problems or a solution.

2014-12-17 10:19  robert

	* src/osgPlugins/fbx/ReaderWriterFBX.cpp: From Sukender, "FBX
	  writer was writing an empty file when the scene had a root node
	  being a Geode.
	  This was caused be the change in Drawable (now derived from Node)
	  and Geode (now derived from Group).
	  This fix simply sticks with previous behaviour. Another change
	  could be to adapt WriterNodeVisitor.
	  "

2014-12-16 17:37  robert

	* src/osgPlugins/gstreamer/GStreamerImageStream.cpp: Fixed warnings
	  and memmory leaks

2014-12-16 17:15  robert

	* src/osgPlugins/gstreamer/CMakeLists.txt,
	  src/osgPlugins/gstreamer/GStreamerImageStream.cpp: Fixed warnings

2014-12-16 17:08  robert

	* src/osgPlugins/gstreamer/GStreamerImageStream.cpp,
	  src/osgPlugins/gstreamer/GStreamerImageStream.hpp: Improved
	  handling of invalid/unhandled files
	  Added support for ImageStream::LoopigMode variable
	  Fixed memory leak associtied with restarting videos
	  Changed Image::setData() to Image::dirty() to avoid resetting
	  data

2014-12-16 11:20  robert

	* CMakeLists.txt, CMakeModules/FindGLIB.cmake,
	  CMakeModules/FindGStreamer.cmake, src/osgPlugins/CMakeLists.txt,
	  src/osgPlugins/gstreamer,
	  src/osgPlugins/gstreamer/CMakeLists.txt,
	  src/osgPlugins/gstreamer/GStreamerImageStream.cpp,
	  src/osgPlugins/gstreamer/GStreamerImageStream.hpp,
	  src/osgPlugins/gstreamer/ReaderWriterGStreamer.cpp: From Julen
	  Garcia, "Here there is a small plugin I use to play video files.
	  It is based on GStreamer http://gstreamer.freedesktop.org and I
	  have used the FFmpeg plugin as inspiration."
	  
	  From Robert Osfield, fixed handled of row widths so that they are
	  padded to a 4 byte boundary as certain row widths were being
	  rendered incorrectly.

2014-12-16 09:34  robert

	* include/osg/TriangleLinePointIndexFunctor,
	  include/osgUtil/MeshOptimizers, src/osgUtil/MeshOptimizers.cpp:
	  From Marc Helbling, "please find enclosed a submission that
	  should improve the VertexAccessOrderVisitor (pre-transform)
	  optimizer:
	  * it sorts primitives to keep "more complex" primitives first;
	  maybe you'll prefer to have this as an option (but usually it
	  should make more sense to pre-transform triangles before e.g.
	  lines)
	  * currently, the visitor rely on TriangleIndexFunctor and does
	  not take care of points and lines (see
	  https://github.com/openscenegraph/osg/blob/master/include/osg/TriangleIndexFunctor#L124-130).
	  This can lead to issues e.g. if you store the wireframe lines
	  along with some triangles: the triangles will be reindexed but
	  not the line. I've therefore added
	  osg/include/TriangleLinePointIndexFunctor to index triangles,
	  lines and points and derived VertexReorder from this class.
	  * to avoid issues, shared arrays are duplicated. However, in some
	  cases (e.g. an UV channel shared in the geometry only) this is
	  not required. I'm adding a SharedArrayOptimizer to optimize this:
	  it looks for duplicated UVs before the array duplication and
	  deduplicate arrays after.
	  "

2014-12-15 17:15  robert

	* include/osgUtil/TriStripVisitor, src/osgUtil/TriStripVisitor.cpp:
	  From Marc Helbling, "please find the mergeTriangleStrip code
	  merged in osgUtil::TriStripVisitor.
	  I've removed the references to DrawArrays as we should no longer
	  produce any.
	  
	  Note that:
	  * as the name suggest, it only works for triangle strips but
	  could probably be easily extended to quads
	  * the resulting primitive is not highly optimized; we could
	  probably sort the strips in order to minimize the number of
	  primitive restart
	  * as we may merge DrawElementsUInt and DrawElementUShort, the
	  code will only generate DrawElementsUInt"

2014-12-10 18:23  robert

	* examples/osgSSBO/osgSSBO.cpp: Build fix

2014-12-10 13:05  robert

	* include/osg/GLExtensions, src/osg/GLExtensions.cpp: Added OpenGL
	  Transform Feedback extensions.

2014-12-10 12:23  robert

	* examples/CMakeLists.txt, examples/osgSSBO,
	  examples/osgSSBO/CMakeLists.txt, examples/osgSSBO/osgSSBO.cpp,
	  include/osg/BufferIndexBinding, include/osg/BufferObject,
	  include/osg/StateAttribute, src/osg/BufferIndexBinding.cpp,
	  src/osg/BufferObject.cpp: From Marcus Hein, Added support for
	  OpenGL SSBO and SSBB via osg::ShaderStorageBufferObject and
	  osg::ShaderStorageBufferBinding to core OSG library, and added
	  new osgSSBO example

2014-12-10 11:44  robert

	* include/osg/GLDefines: Added GLDefines header

2014-12-10 11:29  robert

	* src/osgPlugins/dae/daeRMaterials.cpp: From Farshid Lashkari, "The
	  Collada loader would crash while processing textures on certain
	  files. I've attached the fix."

2014-12-10 10:44  robert

	* examples/osgshaderterrain/osgshaderterrain.cpp,
	  include/osg/GL2Extensions, src/osg/CMakeLists.txt,
	  src/osg/GL2Extensions.cpp, src/osgAnimation/RigGeometry.cpp,
	  src/osgDB/ObjectWrapper.cpp: Removed old GL2Extensions class,
	  replacing it with a typedef to GL2Extensions
	  Removed old includes to include/osg/GL2Extensions

2014-12-10 10:38  robert

	* examples/osgfpdepth/osgfpdepth.cpp,
	  examples/osgmultitexture/osgmultitexture.cpp,
	  examples/osgoit/DepthPeeling.cpp,
	  examples/osgscreencapture/osgscreencapture.cpp,
	  examples/osgvertexprogram/osgvertexprogram.cpp,
	  include/osg/BufferObject, include/osg/FrameBufferObject,
	  include/osg/GL2Extensions, include/osg/GLExtensions,
	  include/osg/PatchParameter, include/osg/PrimitiveSet,
	  include/osg/Program, include/osg/Shader, include/osg/State,
	  include/osg/Texture, include/osg/TextureBuffer,
	  include/osg/Uniform, include/osgViewer/Renderer,
	  src/osg/ArrayDispatchers.cpp, src/osg/BlendColor.cpp,
	  src/osg/BlendEquation.cpp, src/osg/BlendEquationi.cpp,
	  src/osg/BlendFunc.cpp, src/osg/BlendFunci.cpp,
	  src/osg/BufferObject.cpp, src/osg/CMakeLists.txt,
	  src/osg/Capability.cpp, src/osg/ClampColor.cpp,
	  src/osg/ColorMaski.cpp, src/osg/FragmentProgram.cpp,
	  src/osg/FrameBufferObject.cpp, src/osg/GLExtensions.cpp,
	  src/osg/Geometry.cpp, src/osg/GraphicsContext.cpp,
	  src/osg/Image.cpp, src/osg/Multisample.cpp,
	  src/osg/OcclusionQueryNode.cpp, src/osg/PatchParameter.cpp,
	  src/osg/Point.cpp, src/osg/PointSprite.cpp,
	  src/osg/PrimitiveRestartIndex.cpp, src/osg/Program.cpp,
	  src/osg/SampleMaski.cpp, src/osg/Shader.cpp, src/osg/State.cpp,
	  src/osg/Stencil.cpp, src/osg/StencilTwoSided.cpp,
	  src/osg/Texture.cpp, src/osg/Texture1D.cpp,
	  src/osg/Texture2DArray.cpp, src/osg/Texture2DMultisample.cpp,
	  src/osg/Texture3D.cpp, src/osg/TextureBuffer.cpp,
	  src/osg/TextureCubeMap.cpp, src/osg/TextureRectangle.cpp,
	  src/osg/Uniform.cpp, src/osg/VertexAttribDivisor.cpp,
	  src/osg/VertexProgram.cpp, src/osgFX/SpecularHighlights.cpp,
	  src/osgParticle/PrecipitationEffect.cpp, src/osgText/Glyph.cpp,
	  src/osgUtil/GLObjectsVisitor.cpp, src/osgUtil/RenderStage.cpp,
	  src/osgViewer/Renderer.cpp,
	  src/osgViewer/ScreenCaptureHandler.cpp,
	  src/osgViewer/StatsHandler.cpp: Moved GL2Extensions functionality
	  into the include/osg/GLExtensions header and new GLExtensions
	  object.
	  Moved the #defines into new include/osg/GLDefines
	  Converted all GL2Extensions usage to GLExtensions usage

2014-12-10 09:11  robert

	* include/osg/GLExtensions: Streamlined the extension functions

2014-12-09 21:33  robert

	* include/osg/GL2Extensions: Added #ifdef's around GLsync typedef

2014-12-09 20:09  robert

	* include/osg/GL2Extensions, include/osg/GraphicsContext,
	  include/osg/Texture, include/osg/Texture3D, src/osg/Texture.cpp:
	  Windows build fixes

2014-12-09 19:31  robert

	* runexamples.bat: Added new examples to runexamples.bat script

2014-12-09 19:22  robert

	* src/osg/Capability.cpp: Quietened down debug messages

2014-12-09 19:20  robert

	* examples/CMakeLists.txt, examples/osgblenddrawbuffers,
	  examples/osgblenddrawbuffers/CMakeLists.txt,
	  examples/osgblenddrawbuffers/osgblenddrawbuffers.cpp: From Wand
	  Rui, "I've rewritten the osgblenddrawbuffers example to use the
	  new BlendFunci and Capability classes. Hope it will tell others
	  how to make use of the new functionality and why they are
	  important in modern MRT-based applications."

2014-12-09 18:30  robert

	* examples/osgfpdepth/osgfpdepth.cpp,
	  examples/osgoit/DepthPeeling.cpp, include/osg/FrameBufferObject,
	  include/osg/GL2Extensions, include/osg/GraphicsContext,
	  src/osg/BufferObject.cpp, src/osg/FrameBufferObject.cpp,
	  src/osg/GL2Extensions.cpp, src/osg/GraphicsContext.cpp,
	  src/osg/OcclusionQueryNode.cpp, src/osg/Texture.cpp,
	  src/osg/Texture3D.cpp, src/osg/TextureRectangle.cpp,
	  src/osgUtil/RenderStage.cpp: Moved FBO Extensions into
	  GL2Extensions.

2014-12-09 14:58  robert

	* include/osg/PrimitiveRestartIndex: Removed no longer used
	  Extension definition

2014-12-09 14:57  robert

	* include/osg/ClampColor, include/osg/ColorMaski,
	  include/osg/GL2Extensions, include/osg/Multisample,
	  include/osg/Point, include/osg/PointSprite,
	  include/osg/PrimitiveRestartIndex, include/osg/Stencil,
	  src/osg/ClampColor.cpp, src/osg/ColorMaski.cpp,
	  src/osg/GL2Extensions.cpp, src/osg/Multisample.cpp,
	  src/osg/Point.cpp, src/osg/PointSprite.cpp,
	  src/osg/PrimitiveRestartIndex.cpp: Moved local Extensions structs
	  into GL2Extensions

2014-12-09 11:14  robert

	* include/osg/GL2Extensions, include/osg/Stencil,
	  include/osg/StencilTwoSided, src/osg/GL2Extensions.cpp,
	  src/osg/Stencil.cpp, src/osg/StencilTwoSided.cpp: Moveved
	  Stencil/StencilTwoSided::Extensions into GL2Extensions

2014-12-09 10:37  robert

	* include/osg/BlendColor, include/osg/BlendEquation,
	  include/osg/Capability, include/osg/GL2Extensions,
	  src/osg/BlendColor.cpp, src/osg/BlendEquation.cpp,
	  src/osg/BlendEquationi.cpp, src/osg/Capability.cpp,
	  src/osg/GL2Extensions.cpp: Moved local Extensions objects to
	  GL2Extensions

2014-12-09 10:05  robert

	* examples/osgmultitexture/osgmultitexture.cpp,
	  include/osg/GL2Extensions, include/osg/Texture,
	  include/osg/Texture2DArray, include/osg/Texture3D,
	  src/osg/GL2Extensions.cpp, src/osg/Image.cpp,
	  src/osg/Texture.cpp, src/osg/Texture1D.cpp,
	  src/osg/Texture2DArray.cpp, src/osg/Texture2DMultisample.cpp,
	  src/osg/Texture3D.cpp, src/osg/TextureBuffer.cpp,
	  src/osg/TextureRectangle.cpp, src/osgText/Glyph.cpp: Moved
	  Texture*::Extensions functionality into GL2Extensions

2014-12-08 16:08  robert

	* examples/osgvertexprogram/osgvertexprogram.cpp,
	  include/osg/FragmentProgram, include/osg/GL2Extensions,
	  include/osg/VertexProgram, src/osg/FragmentProgram.cpp,
	  src/osg/GL2Extensions.cpp, src/osg/VertexProgram.cpp: MOved
	  VertexProgram and FragmentProgram::Extensions into GL2Extensions.

2014-12-08 11:08  robert

	* src/osgUtil/CullVisitor.cpp: Fixed memory leak in
	  RenderStageCache.

2014-12-07 17:31  robert

	* examples/osgcubemap/osgcubemap.cpp, include/osg/GL2Extensions,
	  include/osg/SampleMaski, src/osg/GL2Extensions.cpp,
	  src/osg/SampleMaski.cpp: MOved SampleMaski::Extensions into
	  osg::GL2Extensions

2014-12-05 20:05  robert

	* include/osg/GL2Extensions, include/osg/TextureCubeMap,
	  src/osg/GL2Extensions.cpp, src/osg/TextureCubeMap.cpp,
	  src/osgFX/SpecularHighlights.cpp: Moved TextureCubeMap::Extension
	  functionality into GL2Extensions

2014-12-05 17:26  robert

	* include/osg/Drawable, include/osg/GL2Extensions,
	  include/osg/State, include/osgViewer/Renderer,
	  src/osg/ArrayDispatchers.cpp, src/osg/Drawable.cpp,
	  src/osg/GL2Extensions.cpp, src/osg/OcclusionQueryNode.cpp,
	  src/osg/State.cpp, src/osg/TextureRectangle.cpp,
	  src/osgParticle/PrecipitationEffect.cpp,
	  src/osgViewer/Renderer.cpp, src/osgViewer/StatsHandler.cpp: Moved
	  osg::Drawable::Extensions into osg::GL2Extensions

2014-12-05 10:37  robert

	* examples/osgshaderterrain/osgshaderterrain.cpp,
	  examples/osgtransferfunction/TransferFunctionWidget.h,
	  src/osgPlugins/lua/LuaScriptEngine.cpp,
	  src/osgPlugins/lua/lua-5.2.3/src/lauxlib.c,
	  src/osgPlugins/lua/lua-5.2.3/src/lcode.c: Fixed windows build
	  warnings

2014-12-05 09:52  robert

	* src/osg/BufferObject.cpp: Windows build fix

2014-12-05 08:58  robert

	* include/osg/BufferObject, include/osg/Drawable,
	  include/osg/GL2Extensions, src/osg/Drawable.cpp: From the
	  GLintptr + GLsizeiptr defintions to GL2Extensions header

2014-12-04 19:03  robert

	* include/osg/BlendFunc, include/osg/GL2Extensions,
	  src/osg/BlendFunc.cpp, src/osg/BlendFunci.cpp,
	  src/osg/GL2Extensions.cpp: Moved osg::BlenFunc::Extensions into
	  osg::GL2Extensions

2014-12-04 18:13  robert

	* examples/osgscreencapture/osgscreencapture.cpp,
	  include/osg/BufferObject, include/osg/GL2Extensions,
	  include/osg/TextureBuffer, src/osg/BufferIndexBinding.cpp,
	  src/osg/BufferObject.cpp, src/osg/GL2Extensions.cpp,
	  src/osg/Geometry.cpp, src/osgViewer/ScreenCaptureHandler.cpp:
	  Moved GLBufferObject::Extensions structure into
	  osg::GL2Extensions

2014-12-04 18:12  robert

	* examples/osgscreencapture/osgscreencapture.cpp: Removed redundent
	  spaces

2014-12-04 17:12  robert

	* include/osg/GL2Extensions, src/osg/GL2Extensions.cpp: Added
	  glMemoryBarrier, glMapBufferRange and glBindBufferBase to
	  GL2Extensions

2014-12-04 16:28  robert

	* src/osg/VertexAttribDivisor.cpp,
	  src/osgUtil/GLObjectsVisitor.cpp: Moved old
	  GL2Extensions::Get(..) usage across to new
	  osg::State::get<GL2Extensions>() usage

2014-12-04 16:22  robert

	* examples/osgshaderterrain/osgshaderterrain.cpp,
	  include/osg/GL2Extensions, include/osg/State,
	  src/osg/FrameBufferObject.cpp, src/osg/GL2Extensions.cpp,
	  src/osg/PatchParameter.cpp, src/osg/Program.cpp,
	  src/osg/Shader.cpp, src/osg/State.cpp: Ported GL2Extentions
	  across to using the new GL extensions approach - cutting code
	  count by 3000 lines!

2014-12-04 15:10  robert

	* src/osgDB/DatabasePager.cpp,
	  src/osgUtil/IncrementalCompileOperation.cpp: Build fix for when
	  ref_ptr<> auto conversion is disabled

2014-12-03 17:31  robert

	* examples/osgmultiplerendertargets/osgmultiplerendertargets.cpp,
	  include/osg/Capability, include/osg/StateAttribute,
	  src/osg/CMakeLists.txt, src/osg/Capability.cpp: Added
	  osg::Capability and Cabibilityi base classes to wrap up
	  glEnable/glDisable + glEnablei/glDisablei functionality, with
	  osg::Enablei and osg::Disablei concrete implementations.

2014-12-02 17:12  robert

	* include/osg/BlendEquation, include/osg/BlendEquationi,
	  include/osg/BlendFunc, include/osg/BlendFunci,
	  include/osg/ColorMaski, src/osg/BlendEquation.cpp,
	  src/osg/BlendEquationi.cpp, src/osg/BlendFunc.cpp,
	  src/osg/BlendFunci.cpp, src/osg/CMakeLists.txt,
	  src/osg/ColorMaski.cpp,
	  src/osgWrappers/serializers/osg/BlendEquationi.cpp,
	  src/osgWrappers/serializers/osg/BlendFunci.cpp,
	  src/osgWrappers/serializers/osg/ColorMaski.cpp: Added
	  osg::BlendFunci, osg::BlendEquationi and osg::ColorMaski
	  StateAttrirbutes that wrap the glBlendFunci, glBlendEquationi and
	  glColorMaski functions

2014-12-02 15:37  robert

	* include/osg/BlendEquation, include/osg/BlendFunc,
	  src/osg/BlendEquation.cpp, src/osg/BlendFunc.cpp: Moved
	  BlendEquation across to using the new GL extension setup
	  approach.

2014-12-02 15:21  robert

	* examples/osgblendequation/osgblendequation.cpp: Fixed typo

2014-12-02 11:10  robert

	* include/osg/BlendFunc, include/osg/State, src/osg/BlendFunc.cpp:
	  Added a template get and get_exisiting method into osg::State
	  that implements a new mechanism for managing OpenGL extensions.
	  
	  Refactored the BendFunc::Extensions usage to simplify it
	  utilizing the new osg::State extension mechanism.

2014-11-28 16:20  robert

	* PlatformSpecifics/Android/android.toolchain.cmake: From Rafa
	  Gaitan, "I'm attaching also a new version of the toolchain with
	  support for the r10c ndk. This fixes some CMake Warnings and
	  allows to use the toolchain in macosx."

2014-11-28 16:10  robert

	* CMakeLists.txt, include/OpenThreads/Version, include/osg/Version,
	  src/OpenThreads/CMakeLists.txt, src/osg/CMakeLists.txt: Removed
	  include/osg/Version and include/OpenThreads/Version headers as
	  these are autogenerated.
	  
	  Changed the paths for the OpenThreads/osg Version headers to be
	  placed in the PROJECT_BINARY_DIR.

2014-11-28 10:54  robert

	* include/osg/BufferObject, include/osgDB/ConvertUTF,
	  src/OpenThreads/pthreads/PThread.cpp, src/osg/GLExtensions.cpp:
	  Standardized on defined(__ANDROID__)

2014-11-28 10:52  robert

	* src/osgPlugins/lua/lua-5.2.3/src/llex.c,
	  src/osgPlugins/lua/lua-5.2.3/src/luaconf.h: Added
	  getlocaledecpoint() workaround for Android build of lua plugin

2014-11-27 15:54  robert

	* src/osgTerrain/GeometryPool.cpp, src/osgTerrain/shaders,
	  src/osgTerrain/shaders/terrain_displacement_mapping_frag.cpp,
	  src/osgTerrain/shaders/terrain_displacement_mapping_vert.cpp:
	  Added in source shaders

2014-11-27 15:39  robert

	* src/osgTerrain/GeometryPool.cpp: Changed the name of shader files

2014-11-26 20:40  robert

	* src/osg/CMakeLists.txt: From Jason Beverage, "It looks like the
	  Callback header got accidentally removed from the CMakeLists.txt
	  in the submission yesterday for the geometry instancing example."

2014-11-26 19:05  robert

	* include/osgTerrain/DisplacementMappingTechnique,
	  include/osgTerrain/GeometryPool: Windows build fix

2014-11-26 17:08  robert

	* applications/present3D/deprecated/Cluster.h: Fixed warnings

2014-11-26 17:04  robert

	* src/osgQt/GraphicsWindowQt.cpp: Fixed warnings

2014-11-26 16:29  robert

	* src/osgPlugins/ffmpeg/CMakeLists.txt: Fixed deprecated warnings

2014-11-26 16:15  robert

	* src/osgPlugins/pdf/CMakeLists.txt: Fixed warning

2014-11-26 16:04  robert

	* examples/osgcluster/osgcluster.cpp: Fixed warnings.

2014-11-26 16:00  robert

	* src/osgPlugins/lwo/Object.cpp: Fixed warning

2014-11-26 15:59  robert

	* src/osgWrappers/deprecated-dotosg/osg/StateSet.cpp: Fixed warning

2014-11-26 14:06  robert

	* src/osgWrappers/serializers/osgTerrain/DisplacementMappingTechnique.cpp:
	  Added osgTerrain::DisplacementMappingTechnique serializer

2014-11-26 14:04  robert

	* examples/osgterrain/CMakeLists.txt,
	  examples/osgterrain/ShaderTerrain.cpp,
	  examples/osgterrain/ShaderTerrain.h,
	  examples/osgterrain/osgterrain.cpp,
	  include/osgTerrain/DisplacementMappingTechnique,
	  include/osgTerrain/GeometryPool, src/osgTerrain/CMakeLists.txt,
	  src/osgTerrain/DisplacementMappingTechnique.cpp,
	  src/osgTerrain/GeometryPool.cpp: Renamed ShaderTerrain to
	  DisplacementMappingTechnique and moved it from the osgterrain
	  example testbed into the osgTerrain NodeKit

2014-11-26 13:36  robert

	* examples/osgterrain/ShaderTerrain.cpp,
	  examples/osgterrain/ShaderTerrain.h,
	  include/osgTerrain/GeometryPool, src/osgTerrain/CMakeLists.txt,
	  src/osgTerrain/GeometryPool.cpp: Moved osgTerrain::GeometryPool
	  from osgterrain example into osgTerrain NodeKit

2014-11-25 14:37  robert

	* src/osg/CMakeLists.txt: Removed GL header as it's already
	  included via the ${OPENSCENEGRAPH_OPENGL_HEADER} entry.

2014-11-25 10:58  robert

	* examples/CMakeLists.txt, examples/osggpucull,
	  examples/osggpucull/AggregateGeometryVisitor.cpp,
	  examples/osggpucull/AggregateGeometryVisitor.h,
	  examples/osggpucull/CMakeLists.txt,
	  examples/osggpucull/DrawIndirectPrimitiveSet.cpp,
	  examples/osggpucull/DrawIndirectPrimitiveSet.h,
	  examples/osggpucull/GpuCullShaders.h,
	  examples/osggpucull/ShapeToGeometry.cpp,
	  examples/osggpucull/ShapeToGeometry.h,
	  examples/osggpucull/osggpucull.cpp, include/osg/BufferTemplate,
	  src/osg/CMakeLists.txt: From PawelKsiezopolski, "This submission
	  contains a new example for OSG : a geometry instancing rendering
	  algorithm consisting of two consequent phases :
	  
	  - first phase is a GLSL shader performing object culling and LOD
	  picking ( a culling shader ).
	  Every culled object is represented as GL_POINT in the input
	  osg::Geometry.
	  The output of the culling shader is a set of object LODs that
	  need to be rendered.
	  The output is stored in texture buffer objects. No pixel is drawn
	  to the screen
	  because GL_RASTERIZER_DISCARD mode is used.
	  
	  - second phase draws osg::Geometry containing merged LODs using
	  glDrawArraysIndirect()
	  function. Information about quantity of instances to render, its
	  positions and other
	  parameters is sourced from texture buffer objects filled in the
	  first phase.
	  
	  The example uses various OpenGL 4.2 features such as texture
	  buffer objects,
	  atomic counters, image units and functions defined in
	  GL_ARB_shader_image_load_store
	  extension to achieve its goal and thus will not work on graphic
	  cards with older OpenGL
	  versions.
	  
	  The example was tested on Linux and Windows with NVidia 570 and
	  580 cards.
	  The tests on AMD cards were not conducted ( due to lack of it ).
	  The tests were performed using OSG revision 14088.
	  
	  The main advantages of this rendering method :
	  - instanced rendering capable of drawing thousands of different
	  objects with
	  almost no CPU intervention ( cull and draw times are close to 0
	  ms ).
	  - input objects may be sourced from any OSG graph ( for example -
	  information about
	  object points may be stored in a PagedLOD graph. This way we may
	  cover the whole
	  countries with trees, buildings and other objects ).
	  Furthermore if we create osgDB plugins that generate data on the
	  fly, we may
	  generate information for every grass blade for that country.
	  - every object may have its own parameters and thus may be
	  distinct from other objects
	  of the same type.
	  - relatively low memory footprint ( single object information is
	  stored in a few
	  vertex attributes ).
	  - no GPU->CPU roundtrip typical for such methods ( method uses
	  atomic counters
	  and glDrawArraysIndirect() function instead of OpenGL queries.
	  This way
	  information about quantity of rendered objects never goes back to
	  CPU.
	  The typical GPU->CPU roundtrip cost is about 2 ms ).
	  - this example also shows how to render dynamic objects ( objects
	  that may change
	  its position ) with moving parts ( like car wheels or airplane
	  propellers ) .
	  The obvious extension to that dynamic method would be the
	  animated crowd rendering.
	  - rendered objects may be easily replaced ( there is no need to
	  process the whole
	  OSG graphs, because these graphs store only positional
	  information ).
	  
	  The main disadvantages of a method :
	  - the maximum quantity of objects to render must be known
	  beforehand
	  ( because texture buffer objects holding data between phases have
	  constant size ).
	  - OSG statistics are flawed ( they don't know anymore how many
	  objects are drawn ).
	  - osgUtil::Intersection does not work
	  
	  Example application may be used to make some performance tests,
	  so below you
	  will find some extended parameter description :
	  --skip-dynamic - skip rendering of dynamic objects if you only
	  want to
	  observe static object statistics
	  --skip-static - the same for static objects
	  --dynamic-area-size - size of the area for dynamic rendering.
	  Default = 1000 meters
	  ( square 1000m x 1000m ). Along with density defines
	  how many dynamic objects is there in the example.
	  --static-area-size - the same for static objects. Default = 2000
	  meters
	  ( square 2000m x 2000m ).
	  
	  Example application defines some parameters (density, LOD ranges,
	  object's triangle count).
	  You may manipulate its values using below described modifiers:
	  --density-modifier - density modifier in percent. Default = 100%.
	  Density ( along with LOD ranges ) defines maximum
	  quantity of rendered objects. registerType() function
	  accepts maximum density ( in objects per square kilometer )
	  as its parameter.
	  --lod-modifier - defines the LOD ranges. Default = 100%.
	  --triangle-modifier - defines the number of triangles in finally
	  rendered objects.
	  Default = 100 %.
	  --instances-per-cell - for static rendering the application
	  builds OSG graph using
	  InstanceCell class ( this class is a modified version of Cell
	  class
	  from osgforest example - it builds simple quadtree from a list
	  of static instances ). This parameter defines maximum number
	  of instances in a single osg::Group in quadtree.
	  If, for example, you modify it to value=100, you will see
	  really big cull time in OSG statistics ( because resulting
	  tree generated by InstanceCell will be very deep ).
	  Default value = 4096 .
	  --export-objects - write object geometries and quadtree of
	  instances to osgt files
	  for later analysis.
	  --use-multi-draw - use glMultiDrawArraysIndirect() instead of
	  glDrawArraysIndirect() in a
	  draw shader. Thanks to this we may render all ( different )
	  objects
	  using only one draw call. Requires OpenGL version 4.3 and some
	  more
	  work from me, because now it does not work ( probably I
	  implemented
	  it wrong, or Windows NVidia driver has errors, because it hangs
	  the apllication at the moment ).
	  
	  This application is inspired by Daniel Rákos work : "GPU based
	  dynamic geometry LOD" that
	  may be found under this address :
	  http://rastergrid.com/blog/2010/10/gpu-based-dynamic-geometry-lod/
	  There are however some differences :
	  - Daniel Rákos uses GL queries to count objects to render, while
	  this example
	  uses atomic counters ( no GPU->CPU roundtrip )
	  - this example does not use transform feedback buffers to store
	  intermediate data
	  ( it uses texture buffer objects instead ).
	  - I use only the vertex shader to cull objects, whereas Daniel
	  Rákos uses vertex shader
	  and geometry shader ( because only geometry shader can send more
	  than one primitive
	  to transform feedback buffers ).
	  - objects in the example are drawn using glDrawArraysIndirect()
	  function,
	  instead of glDrawElementsInstanced().
	  
	  Finally there are some things to consider/discuss :
	  - the whole algorithm exploits nice OpenGL feature that any GL
	  buffer
	  may be bound as any type of buffer ( in our example a buffer is
	  once bound
	  as a texture buffer object, and later is bound as
	  GL_DRAW_INDIRECT_BUFFER ).
	  osg::TextureBuffer class has one handy method to do that trick (
	  bindBufferAs() ),
	  and new primitive sets use osg::TextureBuffer as input.
	  For now I added new primitive sets to example (
	  DrawArraysIndirect and
	  MultiDrawArraysIndirect defined in
	  examples/osggpucull/DrawIndirectPrimitiveSet.h ),
	  but if Robert will accept its current implementations ( I mean -
	  primitive
	  sets that have osg::TextureBuffer in constructor ), I may add it
	  to
	  osg/include/PrimitiveSet header.
	  - I used BufferTemplate class writen and published by Aurelien in
	  submission forum
	  some time ago. For some reason this class never got into
	  osg/include, but is
	  really needed during creation of UBOs, TBOs, and possibly SSBOs
	  in the future.
	  I added std::vector specialization to that template class.
	  - I needed to create similar osg::Geometries with variable number
	  of vertices
	  ( to create different LODs in my example ). For this reason I've
	  written
	  some code allowing me to create osg::Geometries from osg::Shape
	  descendants.
	  This code may be found in ShapeToGeometry.* files. Examples of
	  use are in
	  osggpucull.cpp . The question is : should this code stay in
	  example, or should
	  it be moved to osgUtil ?
	  - this remark is important for NVidia cards on Linux and Windows
	  : if
	  you have "Sync to VBlank" turned ON in nvidia-settings and you
	  want to see
	  real GPU times in OSG statistics window, you must set the power
	  management
	  settings to "Prefer maximum performance", because when "Adaptive
	  mode" is used,
	  the graphic card's clock may be slowed down by the driver during
	  program execution
	  ( On Linux when OpenGL application starts in adaptive mode, clock
	  should work
	  as fast as possible, but after one minute of program execution,
	  the clock slows down ).
	  This happens when GPU time in OSG statistics window is shorter
	  than 3 ms.
	  "

2014-11-25 10:33  robert

	* src/osgUtil/TriStripVisitor.cpp: Removed DrawArrays optimization
	  to simplify the code and open the door to adding primitive
	  combining.

2014-11-25 10:11  robert

	* src/osg/State.cpp: Commented out
	  State::setUpVertexAttribAlias(..) debug message.

2014-11-24 15:19  robert

	* CMakeLists.txt, CMakeModules/FindAVFoundation.cmake,
	  CMakeModules/FindQuickTime.cmake,
	  src/osgViewer/PixelBufferCocoa.mm: From Jan Klimke, "i noticed,
	  that there are a couple of additional flaws when building osg for
	  Mac OS X 10.10 Yosemite.
	  
	  The mac os sdk version is recognized by the current CMAKE script
	  as 10.1 instead of 10.10 since it cuts the version string from
	  the 4th place. I introduced a more reliable version checking
	  based on splitting the returned version code into MAJOR MINOR and
	  PATCH parts and reassemble the OSG sdk version afterwards.
	  
	  I replaced the existing CMake code against the following
	  (returning now version 10.10 as expected):
	  
	  # Determine the canonical name of the selected Platform SDK
	  EXECUTE_PROCESS(COMMAND "/usr/bin/sw_vers" "-productVersion"
	  OUTPUT_VARIABLE OSG_OSX_SDK_NAME
	  OUTPUT_STRIP_TRAILING_WHITESPACE)
	  STRING(REPLACE "." ";" MACOS_VERSION_LIST ${OSG_OSX_SDK_NAME})
	  LIST(GET MACOS_VERSION_LIST 0 MACOS_VERSION_MAJOR)
	  LIST(GET MACOS_VERSION_LIST 1 MACOS_VERSION_MINOR)
	  LIST(GET MACOS_VERSION_LIST 2 MACOS_VERSION_PATCH)
	  
	  SET(OSG_OSX_SDK_NAME
	  "macosx${MACOS_VERSION_MAJOR}.${MACOS_VERSION_MINOR}")
	  
	  Also i added the check for the new Version to some more find
	  scripts.
	  
	  Additionally the nil object in Objective C now seems to be
	  equivalent with a null_ptr that cannot be passed as GLInt
	  anymore. So i switched this in the PixelBufferCocoa.mm to pass a
	  zero instead of nil.
	  "

2014-11-24 14:54  robert

	* include/osg/StateAttribute, include/osg/VertexAttribDivisor,
	  src/osg/CMakeLists.txt, src/osg/VertexAttribDivisor.cpp,
	  src/osgWrappers/serializers/osg/VertexAttribDivisor.cpp: Added
	  VertexAttribDivisor class to wrap up glVertexAttribDivisor
	  function

2014-11-24 14:09  robert

	* examples/osgsimplegl3/osgsimplegl3.cpp: Fixed osgsimplegl3
	  example's set up of the main camera.

2014-11-24 14:01  robert

	* include/osg/State, src/osg/State.cpp: Added numTextureUnits
	  parameter to the osg::State::resetVertexAttributeAlias(bool,
	  unit) method, and set the default to 8.

2014-11-21 20:16  robert

	* src/osgDB/CMakeLists.txt, src/osgDB/FileUtils.cpp: From Alberto
	  Luaces,"the current code uses the preprocessor for generating the
	  plugin path in
	  a way that when CMAKE_INSTALL_PREFIX contains something along the
	  lines
	  of
	  
	  /usr/x86_64-linux-gnu/
	  
	  it gets substituted as
	  
	  /usr/x86_64-1-gnu/
	  
	  that is, the string is preprocessed again, thereby making changes
	  to
	  anything that matches any defined symbol, as "linux" in this
	  example
	  (https://bugs.debian.org/cgi-bin/bugreport.cgi?bug=763816).
	  
	  Quoting that path directly in CMake scripts solves that problem.
	  "

2014-11-21 20:15  robert

	* include/osg/Image: Added comment clarifying how
	  Image::getColor(..) out of 0..1 range texcoords are handled - now
	  clamped to edge.

2014-11-21 17:22  robert

	* src/osg/Image.cpp: Implemented a clamp to edge policy for the
	  Image::g/setColor(color, texcoord).

2014-11-21 17:17  robert

	* src/osg/CopyOp.cpp: Added testing for Drawables in the
	  CopyOp::operator(Node*) to replicate the old functionality.

2014-11-21 16:27  robert

	* include/osg/Image, src/osg/Image.cpp: From Sebastian
	  Messerschmidt, "Added setColor function to modify an image based
	  on texture coordinates, parallel to the getColor functionality."

2014-11-21 14:46  robert

	* examples/osgterrain/osgterrain.cpp: Added --db-affinit cpuNum
	  option to osgterrain example to illustrate how to set the thead
	  affinity of the DatabasePager threads.

2014-11-21 10:44  robert

	* include/osg/Texture2DMultisample: From Sebastian Messerschmidt,
	  "Attached you find a change adding a getNumSamples() function to
	  retrieve the value set via setNumSamples."

2014-11-21 10:37  robert

	* CMakeLists.txt, CMakeModules/ModuleInstall.cmake,
	  CMakeModules/OsgMacroUtils.cmake,
	  PlatformSpecifics/Android/android.toolchain.cmake,
	  src/CMakeLists.txt, src/OpenThreads/pthreads/CMakeLists.txt,
	  src/osgWrappers/serializers/osg/LibraryWrapper.cpp: From Rafa
	  Gaitan, "I finally had some time to change the build system for
	  Android using a Toolchain, which, I think, will be easier to
	  maintain and uses cmake standard system to build it.
	  
	  My changes:
	  -------------------
	  - I changed the cmake files and added a toolchain for building
	  OSG in Android. The toolchain is based on the one used at OpenCV.
	  For building OSG for android you just need to do:
	  
	  mkdir build_android_static_gles2 && cd build_android_static_gles2
	  cmake .. -DANDROID_NDK=<path-to-the-android-ndk>
	  -DCMAKE_TOOLCHAIN_FILE=../PlatformSpecifics/Android/android.toolchain.cmake
	  -DOPENGL_PROFILE="GLES2"
	  -DDYNAMIC_OPENTHREADS=OFF
	  -DDYNAMIC_OPENSCENEGRAPH=OFF
	  -DANDROID_NATIVE_API_LEVEL=15 # optional
	  -DANDROID_ABI=armeabim #optional
	  -DCMAKE_INSTALL_PREFIX=<path-to-the-install-path> #optional
	  make -j 8
	  make install
	  
	  The OPENGL_PROFILE works as expected, changing it to "GLES1" it
	  builds and links OSG using GLES1.
	  The DYNAMIC_OPENTHREADS/DYNAMIC_OPENSCENEGRAPH parameters also
	  allows to build the dynamic libraries
	  
	  - I also added some build fixes for android related to the
	  texture formats and added some missing USE_OSG_SERIALIZER_WRAPPER
	  in the osg serializer library to support loading osgb files in
	  static."

2014-11-21 10:21  robert

	* CMakeModules/CheckAtomicOps.cmake: From Björn Blissing, fix for
	  ambiguous defines in Atomic.cpp when compiling with MinGW and GCC

2014-11-20 17:37  robert

	* include/osg/Texture: From Claus Steuer, "XCode 6, IOs 8.1 SDK
	  Compile fix : There are some undefined texture formats when
	  compiling osg for IOs 8.1 with XCode 6 and OpenGLES2 enabled."

2014-11-20 17:00  robert

	* include/osg/State: From Pjotr Svetachov, "I was experimenting
	  with VBO's to try to get them on par with display
	  lists when drawing lots of batches and noticed that my program
	  generated a lot of unneeded glClientActiveTexture calls. Digging
	  deeper I found out it came from State::disableTexCoordPointer
	  where
	  the function would call glClientActiveTexture but not
	  glDisableClientState because the geometry didn't have texture
	  coordinates for that channel. This is because in our scene there
	  are
	  some geometries that have move than one uv channels making
	  State::_texCoordArrayList grow. Then the method
	  State::applyDisablingOfVertexAttributes() will call
	  disableTexCoordPointer multiple times.
	  
	  I rearrange the method a little to combat this. Now the logic has
	  the
	  same ordering as disableTexCoordPointersAboveAndIncluding which
	  already combats this."

2014-11-20 16:38  robert

	* src/osgPlugins/obj/ReaderWriterOBJ.cpp: From Farshid Lashkari,
	  "The obj loader was overriding the existing database path list
	  with the file path of the model, instead of prepending the file
	  path to the path list. The latter seems to be more common
	  behavior for most of the existing loader plugins. Also, the local
	  options weren't actually being used when processing the scene
	  graph for textures. I've attached the fix for both issues."

2014-11-20 10:52  robert

	* src/osgPlugins/Inventor/ConvertFromInventor.cpp: From Marc
	  Helbling, "here is a trivial fix in the Inventor plugin. In one
	  code path, the pointer validity is checked after dereferencing a
	  pointer that can be null (image->valid()) instead of calling
	  ref_ptr::valid (image.valid())."

2014-11-20 10:45  robert

	* src/osgUtil/MeshOptimizers.cpp: From Marc Helbling, "I've come
	  across scenes that contains geometries with initialized but empty
	  vertex arrays and primitives and that would make some optimizers
	  crash.
	  
	  The submission therefore only contains a test on the size of the
	  vertex array for the VertexCacheMissVisitor and the
	  VertexAccessOrderVisitor visitors."

2014-11-20 10:05  robert

	* src/osg/Texture.cpp: From Christian Ruzicka, "while testing this
	  commit on our OSG 3.2 version, I observed that the changes for
	  ETC2 brake ETC1 support. Attached you'll find the changes to get
	  ETC1 running again"

2014-11-20 09:55  robert

	* src/osgPlugins/3ds/ReaderWriter3DS.cpp: From Sukender, "Fix for
	  3DS reader, which may read wrong triangles. Actually, indices may
	  suffer a 'short int' overflow, in two places."

2014-11-20 09:41  robert

	* src/osg/Texture2DArray.cpp: Fixed segfalt in Texture2DArray copy
	  constructor where it would apply images to an uninitialzed
	  vector.

2014-11-20 09:32  robert

	* src/osgPlugins/fbx/fbxMaterialToOsgStateSet.cpp,
	  src/osgPlugins/fbx/fbxMaterialToOsgStateSet.h,
	  src/osgPlugins/fbx/fbxRMesh.cpp: From Marc Helbling, "patch
	  adding support for ambient material in the FBX plugin. It's a
	  straightfoward adaptation of the emissive support and has been
	  tested on a proprietary model."

2014-11-20 09:21  robert

	* src/osgPlugins/gif/ReaderWriterGIF.cpp: From Pjotr Svetachov, fix
	  for build breakage with giflib 5.0.

2014-11-20 08:26  robert

	* README.txt: From Per Nordqvist, "The README.txt is still somewhat
	  confusing so I have updated it"

2014-11-19 17:45  robert

	* README.txt, configure: Removed configure script as it's no longer
	  required as cmake . will now default to Release

2014-11-19 17:42  robert

	* CMakeLists.txt: Added CMake script to set the default
	  CMAKE_BUILD_TYPE to Release. Approach taken from simgear.

2014-11-19 17:29  robert

	* ChangeLog, applications/osgversion/Contributors.cpp: Fixed
	  Contributors names

2014-11-19 17:10  robert

	* src/osgPlugins/gif/ReaderWriterGIF.cpp: From Clement Boesch, "Fix
	  remaining bit of Giflib5 usage"

2014-11-19 11:37  robert

	* src/osgWrappers/deprecated-dotosg/osg/ProxyNode.cpp: From Laurens
	  Voerman, "I found a new way to crach the osgviewer:
	  osgviewer "ProxyNode { FileNameList { cow.osgt } num_children 1
	  }".osgs
	  
	  The proxy node reader wrongly assumes options to be non NULL.
	  
	  fixed in attached zip:
	  src\osgWrappers\deprecated-dotosg\osg\ProxyNode.cpp
	  
	  applies to both the 3.2 branch and svn trunk"

2014-11-19 11:30  robert

	* examples/osgQtWidgets/osgQtWidgets.cpp,
	  include/osgQt/QGraphicsViewAdapter, include/osgQt/QWebViewImage,
	  include/osgQt/QWidgetImage, src/osgQt/QGraphicsViewAdapter.cpp,
	  src/osgQt/QWidgetImage.cpp,
	  src/osgViewer/ViewerEventHandlers.cpp: From Wang Rui, "The
	  submission includes some fixes for osgQt library and osgQtWidgets
	  example: (1) QTextEdit now works with mouse/drag events, (2)
	  scrollbars will change when OSG window is resizing, (3) improve
	  rendering efficiency of QGraphicsViewAdapter so that it works
	  with complex Qt UI, (4) add new setBackgroundWidget() method to
	  indicate a 'background widget', which will ignore mouse/key
	  events on it and pass them to the 3D scene."

2014-11-19 10:43  robert

	* examples/osgterrain/ShaderTerrain.cpp: Changed the way that the
	  cell size is passed to the shader

2014-11-19 09:33  robert

	* src/osg/Texture.cpp: From James Turner, "Converting the loops to
	  forward versions fixed the issue. The problem is size_t is
	  unsigned; at the limit condition it doesn’t go negative but wraps
	  around to 0xffffffffffffffff …. and boom."

2014-11-17 15:43  robert

	* src/osgPlugins/exr/ReaderWriterEXR.cpp: Fixed typo

2014-11-17 09:19  robert

	* src/osgDB/ObjectCache.cpp: Fixed typo in comment

2014-11-14 17:44  robert

	* examples/osgterrain/ShaderTerrain.cpp: Added use of
	  GL_TRIANGLE_STRIP to cut down the size of the primitive indices
	  required.

2014-11-14 16:47  robert

	* examples/osgterrain/ShaderTerrain.cpp: Implemented skirt
	  functionality

2014-11-13 09:40  robert

	* include/osgDB/DatabasePager, include/osgDB/ObjectCache,
	  include/osgDB/Options, src/osgDB/DatabasePager.cpp,
	  src/osgDB/ObjectCache.cpp, src/osgDB/Options.cpp,
	  src/osgDB/Registry.cpp: Refactored the handling of use of the
	  osgDB::ObjectCache in the DatabasePager to use a local thread
	  specific ObjectCache to handle new additions and
	  then have these additions merged with the main Registry
	  ObjectCache during the main loop.

2014-11-11 18:28  robert

	* include/osgDB/ObjectCache, include/osgDB/Registry,
	  src/osgDB/CMakeLists.txt, src/osgDB/ObjectCache.cpp,
	  src/osgDB/Registry.cpp: Moved implementation of ObjectCache
	  functionality out of Registry into a dedicated osgDB::ObjectCache
	  class.

2014-11-10 16:04  robert

	* include/osgDB/DatabasePager, src/osgDB/DatabasePager.cpp: To
	  handle thread safe paging and use of the osgDB::Registry
	  ObjectCache, moved the handling of cache into
	  osgDB::DatabasePager.

2014-11-06 10:44  robert

	* src/osgDB/InputStream.cpp: From Pjotr Svetachov, "I tried your
	  fix and it exposed a bug in my fix :)
	  The problem is that the readObjectFields method will add the
	  object to the _identifierMap. So all the other instances of that
	  image in the same file will be replaced by the created dummy
	  object. In my fix this was an dummy image and I didn't notice it
	  in our scene's, probably because it covered a small part of an
	  object. In your fix the dummy object was not an image and that
	  leads to a crash when something tries to use it as an image. I
	  have attached a small fix for this bug.
	  
	  "

2014-11-06 10:40  robert

	* include/osg/Object, include/osgDB/DatabasePager,
	  include/osgUtil/IncrementalCompileOperation,
	  src/osgDB/DatabasePager.cpp, src/osgDB/InputStream.cpp,
	  src/osgUtil/IncrementalCompileOperation.cpp: Introduced use of
	  MarkerObject to IncrmentalCompileOperation/DatabasePager as a way
	  of marking objects that have already been processed and compiled,
	  thus avoid potential threading conflicts when paged subgraphs are
	  reused.

2014-11-05 16:08  robert

	* include/osgDB/InputStream, src/osgDB/InputStream.cpp: Added
	  handling of the reading of field properties to a dummy object for
	  cached images to avoid threading issues associated with reusing
	  and modifying an active object.

2014-11-05 13:38  robert

	* src/osg/OperationThread.cpp: Reinstated the original mechanism
	  for OperationThread::cancel() that co-operatively releases
	  blocks/barriers to make sure the thread is able to exit
	  correctly.

2014-11-04 20:07  robert

	* examples/osgterrain/ShaderTerrain.cpp,
	  examples/osgterrain/ShaderTerrain.h: Improvements to the
	  ShaderTerrain experiemental terrain rendering technique.

2014-11-04 20:07  robert

	* src/osgTerrain/TerrainTile.cpp: Changed TerrainTile::setDirty()
	  to use children needing update traversal mechanism to address
	  threadng issues.

2014-11-04 20:06  robert

	* src/OpenThreads/pthreads/PThread.cpp,
	  src/OpenThreads/pthreads/PThreadPrivateData.h: Change isRunning
	  variable to an Atomic to address possible race condition
	  asscoiated with reading and writing to the variable from
	  different threads.

2014-11-04 16:29  robert

	* src/osgPlugins/ffmpeg/FFmpegDecoderAudio.cpp,
	  src/osgPlugins/ffmpeg/FFmpegDecoderVideo.cpp: Build fixes for
	  ffmpeg LIBAVCODEC_VERSION_MAJOR >= 56

2014-11-04 11:18  robert

	* src/osgViewer/ViewerBase.cpp: Added an InitRegistry static
	  intiialization and destrucion static to help control the order of
	  construction and destruction of the osgDB::Registry.

2014-11-04 10:46  robert

	* examples/osgQtBrowser/osgQtBrowser.cpp,
	  examples/osgunittests/MultiThreadRead.cpp,
	  examples/osgunittests/osgunittests.cpp,
	  examples/osguserstats/osguserstats.cpp,
	  examples/osgviewerMFC/MFC_OSG.cpp, include/osg/OperationThread,
	  src/OpenThreads/pthreads/PThread.cpp,
	  src/OpenThreads/qt/QtThread.cpp,
	  src/OpenThreads/sproc/SprocThread.c++,
	  src/OpenThreads/win32/Win32Thread.cpp,
	  src/osg/OperationThread.cpp, src/osgDB/DatabasePager.cpp,
	  src/osgDB/ImagePager.cpp, src/osgPlugins/cfg/RenderSurface.cpp,
	  src/osgPlugins/gif/ReaderWriterGIF.cpp,
	  src/osgPlugins/quicktime/QuicktimeImageStream.cpp,
	  src/osgPlugins/vnc/ReaderWriterVNC.cpp: Replaced use of
	  while(isRunning()) { YieldCurrentThread(); } style loops with use
	  of join() to avoid false positives being reported by valgrind
	  when using the helgrind tool for thread debugging.

2014-10-21 15:08  robert

	* examples/osgterrain/CMakeLists.txt,
	  examples/osgterrain/ShaderTerrain.cpp,
	  examples/osgterrain/ShaderTerrain.h,
	  examples/osgterrain/osgterrain.cpp,
	  src/osgTerrain/TerrainTile.cpp: Added experimental
	  osgTerrain::ShaderTerrain TerrainTechnique to osgterrain example
	  to flesh out new shader based displacement mapping approach to
	  osgTerrain databases.
	  
	  Requires shader files place in OpenSceneGraph-Data/shaders from
	  OpenSceneGraph-Data's svn/trunk to function.
	  
	  Run osgterrain example with --shader command line option to
	  select displacement mapping shader approach.

2014-10-21 14:47  robert

	* applications/osgviewer/osgviewer.cpp: Removed --sync related code
	  as it's now integrated into osg::DisplaySettings and osgViewer

2014-10-21 14:46  robert

	* include/osg/DisplaySettings, include/osg/GraphicsContext,
	  src/osg/DisplaySettings.cpp, src/osg/GraphicsContext.cpp,
	  src/osgViewer/CompositeViewer.cpp, src/osgViewer/Viewer.cpp:
	  Added osg::SyncSwapBuffersCallback to include/osg/GraphicsContext
	  and support for enabling it to include/osg/DisplaySettings, and
	  to the Viewer/CompositeViewer::realize() methods.
	  
	  To enable the sync of swap buffers set the env var
	  OSG_SYNC_SWAP_BUFFERS to ON or 1, to switch off set to OFF or 0.
	  
	  One can also use the --sync command line option for application
	  that pass on command line options to the
	  osg::DisplaySettings::instance().

2014-10-21 08:27  robert

	* src/osg/StateSet.cpp: Removed checks against Drawable as these
	  are no longer required.

2014-09-17 17:40  robert

	* src/osgPlugins/lua/LuaScriptEngine.cpp,
	  src/osgPlugins/lua/LuaScriptEngine.h,
	  src/osgPlugins/lua/ReaderWriterLua.cpp: Added support for writing
	  the file path of a script to the lua package.path to help with
	  loading scripts within lua.

2014-09-16 17:40  robert

	* examples/osgvolume/osgvolume.cpp,
	  src/osgPlugins/p3d/ReaderWriterP3D.cpp,
	  src/osgPlugins/tf/ReaderWriterTF.cpp: Changed osgvolume example
	  to use the new tf plugin rather than having local code for
	  reading transfer function

2014-09-16 11:00  robert

	* src/osgPlugins/tf/ReaderWriterTF.cpp: Added write support

2014-09-15 17:53  robert

	* src/osgDB/Registry.cpp, src/osgPlugins/CMakeLists.txt,
	  src/osgPlugins/tf, src/osgPlugins/tf/CMakeLists.txt,
	  src/osgPlugins/tf/ReaderWriterTF.cpp: Added .tf & .tf-255 plugin
	  for reading ascii 1D transfer functon files in support for volume
	  rendering.

2014-09-12 14:16  robert

	* include/osgUI/TabWidget, src/osgUI/TabWidget.cpp: Added basic
	  frame rendering for TabWidget

2014-09-10 17:03  robert

	* include/osgUI/AlignmentSettings, src/osgUI/AlignmentSettings.cpp,
	  src/osgUI/TabWidget.cpp: Improved the alignment and sizing of
	  TabWidget tab headers

2014-09-10 11:59  robert

	* src/osgUI/TabWidget.cpp: Implemented the selection of tabs by
	  clicking, using mouse wheel or arrow keys.

2014-09-09 16:12  robert

	* src/osgUI/Dialog.cpp, src/osgUI/TabWidget.cpp: Improved the
	  handling of the dialog title text

2014-09-09 15:14  robert

	* include/osgUI/Callbacks, src/osgUI/Callbacks.cpp,
	  src/osgUI/Dialog.cpp, src/osgUI/Widget.cpp: Moved the diaglog
	  title bar widgets into the Widget::GraphicsSubgraph map to avoid
	  them poluting the Dialog's children list and to prevent them from
	  being serialized.

2014-09-09 13:37  robert

	* include/osgUI/TabWidget, include/osgUI/Widget,
	  src/osgUI/ComboBox.cpp, src/osgUI/Dialog.cpp,
	  src/osgUI/Label.cpp, src/osgUI/LineEdit.cpp, src/osgUI/Popup.cpp,
	  src/osgUI/PushButton.cpp, src/osgUI/Style.cpp,
	  src/osgUI/TabWidget.cpp, src/osgUI/Widget.cpp,
	  src/osgWrappers/serializers/osgUI/Tab.cpp,
	  src/osgWrappers/serializers/osgUI/Widget.cpp: Introduced
	  Widget::WidgetStateSet to help localize the StateSet set up by
	  Widget implementations from being serialized or
	  affecting what end users apply via the standard
	  Node::s/getStateSet().
	  
	  Further work on TabWidget.

2014-09-08 08:53  robert

	* examples/osgtransferfunction/TransferFunctionWidget.cpp: Build
	  fix

2014-09-05 16:04  robert

	* include/osgUI/TabWidget, src/osgUI/CMakeLists.txt,
	  src/osgUI/TabWidget.cpp,
	  src/osgWrappers/serializers/osgUI/Tab.cpp,
	  src/osgWrappers/serializers/osgUI/TabWidget.cpp: Added shell of
	  new osgUI::TabWidget class

2014-09-05 11:05  robert

	* include/osgDB/ObjectWrapper, include/osgDB/Serializer,
	  src/osgDB/ObjectWrapper.cpp,
	  src/osgWrappers/serializers/osgVolume/VolumeSettings.cpp:
	  Introduced support for specifying whether a serializer supports
	  different types of usage - one or more of READ_WRITE_PROPERTY,
	  GET_PROPERTY and SET_PROPERTY.

2014-09-03 15:54  robert

	* include/osgVolume/VolumeSettings,
	  src/osgPresentation/deprecated/SlideShowConstructor.cpp,
	  src/osgVolume/VolumeSettings.cpp,
	  src/osgWrappers/serializers/osgVolume/VolumeSettings.cpp: Added
	  setting of the IsoSurfaceProperty in VolumeSettings

2014-09-03 12:28  robert

	* include/osgUI/Callbacks, src/osgUI/Callbacks.cpp,
	  src/osgUI/Dialog.cpp, src/osgUI/PushButton.cpp: Added close
	  button on Dialog title bar

2014-09-02 17:01  robert

	* include/osgUI/ComboBox, src/osgUI/ComboBox.cpp: Refactored the
	  handling of ComboBox item picking to make it faster and more
	  reliable

2014-09-02 10:00  robert

	* src/osgUI/ComboBox.cpp: Improved handling of ComboBox popup
	  toggling

2014-09-02 09:14  robert

	* src/osgUI/Callbacks.cpp, src/osgUI/Widget.cpp: Added support for
	  scaling widgets via the scoll wheel.

2014-09-02 08:41  robert

	* src/osgGA/KeySwitchMatrixManipulator.cpp: Removed debugging
	  message

2014-09-01 19:13  robert

	* include/osgUI/Callbacks, include/osgUI/Widget,
	  src/osgUI/CMakeLists.txt, src/osgUI/Callbacks.cpp,
	  src/osgUI/Dialog.cpp, src/osgUI/LineEdit.cpp,
	  src/osgUI/Widget.cpp: Added DragCallback class to help dialog
	  dragging support.
	  Introduced a new
	  Widget::computeExtentsPositionInLocalCoordinates() method that
	  intersects with a ray through mouse pointer and the extents of
	  the widget.

2014-08-28 15:11  robert

	* src/osgVolume/MultipassTechnique.cpp: Improved support for
	  controlling the ShadingModel via the VolumeSettings object

2014-08-28 09:42  robert

	* src/osgPresentation/deprecated/SlideShowConstructor.cpp,
	  src/osgVolume/Property.cpp: Improved handling of VolumeSettings

2014-08-27 15:08  robert

	* src/osgPresentation/deprecated/SlideShowConstructor.cpp,
	  src/osgUI/Widget.cpp, src/osgVolume/Property.cpp,
	  src/osgWrappers/serializers/osgVolume/SampleRatioProperty.cpp:
	  Changed the osgUI behaviour so that events are set to be handled
	  by Widgets that have focus even if they don't directly use them.

2014-08-27 15:07  robert

	* src/osg/NodeVisitor.cpp: Changed the
	  NodeVisitor::apply(Drawable&) to call apply(Node&)

2014-08-27 09:25  robert

	* include/osgDB/Serializer,
	  src/osgWrappers/serializers/osgVolume/VolumeSettings.cpp: Added
	  support for getting osgVolumre::Property::ModifieCount

2014-08-25 16:56  robert

	* include/osgDB/Serializer, include/osgVolume/Property,
	  include/osgVolume/VolumeSettings, src/osgVolume/Property.cpp,
	  src/osgWrappers/serializers/osgVolume/Property.cpp,
	  src/osgWrappers/serializers/osgVolume/VolumeSettings.cpp: Added
	  Property::getModifiedCount() + dirty() to help with tracking
	  changes. Added VolumeSettings serializers for Property objects

2014-08-25 13:43  robert

	* include/osg/StateSet, src/osg/NodeVisitor.cpp,
	  src/osg/StateSet.cpp: Changed StateSet::ParentList from
	  vector<Object*> to vector<Node*> to reflect that Drawable is now
	  a Node.

2014-08-22 19:00  robert

	* include/osgUI/Style, src/osgUI/Popup.cpp, src/osgUI/Style.cpp:
	  Improved handling of setting of the depth of the UI.

2014-08-20 14:15  robert

	* src/osgUI/Style.cpp: Reordered method implemenations to make it
	  easier to compare similar methods

2014-08-19 16:58  robert

	* src/osgPresentation/deprecated/SlideShowConstructor.cpp: Added
	  toggling on/off of the VolumeSettings ui via the 'E' key.

2014-08-19 16:37  robert

	* src/osgPresentation/deprecated/SlideShowConstructor.cpp: Updated
	  VolumeSettings.lua reference to use ui prefix to work with the
	  new OpenSceneGraph-Data/ui/VolumeSettings.lua file.

2014-08-19 09:27  robert

	* src/osgPlugins/md2/ReaderWriterMD2.cpp: Fixed MD2 danglng pointer
	  crash.

2014-08-19 09:00  robert

	* examples/osgcallback/osgcallback.cpp: Fixed build

2014-08-19 08:57  robert

	* src/osgUI/Style.cpp: Fixed build

2014-08-14 19:00  robert

	* include/osgUI/ComboBox, src/osgUI/ComboBox.cpp,
	  src/osgWrappers/serializers/osgUI/ComboBox.cpp: Added support for
	  ComboBox::currentIndexChanged*(uint) callback API.

2014-08-13 09:24  robert

	* src/osgPresentation/deprecated/SlideShowConstructor.cpp: Resert
	  default value to 1.0

2014-08-08 16:42  robert

	* src/osgPlugins/txp/ReaderWriterTXP.cpp: From Ryan Kawicki, "There
	  is an issue where the model insets of a terrex terrain are being
	  removed during the loading process. The issue is described below.
	  
	  - the issue here is that the plugin is removing group nodes if
	  that group node only has one child. becuase transforms are also
	  group nodes, there were cases when the transform would have only
	  one child under it and would cause it to remove the translation
	  portion. this would cause all the vertex data to be loaded around
	  the last matrix operation, which in our case was the origin
	  (0,0,0).
	  
	  We work off of OSG 2.8.1 but see that this has not been addressed
	  on latest yet. I’ve tested this against 2.8.1 and have cleanly
	  applied it to my local repository off of latest."

2014-08-08 16:34  robert

	* src/osgUtil/RenderStage.cpp: From Tim George, "Currently there is
	  a problem with using a camera with a viewport with a non 0 offset
	  and also using an FBO. The problem is that only area made up of
	  the viewports width and height is drawn based on an offset of 0,0
	  instead of using the viewports offset.
	  
	  It is caused by line 991 in RenderStage.cpp:
	  
	  
	  Code:
	  fbo_ext->glBlitFramebuffer(
	  0, 0, static_cast<GLint>(_viewport->width()),
	  static_cast<GLint>(_viewport->height()),
	  0, 0, static_cast<GLint>(_viewport->width()),
	  static_cast<GLint>(_viewport->height()),
	  blitMask, GL_NEAREST);
	  
	  
	  
	  which is not taking into account the viewport x and y when
	  performing the blit. It probably should be:
	  
	  
	  Code:
	  fbo_ext->glBlitFramebuffer(
	  static_cast<GLint>(_viewport->x()),
	  static_cast<GLint>(_viewport->y()),
	  static_cast<GLint>(_viewport->width()) +
	  static_cast<GLint>(_viewport->x()),
	  static_cast<GLint>(_viewport->height()) +
	  static_cast<GLint>(_viewport->y()),
	  static_cast<GLint>(_viewport->x()),
	  static_cast<GLint>(_viewport->y()),
	  static_cast<GLint>(_viewport->width()) +
	  static_cast<GLint>(_viewport->x()),
	  static_cast<GLint>(_viewport->height()) +
	  static_cast<GLint>(_viewport->y()),
	  blitMask, GL_NEAREST);
	  "
	  
	  Note from Robert Osfield, made small tweak to above on merge,
	  changing the width+x to x+width to make it read more naturally.

2014-08-08 16:09  robert

	* src/osgUtil/MeshOptimizers.cpp: From Marc Helbling, "please find
	  a fix for the vertex pretransform visitor
	  (VertexAccessOrderVisitor).
	  The issue with current code is that arrays are collected *before*
	  duplicating shared arrays which leads to arrays that are
	  correctly duplicated but that are not reordered.
	  
	  Also the submitted patch contains a small cleaning in
	  GeometryArrayGathrer as the _useDrawElements variable is not
	  used; it is only set in the GeometryArrayGathrer constructor and
	  VertexAccessOrderVisitor already checks that primitives have
	  indexed type."

2014-08-08 15:45  robert

	* include/osg/Node: From Glen Waldron, "Node: patch for
	  remove*Callback() methods to resolve a crash"

2014-08-08 09:28  robert

	* CMakeLists.txt, include/osg/Texture: Changes to support building
	  against ANDROID under OSX.

2014-08-05 18:32  robert

	* include/osg/Callback, include/osgUI/LineEdit,
	  include/osgUI/Validator, src/osgUI/CMakeLists.txt,
	  src/osgUI/LineEdit.cpp, src/osgUI/Validator.cpp,
	  src/osgWrappers/serializers/osgUI/DoubleValidator.cpp,
	  src/osgWrappers/serializers/osgUI/IntValidator.cpp,
	  src/osgWrappers/serializers/osgUI/LineEdit.cpp,
	  src/osgWrappers/serializers/osgUI/Validator.cpp: Implemented
	  osgUI::Validator, IntValidator and DoubleValidator classes that
	  manage validation/specialization of LineEdit widgets to work with
	  just integer or double values.

2014-08-01 13:07  robert

	* include/osgUI/LineEdit, src/osgUI/LineEdit.cpp: Implemented
	  callbacks for validate(), textChanged() and returnPressed()

2014-08-01 10:57  robert

	* src/osgUI/ComboBox.cpp, src/osgUI/LineEdit.cpp,
	  src/osgUI/PushButton.cpp, src/osgUI/Widget.cpp: Moved
	  responsiblity for checking current event focus onto
	  Widget::handleImplementations().
	  
	  Added support for closing CombinBox popup when the mouse is
	  clicked outside the popup or combobox widget.

2014-07-31 18:29  robert

	* include/osg/NodeVisitor, src/osgUI/Widget.cpp,
	  src/osgUtil/CullVisitor.cpp, src/osgUtil/IntersectVisitor.cpp,
	  src/osgUtil/IntersectionVisitor.cpp,
	  src/osgUtil/UpdateVisitor.cpp,
	  src/osgWrappers/serializers/osg/NodeVisitor.cpp: Added
	  NodeVisitor::INTERSECTION_VISITOR VisitorType

2014-07-30 12:48  robert

	* include/osgUI/Style, src/osgUI/ComboBox.cpp,
	  src/osgUI/Dialog.cpp, src/osgUI/Popup.cpp, src/osgUI/Style.cpp:
	  Fixed rendering of Popups

2014-07-30 12:47  robert

	* CMakeLists.txt: Update SO version to account for new changes to
	  osg::StateSet and osgUI

2014-07-30 12:47  robert

	* include/osg/StateSet, include/osg/Version,
	  include/osgUtil/CullVisitor,
	  src/osgWrappers/serializers/osg/StateSet.cpp: Added
	  StateSet::RenderBinMode::PROTECTED_RENDERBIN_DETAILS and
	  OVERRIDE_PROTECTED_RENDERBIN_DETAILS options.

2014-07-29 15:50  robert

	* include/osgUI/ComboBox, src/osgUI/ComboBox.cpp: Added preliminary
	  icon to ComboBox.

2014-07-29 15:50  robert

	* src/osgUI/LineEdit.cpp: Fixed debug comment

2014-07-29 15:50  robert

	* include/osgUI/Style, src/osgUI/Style.cpp: Implemented prelimary
	  icon support allowing UI widget to place image and model based
	  icons on widgets

2014-07-29 15:47  robert

	* src/osgUtil/Optimizer.cpp: Added catch for NULL Transform
	  pointers getting into the _transformMap.

2014-07-28 16:19  robert

	* include/osg/ComputeBoundsVisitor,
	  src/osg/ComputeBoundsVisitor.cpp: Added handling of Drawables
	  added directly to scene graph without Geode decorating them.

2014-07-24 14:14  robert

	* include/osgUI/LineEdit, src/osgUI/LineEdit.cpp,
	  src/osgUI/PushButton.cpp: Added support for changing background
	  colour of LineEdit widget when focus changes

2014-07-24 13:25  robert

	* src/osgUI/ComboBox.cpp, src/osgUI/Dialog.cpp,
	  src/osgUI/LineEdit.cpp, src/osgUI/PushButton.cpp: Refined the
	  colouring of widget to be more in sync with the defaults used in
	  Qt.

2014-07-23 16:36  robert

	* include/osgVolume/VolumeSettings,
	  src/osgPlugins/p3d/ReaderWriterP3D.cpp,
	  src/osgVolume/VolumeSettings.cpp,
	  src/osgWrappers/serializers/osgVolume/VolumeSettings.cpp: Added
	  VolumeSettings::Filename property.

2014-07-23 15:57  robert

	* src/osgUI/Style.cpp: Changed the default text colour to black

2014-07-23 14:50  robert

	* src/osgPlugins/lua/LuaScriptEngine.cpp: Added writeFile support

2014-07-23 10:49  robert

	* src/osgPlugins/lua/LuaScriptEngine.cpp: Added
	  Node:getNumParents() and Node:getParent(index) support

2014-07-22 16:02  robert

	* CMakeLists.txt, include/osg/State, include/osg/Version,
	  src/osg/State.cpp, src/osgUtil/SceneView.cpp: Removed
	  State::AppliedProgramObjectSet container and Obsever usage from
	  osg::State to address threading bug crash.
	  
	  The State::AppliedProgramObjectSet wasn't ever being used
	  actively in the current rev of the OSG so populating and clearing
	  was no longer neccessary, allowing the code to be removed
	  completely.

2014-07-21 16:36  robert

	* applications/osgviewer/osgviewer.cpp, include/osg/Types,
	  src/osgPlugins/ktx/ReaderWriterKTX.h,
	  src/osgPlugins/osg/BinaryStreamOperator.h,
	  src/osgPlugins/pvr/ReaderWriterPVR.cpp: Centralized the calling
	  of #include <stdint.h> and VS fallback into include/osg/Types
	  header

2014-07-21 14:32  robert

	* src/osgUtil/CullVisitor.cpp: From Pjotr Svetachov, "I think I
	  spotted some unneeded ref_ptrs in the cullvisitor. The call
	  pushModelViewMatrix or pushProjectionMatrix will already keep the
	  reference when adding it to the MatrixStack. In
	  CullVisitor::apply
	  methods for the billboard and the camera you already take a
	  pointer
	  instead of a ref_ptr."

2014-07-21 13:45  robert

	* src/osgText/Glyph.cpp: Added setting of glPixelStore before
	  glTexSubImage2D call.

2014-07-21 13:43  robert

	* src/osgText/Glyph.cpp: From Jaap Gas, "I want to submit a bugfix
	  for a crash occurring in osgText/Glyph.cpp if
	  the scene tree contains (large) 2D textures from images with
	  STRIDE.
	  
	  ============================================================================
	  #0 0x00007fffe8ea4350 in __memmove_ssse3 () from /lib64/libc.so.6
	  #1 0x00007fffe52ced76 in ?? () from
	  /usr/lib64/libnvidia-glcore.so.310.44
	  #2 0x00007fffe52d8e86 in ?? () from
	  /usr/lib64/libnvidia-glcore.so.310.44
	  #3 0x00007fffe53dd8be in ?? () from
	  /usr/lib64/libnvidia-glcore.so.310.44
	  #4 0x00007fffe53c2643 in ?? () from
	  /usr/lib64/libnvidia-glcore.so.310.44
	  #5 0x00007fffe53c7fdd in ?? () from
	  /usr/lib64/libnvidia-glcore.so.310.44
	  #6 0x00007fffe53cbabf in ?? () from
	  /usr/lib64/libnvidia-glcore.so.310.44
	  #7 0x00007fffe53cc1fa in ?? () from
	  /usr/lib64/libnvidia-glcore.so.310.44
	  #8 0x00007ffff30092fd in osgText::GlyphTexture::apply
	  (this=0x1bb8cf0, state=
	  ...)
	  at
	  /d43/jaap/dev/jaapOSG/build/OpenSceneGraph3.3.1/src/osgText/Glyph.cpp:234
	  #9 0x00007ffff56c30b6 in osg::State::applyAttributeOnTexUnit
	  (this=0x125f180,
	  unit=0, attribute=0x1bb8cf0, as=...)
	  at
	  /d43/jaap/dev/jaapOSG/build/OpenSceneGraph3.3.1/include/osg/State:1713
	  #10 0x00007ffff56c2f3f in osg::State::applyTextureAttribute
	  (this=0x125f180,
	  unit=0, attribute=0x1bb8cf0)
	  at
	  /d43/jaap/dev/jaapOSG/build/OpenSceneGraph3.3.1/include/osg/State:411
	  #11 0x00007ffff30204da in osgText::Text::drawTextWithBackdrop
	  (this=0x1baed70,
	  state=..., colorMultiplier=...)
	  ==============================================================================
	  
	  The crash disappears if I either (1) disable the use of images
	  with stride
	  in the (public) osgGeo-library, or (2) add the following bugfix
	  to Glyph.cpp.
	  This combination gives me the confidence that I understand where
	  this problem
	  originates from, without trying to understand the full OpenGL
	  details.
	  
	  ===============================================================================
	  @@ -221,7 +223,12 @@
	  imageData[i] = 0;
	  }
	  
	  + glPixelStorei(GL_UNPACK_ALIGNMENT,1);
	  
	  + #if !defined(OSG_GLES1_AVAILABLE) &&
	  !defined(OSG_GLES2_AVAILABLE)
	  + glPixelStorei(GL_UNPACK_ROW_LENGTH,getTextureWidth());
	  + #endif
	  +
	  // allocate the texture memory.
	  glTexImage2D( GL_TEXTURE_2D, 0, GL_ALPHA,
	  getTextureWidth(), getTextureHeight(), 0,
	  ================================================================================
	  
	  I have copied (and adapted) the added lines above from the same
	  source file,
	  where they were used in front of a similar call to
	  glTexSubImage2D(.) around
	  line 515.
	  "

2014-07-21 12:21  robert

	* src/osgPresentation/CMakeLists.txt,
	  src/osgPresentation/deprecated/SlideShowConstructor.cpp: Initial
	  work on integtasting osgUI into Present3D

2014-07-21 12:18  robert

	* include/osg/NodeVisitor: Fixed indentation

2014-07-21 09:35  robert

	* src/osgUI/Style.cpp: Added debug messages

2014-07-18 17:17  robert

	* src/osgWrappers/serializers/CMakeLists.txt,
	  src/osgWrappers/serializers/osg/NodeVisitor.cpp,
	  src/osgWrappers/serializers/osgGA/EventVisitor.cpp,
	  src/osgWrappers/serializers/osgUtil,
	  src/osgWrappers/serializers/osgUtil/CMakeLists.txt,
	  src/osgWrappers/serializers/osgUtil/CullVisitor.cpp,
	  src/osgWrappers/serializers/osgUtil/UpdateVisitor.cpp: Added
	  serailizer support for NodeVisitor, UpdateVisitor, CullVisitor
	  and EventVisitor

2014-07-14 15:59  robert

	* examples/osgpresentation/osgpresentation.cpp,
	  include/osgDB/Callbacks, include/osgDB/ReadFile,
	  include/osgDB/ReaderWriter, include/osgDB/Registry,
	  include/osgDB/WriteFile, src/osgDB/Callbacks.cpp,
	  src/osgDB/ReadFile.cpp, src/osgDB/ReaderWriter.cpp,
	  src/osgDB/Registry.cpp, src/osgDB/WriteFile.cpp,
	  src/osgPlugins/V8/ReaderWriterV8.cpp,
	  src/osgPlugins/lua/ReaderWriterLua.cpp,
	  src/osgPlugins/python/ReaderWriterPython.cpp: Added
	  readScript/writeScript methods to ReaderWriter

2014-07-14 14:09  robert

	* CMakeLists.txt, examples/osgpresentation/osgpresentation.cpp,
	  include/osg/Version, include/osgDB/ClassInterface,
	  include/osgDB/PropertyInterface, src/osgDB/CMakeLists.txt,
	  src/osgDB/ClassInterface.cpp, src/osgDB/PropertyInterface.cpp,
	  src/osgPlugins/lua/LuaScriptEngine.cpp,
	  src/osgPlugins/lua/LuaScriptEngine.h: Renamed
	  osgDB::PropertyInterface to osgDB::ClassInterface to better
	  reflect it's functionality

2014-07-04 16:45  robert

	* include/osgPresentation/deprecated/SlideShowConstructor,
	  include/osgVolume/Property, include/osgVolume/VolumeSettings,
	  src/osgPlugins/p3d/ReaderWriterP3D.cpp,
	  src/osgPresentation/deprecated/SlideShowConstructor.cpp,
	  src/osgVolume/Property.cpp, src/osgVolume/VolumeSettings.cpp:
	  Added preliminary support for writing VolumeSettings to disk from
	  within Present3D in response to pressing and releasing 'Ctrl-S'.

2014-07-03 16:36  robert

	* src/osgVolume/Shaders/volume_accumulateSamples_iso_frag.cpp,
	  src/osgVolume/Shaders/volume_accumulateSamples_mip_frag.cpp:
	  Updated iso and mip shaders from OpenSceneGraph-Data.

2014-07-03 13:06  robert

	* src/osgPlugins/osc/OscSendingDevice.cpp,
	  src/osgPresentation/deprecated/PropertyManager.cpp: Added virtual
	  destructors

2014-07-03 13:05  robert

	* src/osgPlugins/osc/OscSendingDevice.cpp: Fixed line endings

2014-07-03 13:01  robert

	* include/osgPresentation/deprecated/SlideShowConstructor,
	  src/osgPlugins/p3d/ReaderWriterP3D.cpp,
	  src/osgPresentation/deprecated/SlideShowConstructor.cpp: Changed
	  enum usage to use the new osgVolume::VolumeSettings versions and
	  added support for reading a VolumeSettings file.

2014-07-03 10:01  robert

	* include/osgVolume/VolumeSettings,
	  src/osgVolume/VolumeSettings.cpp: Refactor VolumeSettings so that
	  it's subclassed from osgVolume::Property

2014-07-02 16:26  robert

	* include/osgVolume/VolumeSettings,
	  src/osgPlugins/dds/ReaderWriterDDS.cpp,
	  src/osgVolume/CMakeLists.txt, src/osgVolume/VolumeSettings.cpp,
	  src/osgWrappers/serializers/osgVolume/VolumeSettings.cpp: Added
	  osgVolume::VolumeSettings object

2014-07-02 15:34  robert

	* examples/osgvolume/osgvolume.cpp: Changed the default image
	  output format to .osgb as .dds isn't able to represent signed
	  byte, short and int data correctly.

2014-07-02 14:14  robert

	* src/osgPlugins/osg/ReaderWriterOSG2.cpp: fixed handlng of file
	  type of nested files within a .osgx, .osgt and .osgb file.

2014-07-02 10:25  robert

	* include/osgViewer/ViewerEventHandlers: From Laurens Voerman,
	  "just like ClusterCullingCallback (fixed in r14322) visual studio
	  likes an explicit implementation of run() for
	  InteractiveImageHandler.
	  
	  The warning is (14 times):
	  include\osgViewer/ViewerEventHandlers(542): warning C4250:
	  'osgViewer::InteractiveImageHandler' : inherits
	  'osgGA::EventHandler::osgGA::EventHandler::run' via dominance
	  (src\osgViewer\StatsHandler.cpp)
	  include\osgGA/EventHandler(45) : see declaration of
	  'osgGA::EventHandler::run'
	  
	  
	  attached a zipped version of
	  include\osgViewer\ViewerEventHandlers"

2014-07-01 07:31  robert

	* applications/osgviewer/osgviewer.cpp: Added #include <stdint.h>
	  to address compile issue on some Linux distro's.

2014-06-30 15:31  robert

	* examples/osgvolume/osgvolume.cpp: Add dds no flip on write option
	  to prevent output of .dds volume from being flipped by the dds
	  plugin.

2014-06-30 13:24  robert

	* src/osgPlugins/3ds/WriterNodeVisitor.cpp: REmoved debug cout

2014-06-30 10:13  robert

	* include/osgUtil/StateGraph: From Mikhail Izmestev, "Attached fix
	  to avoid vector reallocs on push_back in
	  StateGraph::moveStateGraph."

2014-06-30 09:12  robert

	* AUTHORS.txt, ChangeLog: Updated ChangeLog and AUTHORS file

2014-06-30 08:56  robert

	* CMakeLists.txt, include/osg/Version: Updated version number

2014-06-30 08:46  robert

	* include/osg/Image: From Pjotr Svetachov, "Here is a small fix for
	  a overflow when editing large 3d volume data."

2014-06-30 08:20  robert

	* src/osgPlugins/svg/ReaderWriterSVG.cpp: Removed space from
	  #include.

2014-06-30 07:37  robert

	* src/osgPlugins/svg/ReaderWriterSVG.cpp: From Alexander
	  Sinditskiy, build fix to allow building against versions older
	  than librsvg-2.36.2

2014-06-28 06:22  robert

	* include/osg/ClusterCullingCallback: Replaced using
	  NodeCallback::run with explict run() implementation.

2014-06-27 15:57  robert

	* src/osgPlugins/ive/DataOutputStream.cpp: From Pjotr Svetachov, "I
	  made a small change to DataOutputStream.cpp which makes saving
	  Geodes possible again. This is only half a fix as it only will
	  save a Drawable that is part of a Geode. But this change does not
	  require a version bump of the .ive format. I tried it with a few
	  datasets we have here with the 3.2 stable branch and the trunk
	  with this patch and there was no difference in the .ive files
	  that were produced."

2014-06-27 15:55  robert

	* src/osgUtil/DelaunayTriangulator.cpp: Removed unused method.

2014-06-27 15:48  robert

	* src/osgUtil/Tessellator.cpp: From Laurens Voerman, "attached is a
	  modified version of src/osgUtil/Tessellator.cpp
	  current code checks for a Nullpointer and on notify level info or
	  above will inform you with a crash, by dereferencing it."

2014-06-27 15:39  robert

	* AUTHORS.txt: Updated AUTHORS file

2014-06-27 15:38  robert

	* src/osg/ApplicationUsage.cpp: Added an OSG_INIT_SINGLETON_PROXY
	  to make sure that the ApplicationUsage singleton gets intialized
	  before usage.

2014-06-27 15:36  robert

	* AUTHORS.txt: Updated AUTHORS file

2014-06-27 15:30  robert

	* include/osg/Camera, src/osg/GraphicsContext.cpp,
	  src/osgViewer/CompositeViewer.cpp, src/osgViewer/Viewer.cpp:
	  Added a render order sort to the list of Cameras being tested by
	  the *Viewer::generatePointerData(..) method to ensure that the
	  highest Camera gets focus.

2014-06-26 15:54  robert

	* ChangeLog: Update ChangeLog for dev release

2014-06-26 14:16  robert

	* include/osg/KdTree, include/osg/NodeVisitor, src/osg/KdTree.cpp:
	  Revised KdTreeBuilder so that is used the new
	  apply(osg::Geometry&) method rather than expanding an osg::Geode.

2014-06-26 11:49  robert

	* src/osg/Sequence.cpp: From Sebastian Messerschmidt, "I've applied
	  a simple fix for the backward animation support in osg::Sequence.
	  It will simply use the sign of the speed set in the getNextValue.
	  Attached file is against trunk."

2014-06-26 11:11  robert

	* src/osgDB/Registry.cpp: From Lauren Voerman, "In order to speed
	  up loading large scenes (especially from network disk) I added
	  code to our viewer to setup multiple database-pagers and request
	  the files trough a database-request:
	  databasePager->setUpThreads(16, 1);
	  
	  We experienced problems with multiple databasepagers loading
	  files in parallel, when two threads start to load the same file
	  (usually a texture referenced by multiple models). The second
	  thread to add the file to the cache (sometimes) manages to do so
	  while the refcount from the cached object still is zero, causing
	  the object loaded to be destroyed.
	  Sometimes the second thread manages to ref() the object before
	  Referenced::signalObserversAndDelete does the final recount
	  check, causing a warning:
	  "Warning Referenced::signalObserversAndDelete(,,) doing delete
	  with _refCount=1"
	  
	  With a deleted object added to the scenegraph we get some
	  undesired results, I think the program only crashes if the object
	  was a Node, and just has some untextured surfaces if it was a
	  texture, but I'm not completely sure.
	  
	  Attached is a modified version of the Registry.cpp, returning the
	  object in cache and let the duplicate loaded object to be
	  destroyed.
	  
	  A more efficient option would be to add some sort of blocking
	  entry to the objectcache to stop the second thread from reading
	  the file, and just wait until the first thread added it to the
	  cache. If you think that's worthwile we would be happy to
	  implement that version. A bit tricky to implement and test,
	  that's why I submit a simple version that stops my program from
	  crashing."

2014-06-26 11:09  robert

	* src/osgDB/Registry.cpp: Removed erroneous character

2014-06-26 10:53  robert

	* src/osgText/Text3D.cpp, src/osgText/TextBase.cpp: From Farshid
	  Lashkari,
	  "I noticed that Text3D objects would change there z alignment
	  depending on the alignment mode. I'm not sure if this was
	  intentional or just a simple mistake. My expectation was that the
	  front of the object would always stay aligned to the 0 z-plane,
	  regardless of the alignment mode. I've attached an updated
	  version that retains a consistent z-alignment."
	  "I just now noticed another issue with Text3D objects. It was not
	  properly computing the bounding box when non-axis aligned
	  rotations were being applied. In this case all corners of the
	  bounding box need to be transformed in order to get the correct
	  containing box. I've attached the updated file."
	  "The incorrect bounding box problem also applies to regular Text
	  objects. I've attached the fix for that as well as the original
	  Text3D fix."

2014-06-26 10:45  robert

	* include/osgAnimation/Interpolator,
	  src/osgAnimation/StackedTransform.cpp,
	  src/osgAnimation/UpdateBone.cpp: From Pjotr Svetachov, "For a
	  scene with a lot of animated agents I did some small
	  optimizations to reduce cpu overhead:
	  1) Avoid a load-hit-store in UpdateBone.
	  b->getMatrixInBoneSpace()
	  returns the same matrix that was just stored with b->setMatrix()
	  2) Avoid calling element->isIdentity() for the whole transform
	  stack
	  (can be expensive is element is a matrix)
	  3) Make the key frame interpolator use binary search instead of a
	  linear one. This is very noticeable in scenes where some geometry
	  has
	  long repeating animations that start at the same time, you will
	  see
	  the update time grow then reset and grow again."

2014-06-26 10:24  robert

	* src/osg/ImageSequence.cpp: From Laurens Voerman, "while debugging
	  ImageSequence I had a crash, due to the very large frametimes
	  caused by halting the program. The problem is that when the frame
	  time exceeds the length of the entire image sequence, a looping
	  sequence will try to read it's _imageDataList beyond its size.
	  fix attached for src/osg/ImageSequence.cpp"

2014-06-26 10:05  robert

	* src/osgPlugins/ive/ImageSequence.cpp,
	  src/osgWrappers/deprecated-dotosg/osg/ImageSequence.cpp,
	  src/osgWrappers/serializers/osg/ImageSequence.cpp: From Laurens
	  Voerman, "while testing databasepager stuff I noticed that the
	  various loaders (osg/ive/osgx) do not pass the current options to
	  the imagePager, therefore the images cannot be found if not in
	  the global OSG_FILE_PATH. Attached is a fix, containing modified
	  versions of
	  
	  From Robert Osfield, add check to only apply Options object when
	  a valid Option object is assigned.

2014-06-26 09:38  robert

	* src/osgPlugins/ply/plyfile.cpp: From Farshid Lashkari, "I've
	  attached a small fix for the ply loader to support Windows style
	  line endings when reading the header."

2014-06-26 09:33  robert

	* src/osgPlugins/osg/BinaryStreamOperator.h,
	  src/osgPlugins/osga/OSGA_Archive.cpp: From Aurelien Albert, "This
	  submission fix all my problems with reading / writing "osgb"
	  files inside "osga" archive with final archive size > 2 Go, with
	  Windows OS (didn't tested with Linux)"

2014-06-25 16:05  robert

	* src/osgDB/Registry.cpp: From Riccardo Corsi, "there's an
	  inconsistency between the behavior of the method and the
	  debug message it prints out on the console.
	  
	  Around line 1040 of Registry.cpp (see code below) the method
	  returns
	  "simpleFileName" but prints about returning "filename".
	  
	  In attachment the modified file, based on osg 3.2.0
	  ricky
	  
	  
	  <code>
	  if(fileExists(simpleFileName))
	  {
	  OSG_DEBUG << "FindFileInPath(" << filename << "): returning " <<
	  filename << std::endl;
	  return simpleFileName;
	  }
	  </code>
	  "

2014-06-25 15:55  robert

	* src/osgPlugins/3ds/ReaderWriter3DS.cpp,
	  src/osgPlugins/3ds/WriterNodeVisitor.cpp,
	  src/osgPlugins/3ds/WriterNodeVisitor.h: From Auelien Albert, "I'm
	  working on an application which use 3ds file format as input and
	  use the name of the material to "map" specific data with 3d
	  geometry.
	  
	  The osg 3ds plugin modify the exported materials name in the same
	  way it modifies the node names.
	  
	  I've added an option to preserve originals materials names, with
	  the assurance of unique material names are preserved."

2014-06-25 15:47  robert

	* src/osg/CollectOccludersVisitor.cpp: Refactored the way that hole
	  are pruned from the occluder hole list.

2014-06-25 11:07  robert

	* applications/osgconv/osgconv.cpp: From Laurens Voerman, "a minor
	  patch for osgconv to make sure the helptext is printed if you run
	  "osgconv -h" with OSG_NOTIFY_LEVEL set too low.
	  applys to both trunk and stable branch."

2014-06-25 10:45  robert

	* src/osgUtil/StateGraph.cpp: From Mikhail Izmestev, "Attached fix
	  to avoid vector usage in StateGraph::prune and reduce heap
	  allocations."
	  
	  Notes from Robert Osfield, ammended the erase so that it
	  explictly increments the iterator before the erase call.

2014-06-25 09:58  robert

	* src/osg/Texture.cpp: changed debug message to use OSG_DEBUG

2014-06-25 09:57  robert

	* include/osg/Texture, src/osg/Texture.cpp: From Alexander
	  Sinditskiy, "My changes added support for gltexstorrage2d for
	  texture2d.
	  
	  Initially I described issue in message:
	  http://forum.openscenegraph.org/viewtopic.php?t=13820
	  It solves issue with compiling texture using ico from image with
	  mipmaps
	  
	  I added enviroment variable OSG_GL_TEXTURE_STORAGE_ENABLE to
	  control usage of glTexStorage2d. Initially it is disabled.
	  
	  It used only if image have mipmaps.
	  
	  Another issue is converting from internalFormat + type to sized
	  internal format. I created sizedInternalFormats[] struct where
	  sized internal formats are ordered from worse->best.
	  also this struct have commented lines. Commented formats are
	  listed in
	  http://www.opengl.org/wiki/GLAPI/glTexStorage2D
	  but looks like not using in osg."
	  
	  Note from Robert Osfield. Changed the env var control to
	  OSG_GL_TEXTURE_STORAGE and made it's value true by default when
	  the feature is supported by the OpenGL driver. To disable to
	  use of glTexStorage2D use OSG_GL_TEXTURE_STORAGE="OFF" or
	  "DISABLE"

2014-06-25 08:21  robert

	* include/osg/Math: From Björn Blissing, "I found a minor error in
	  documentation in include/osg/Math.
	  Function: absolute() had the same description as the function
	  minimum()
	  
	  I removed the erroneous text."

2014-06-25 08:18  robert

	* src/osgPlugins/fbx/fbxMaterialToOsgStateSet.cpp: From Björn
	  Blissing, "Fix to support correct shininess and transparency in
	  FBX plugin"

2014-06-24 19:57  robert

	* src/osgDB/ObjectWrapper.cpp: From Pjotr Svetachov, "There were
	  some modes missing when exporting to .ogst so I added them."

2014-06-24 14:58  robert

	* src/osgPlugins/osg/ReaderWriterOSG2.cpp: From Farshid Lashkari,
	  "I've attached a small for the osg ReaderWriter. It was
	  performing a case sensitive comparison to the file extension to
	  determine whether to write the file in ascii or binary. This
	  meant that if the filename was "model.OSGT" it would be treated
	  as binary, instead of ascii. I've updated the plugin to ignore
	  case."

2014-06-24 11:24  robert

	* src/osgUtil/Optimizer.cpp: Merged fix to merge geometries.

2014-06-23 12:02  robert

	* src/osg/Callback.cpp: Fixed nested callback calling.

2014-06-16 16:16  robert

	* src/osgUtil/Optimizer.cpp: Fixed check against totaly number of
	  vertices

2014-06-16 08:54  robert

	* src/osgPlugins/osg/BinaryStreamOperator.h: From Aurelien Albert,
	  "I've got some issues using osgb files within an big osga archive
	  (file size > 2Go).
	  
	  Issue is described here :
	  http://forum.openscenegraph.org/viewtopic.php?t=13914
	  
	  Here is a fix, using "std::streampos" standard type for stream
	  positions up to 64bits.
	  "

2014-06-13 17:17  robert

	* include/osgUI/ColorPalette, src/osgUI/CMakeLists.txt,
	  src/osgUI/ColorPalette.cpp,
	  src/osgWrappers/serializers/osgUI/ColorPalette.cpp: Added
	  osgUI::ColorPalette class

2014-06-13 17:16  robert

	* include/osgUI/AlignmentSettings: Fixed typo in parameter name

2014-06-12 16:00  robert

	* src/osgViewer/GraphicsWindowX11.cpp: Removed generation of scroll
	  event on the X11 button release event as X11 was generating both
	  a pair of press/release events for a single scroll when movement.

2014-06-12 15:24  robert

	* src/osg/State.cpp: Added if () blocks to
	  State::convertVertexShaderSourceToOsgBuiltIns() to ensure that
	  only parts of the shader than need replacing are replaced.

2014-06-12 14:12  robert

	* src/osgUI/ComboBox.cpp: Improved positioning of combo box popup
	  items

2014-06-12 14:05  robert

	* src/osgUI/ComboBox.cpp, src/osgUI/Style.cpp: Added frame support
	  to ComboBox.
	  
	  Improved the alingment support for text

2014-06-11 16:31  robert

	* src/osgUI/Style.cpp: Added handling of AligmentSettings of Text
	  layout

2014-06-11 10:55  robert

	* include/osgUI/Widget, src/osgUI/ComboBox.cpp,
	  src/osgUI/Popup.cpp, src/osgUI/Style.cpp, src/osgUI/Widget.cpp:
	  Implemented more robust intersection handling for mouse
	  interactions. Wired up even handling of ComboBox popup.

2014-06-10 08:50  robert

	* include/osg/Drawable: Added using Callback::run() method to
	  Drawable::CullCallback

2014-06-09 13:46  robert

	* include/osgGA/EventVisitor: Fixed handling of Drawable callbacks
	  and NumChildrenRequiringEventTraversal

2014-06-06 15:05  robert

	* include/osg/NodeVisitor, include/osgViewer/ViewerEventHandlers:
	  Removed redudent NodeVisitor::s/getUserData() as osg::Object
	  provide this.
	  
	  Added using run entry to InteractiveImageHandler to quieten
	  warning

2014-06-06 09:12  robert

	* include/osg/ClusterCullingCallback: Added using
	  NodeCallback::run() to avoid warnings

2014-06-06 09:01  robert

	* include/osg/Callback, include/osg/StateSet: Added missing
	  OSG_EXPORT

2014-06-05 16:26  robert

	* examples/osgfpdepth/osgfpdepth.cpp,
	  examples/osgposter/PosterPrinter.h,
	  examples/osgvertexprogram/osgvertexprogram.cpp,
	  include/osg/AnimationPath, include/osg/Callback,
	  include/osg/ClusterCullingCallback, include/osg/CopyOp,
	  include/osg/Drawable, include/osg/Node, include/osg/NodeCallback,
	  include/osg/NodeTrackerCallback, include/osg/ScriptEngine,
	  include/osg/StateAttribute, include/osg/StateAttributeCallback,
	  include/osg/StateSet, include/osgAnimation/Skeleton,
	  include/osgAnimation/UpdateMatrixTransform,
	  include/osgGA/EventHandler, include/osgGA/EventVisitor,
	  include/osgGA/GUIEventHandler,
	  include/osgPresentation/deprecated/AnimationMaterial,
	  include/osgPresentation/deprecated/PropertyManager,
	  include/osgShadow/MinimalDrawBoundsShadowMap,
	  include/osgUtil/CullVisitor, include/osgUtil/TransformCallback,
	  include/osgUtil/UpdateVisitor,
	  include/osgViewer/ViewerEventHandlers,
	  include/osgVolume/Property, src/osg/CMakeLists.txt,
	  src/osg/Callback.cpp, src/osg/CopyOp.cpp, src/osg/Drawable.cpp,
	  src/osg/Node.cpp, src/osg/NodeCallback.cpp,
	  src/osg/ScriptEngine.cpp, src/osg/StateAttribute.cpp,
	  src/osg/StateSet.cpp, src/osgAnimation/AnimationManagerBase.cpp,
	  src/osgAnimation/LinkVisitor.cpp,
	  src/osgAnimation/StatsHandler.cpp,
	  src/osgGA/CameraManipulator.cpp,
	  src/osgGA/FirstPersonManipulator.cpp,
	  src/osgGA/FlightManipulator.cpp,
	  src/osgGA/MultiTouchTrackballManipulator.cpp,
	  src/osgGA/NodeTrackerManipulator.cpp,
	  src/osgGA/OrbitManipulator.cpp,
	  src/osgGA/StandardManipulator.cpp,
	  src/osgGA/TerrainManipulator.cpp,
	  src/osgGA/TrackballManipulator.cpp,
	  src/osgPlugins/bvh/ReaderWriterBVH.cpp,
	  src/osgPlugins/dae/daeRAnimations.cpp,
	  src/osgPlugins/dae/daeRTransforms.cpp,
	  src/osgPlugins/dae/daeReader.h,
	  src/osgPlugins/dae/daeWAnimations.cpp,
	  src/osgPlugins/dae/daeWTransforms.cpp,
	  src/osgPlugins/dae/daeWriter.h, src/osgPlugins/txp/TXPNode.h,
	  src/osgUtil/CullVisitor.cpp, src/osgUtil/SceneView.cpp,
	  src/osgWrappers/deprecated-dotosg/osg/NodeCallback.cpp,
	  src/osgWrappers/serializers/osg/Callback.cpp,
	  src/osgWrappers/serializers/osg/Drawable.cpp,
	  src/osgWrappers/serializers/osg/Node.cpp,
	  src/osgWrappers/serializers/osg/NodeCallback.cpp: Refactored
	  Callback system in osg::Node, osg::Drawable, osg::StateSet and
	  osg::StateAttribute to use a new osg::Callback base class.

2014-06-04 08:59  robert

	* src/osgVolume/Shaders/volume_accumulateSamples_lit_frag.cpp,
	  src/osgVolume/Shaders/volume_accumulateSamples_lit_tf_frag.cpp,
	  src/osgVolume/Shaders/volume_accumulateSamples_mip_frag.cpp,
	  src/osgVolume/Shaders/volume_accumulateSamples_standard_frag.cpp,
	  src/osgVolume/Shaders/volume_multipass_vert.cpp: Updated shaders
	  from OpenSceneGraph-Data sources

2014-06-03 15:05  robert

	* examples/osgcallback/osgcallback.cpp: From Pjotr Sventachov and
	  Robert Osfield, added callback unit test to osgcallback example,
	  to use test run osgcallback --test, if everything is functioning
	  then test1 to test7 messages should be reported to the console.

2014-06-03 09:52  robert

	* examples/osgkeyboardmouse/osgkeyboardmouse.cpp,
	  examples/osgparticleeffects/osgparticleeffects.cpp,
	  include/osg/Node, src/osg/Node.cpp,
	  src/osgPlugins/txp/TXPParser.cpp, src/osgUtil/Optimizer.cpp:
	  Reverted change of Node::ParentList from being a vector<Node*>
	  back to a vector<Group*>

2014-06-03 09:23  robert

	* include/osg/Drawable, include/osg/Geode, src/osg/Billboard.cpp,
	  src/osg/Geode.cpp, src/osg/Group.cpp,
	  src/osgPlugins/pov/POVWriterNodeVisitor.cpp,
	  src/osgShadow/DebugShadowMap.cpp, src/osgSim/ScalarBar.cpp,
	  src/osgSim/SphereSegment.cpp, src/osgUtil/Optimizer.cpp: Refactor
	  osg::Geode to subclass from osg::Group and reuse the NodeList
	  children container

2014-06-02 16:20  robert

	* CMakeLists.txt, include/osg/BoundingSphere, include/osg/Drawable,
	  include/osg/Node, include/osg/Plane, include/osg/Polytope,
	  src/osg/Config.in, src/osg/Node.cpp: Removed OSG_USE_BOUND and
	  associated osg::Bound adapter class to avoid problems with
	  BoundingBox::expandBy/expandByRadius() implementation choosing a
	  null BoundingBox from
	  the osg::Bound class causing crashes.

2014-06-02 08:13  robert

	* CMakeLists.txt: From Roni Zanolli, build fix for iPhone

2014-05-30 16:44  robert

	* include/osgUI/Style, src/osgUI/Dialog.cpp,
	  src/osgUI/LineEdit.cpp, src/osgUI/Popup.cpp,
	  src/osgUI/PushButton.cpp, src/osgUI/Style.cpp: Implemented basic
	  frame graphic

2014-05-29 15:21  robert

	* src/osgUI/ComboBox.cpp, src/osgUI/Popup.cpp: Futher work on
	  ComboBox/Popup

2014-05-29 10:51  robert

	* include/osgUI/ComboBox, src/osgUI/ComboBox.cpp: Added beginnings
	  of ComboBox popup functionality.

2014-05-28 10:18  robert

	* include/osgUI/Style, src/osgUI/Style.cpp: Added cached Depth and
	  ColorMask to reduce the amount of duplicate state in the osgUI
	  subgraph

2014-05-28 10:06  robert

	* include/osgDB/Serializer, include/osgUI/Style,
	  include/osgUI/Widget, src/osgUI/ComboBox.cpp,
	  src/osgUI/Dialog.cpp, src/osgUI/Label.cpp,
	  src/osgUI/LineEdit.cpp, src/osgUI/Popup.cpp,
	  src/osgUI/PushButton.cpp, src/osgUI/Style.cpp,
	  src/osgUI/Widget.cpp,
	  src/osgWrappers/serializers/osg/TransferFunction1D.cpp,
	  src/osgWrappers/serializers/osgUI/Widget.cpp: Replaced
	  Widget::GraphicsSubgraph with GraphicsSubgraphMap to allow finer
	  control of when the rendering subgraphs are done.

2014-05-27 14:14  robert

	* src/osgUI/Label.cpp, src/osgUI/Style.cpp: Improved handling of
	  text

2014-05-26 16:32  robert

	* include/osgUI/Dialog, include/osgUI/Popup, src/osgUI/Dialog.cpp,
	  src/osgUI/Popup.cpp,
	  src/osgWrappers/serializers/osgUI/Dialog.cpp,
	  src/osgWrappers/serializers/osgUI/Popup.cpp: Removed
	  Dialog/Popup::open/close() methods as they are replaced by the
	  setVisible() method

2014-05-26 16:27  robert

	* include/osgUI/Dialog, src/osgUI/Dialog.cpp, src/osgUI/Popup.cpp,
	  src/osgUI/Widget.cpp: Implemented Widger::Visible and Enabled
	  usage

2014-05-26 16:15  robert

	* include/osgUI/Widget, src/osgUI/Widget.cpp,
	  src/osgWrappers/serializers/osgUI/Widget.cpp: Added Visible and
	  Enalbed properties to Widget

2014-05-26 16:15  robert

	* src/osgUI/ComboBox.cpp: Fixed missing initilaizer

2014-05-26 15:58  robert

	* src/osgWrappers/serializers/osgUI/Item.cpp: Added item serializer

2014-05-23 18:59  robert

	* include/osgUI/Style, src/osgUI/ComboBox.cpp,
	  src/osgUI/Dialog.cpp, src/osgUI/LineEdit.cpp,
	  src/osgUI/Popup.cpp, src/osgUI/PushButton.cpp,
	  src/osgUI/Style.cpp: Implemented clipping of widget to the
	  widgets extents.

2014-05-23 15:00  robert

	* applications/osgversion/Contributors.cpp, include/osgUI/Style,
	  src/osgUI/Dialog.cpp, src/osgUI/Popup.cpp,
	  src/osgUI/PushButton.cpp, src/osgUI/Style.cpp: Implemented scheme
	  for making sure nested widgest overdraw parent widgets graphics

2014-05-23 15:00  robert

	* src/osgWrappers/serializers/osgUI/Dialog.cpp,
	  src/osgWrappers/serializers/osgUI/Popup.cpp: Added wrappers for
	  open and close methods

2014-05-22 10:02  robert

	* include/osgUI/Widget, src/osgUI/ComboBox.cpp,
	  src/osgUI/Dialog.cpp, src/osgUI/LineEdit.cpp,
	  src/osgUI/Popup.cpp, src/osgUI/PushButton.cpp,
	  src/osgUI/Widget.cpp,
	  src/osgWrappers/serializers/osgUI/Widget.cpp: Added
	  osgUI::Widget::set/getGraphicsSubgraph() to hold the subgraph
	  that does the rendering portion of widgets

2014-05-21 16:15  robert

	* include/osgDB/ObjectWrapper, include/osgDB/Serializer,
	  include/osgUI/PushButton, src/osgUI/PushButton.cpp,
	  src/osgWrappers/serializers/osgUI/PushButton.cpp,
	  src/osgWrappers/serializers/osgUI/Widget.cpp: Addd method
	  implementation in serializers

2014-05-21 10:17  robert

	* src/osgUI/PushButton.cpp, src/osgUI/Widget.cpp: Fixed handling of
	  traverse

2014-05-21 09:45  robert

	* include/osgUI/Widget, src/osgUI/Widget.cpp: Improved handling of
	  callback object to open the door to use of general
	  osg::CallbackObject as mechnisms for something simialr to Qt's
	  signal/slot mechanism.

2014-05-21 09:07  robert

	* include/osg/ScriptEngine: Added osg::runNamedCallbackObjects(..)
	  convinience method for run all named osg::CallbackObjects
	  attached to an osg::Object

2014-05-21 09:06  robert

	* include/osg/Drawable, src/osg/Drawable.cpp: Renamed callbacks to
	  avoid overlap with Node callbacks

2014-05-20 16:09  robert

	* include/osg/Drawable, include/osgUtil/UpdateVisitor: Moved the
	  _boundingSphere set method into the update section of the
	  Drawable::getBoundingBox() method
	  
	  Added an UpdateVisitor::apply(Drawable&) implementation.

2014-05-20 15:34  robert

	* include/osg/Drawable: From Pjotr Svetachov, "I stumbled on a
	  little bug with the new drawables. I was distributing points data
	  into different drawables that I used in a LOD later. When
	  simplifying the system to not use geodes anymore I came upon the
	  following bug:
	  If Drawable::getBoundingBox would compute an invalid bounding box
	  (if it was for example empty) it would make a bounding sphere
	  with a infinite radius which counts as a valid sphere in osg.
	  
	  Attached is a small fix."

2014-05-20 08:35  robert

	* include/osgUI/LineEdit, src/osgUI/Dialog.cpp,
	  src/osgUI/LineEdit.cpp: Improved the handling of updating of text

2014-05-20 08:35  robert

	* include/osgUI/Popup, src/osgUI/CMakeLists.txt,
	  src/osgUI/Popup.cpp, src/osgWrappers/serializers/osgUI/Popup.cpp:
	  Added shell of Popup class

2014-05-20 08:34  robert

	* src/osgViewer/CompositeViewer.cpp, src/osgViewer/Viewer.cpp:
	  Added check against whether an event has been handled or not
	  before actioning escape/quit.

2014-05-19 10:11  robert

	* include/osgUI/Dialog, src/osgUI/CMakeLists.txt,
	  src/osgUI/Dialog.cpp,
	  src/osgWrappers/serializers/osgUI/Dialog.cpp: Add shell of Dialog
	  class

2014-05-19 09:30  robert

	* src/osgUI/ComboBox.cpp: Added handling of up/down key to ComboBox

2014-05-16 19:24  robert

	* include/osgUI/ComboBox, include/osgUI/PushButton,
	  src/osgUI/CMakeLists.txt, src/osgUI/ComboBox.cpp,
	  src/osgUI/PushButton.cpp,
	  src/osgWrappers/serializers/osgUI/ComboBox.cpp: Added initial cut
	  of ComboBox

2014-05-16 10:38  robert

	* include/osgUI/Label, include/osgUI/LineEdit,
	  include/osgUI/PushButton, src/osgUI/CMakeLists.txt,
	  src/osgUI/Label.cpp, src/osgUI/LineEdit.cpp,
	  src/osgUI/PushButton.cpp, src/osgUI/Style.cpp,
	  src/osgUI/Widget.cpp,
	  src/osgWrappers/serializers/osgUI/PushButton.cpp: Added initial
	  shell of PushButton implementation

2014-05-15 16:30  robert

	* include/osgUtil/IntersectVisitor,
	  include/osgUtil/IntersectionVisitor,
	  src/osgUtil/IntersectVisitor.cpp,
	  src/osgUtil/IntersectionVisitor.cpp: Added support for
	  intesecting Drawable that are attached directly to the scene
	  graph without an osg::Geode

2014-05-15 14:57  robert

	* src/osg/Notify.cpp: From Sebastian Messerschmidt, "There was some
	  small error due to MS non-conformity handling comments
	  correctly."

2014-05-15 14:45  robert

	* include/osgUI/Export, src/osgUI/CMakeLists.txt: From Pjotr
	  Svetachov, build fixes for VisualStudio

2014-05-15 13:34  robert

	* src/osgUI/CMakeLists.txt: Added osgGA dependency

2014-05-15 13:22  robert

	* include/osg/Plane: Placed the #include<osg/Node> within #ifdef
	  OSG_USE_BOUND to prevent unncessary inclusion of Node header when
	  OSG_USE_BOUND is false.

2014-05-15 09:26  robert

	* include/osg/Drawable, include/osg/Geometry, include/osg/Node,
	  src/osg/Group.cpp: Added Node::asDrawable() and
	  Node::asGeometry() methods to provide a low cost way of casting a
	  node to Drawable and Geoemtry.
	  
	  Changed the Group::computeBound() method so that it takes account
	  of the a Drawable's BoundingBox.

2014-05-14 16:52  robert

	* include/osg/Drawable, src/osgUtil/CullVisitor.cpp: Fixed the
	  bounding sphere computation and handling of Drawable as the root
	  of the scene graph

2014-05-14 16:01  robert

	* examples/osgdepthpeeling/DePee.cpp, examples/osghud/osghud.cpp,
	  examples/osgoit/HeatMap.cpp,
	  examples/osgposter/PosterPrinter.cpp,
	  examples/osgqfont/osgqfont.cpp, examples/osgtext/osgtext.cpp,
	  include/osg/CullingSet, include/osg/Drawable, include/osg/Node,
	  src/osg/Billboard.cpp, src/osg/ComputeBoundsVisitor.cpp,
	  src/osg/Geode.cpp, src/osg/Group.cpp, src/osg/KdTree.cpp,
	  src/osg/Switch.cpp,
	  src/osgPlugins/OpenFlight/GeometryRecords.cpp,
	  src/osgPlugins/fbx/WriterCompareTriangle.cpp,
	  src/osgPlugins/txp/TXPParser.cpp,
	  src/osgPresentation/deprecated/PickEventHandler.cpp,
	  src/osgPresentation/deprecated/SlideShowConstructor.cpp,
	  src/osgShadow/MinimalCullBoundsShadowMap.cpp,
	  src/osgShadow/ViewDependentShadowMap.cpp,
	  src/osgUtil/CullVisitor.cpp, src/osgUtil/IntersectVisitor.cpp,
	  src/osgUtil/LineSegmentIntersector.cpp,
	  src/osgUtil/Optimizer.cpp, src/osgUtil/RayIntersector.cpp,
	  src/osgViewer/HelpHandler.cpp, src/osgViewer/StatsHandler.cpp,
	  src/osgWidget/Label.cpp: Further work on Bound
	  class/Node::getBound() and Drawable::getBound() and usage in OSG
	  codebase

2014-05-14 16:00  robert

	* src/osgViewer/config/WoWVxDisplay.cpp: Cleaned up code

2014-05-14 10:19  robert

	* CMakeLists.txt, examples/osgforest/osgforest.cpp,
	  examples/osgkeyboardmouse/osgkeyboardmouse.cpp,
	  examples/osgoit/HeatMap.cpp,
	  examples/osgparticleeffects/osgparticleeffects.cpp,
	  examples/osgteapot/osgteapot.cpp, include/osg/CullingSet,
	  include/osg/DrawPixels, include/osg/Drawable, include/osg/Node,
	  include/osg/Plane, include/osg/Polytope,
	  include/osg/ShapeDrawable, include/osgParticle/ParticleSystem,
	  include/osgShadow/OccluderGeometry,
	  include/osgSim/ImpostorSprite, include/osgText/Text3D,
	  include/osgText/TextBase, src/osg/Config.in,
	  src/osg/DrawPixels.cpp, src/osg/Drawable.cpp, src/osg/Group.cpp,
	  src/osg/ShapeDrawable.cpp, src/osg/Switch.cpp,
	  src/osgAnimation/RigGeometry.cpp,
	  src/osgParticle/ParticleSystem.cpp,
	  src/osgPlugins/logo/ReaderWriterLOGO.cpp,
	  src/osgShadow/OccluderGeometry.cpp,
	  src/osgSim/ImpostorSprite.cpp, src/osgSim/LightPointDrawable.cpp,
	  src/osgSim/LightPointDrawable.h, src/osgSim/OverlayNode.cpp,
	  src/osgSim/SphereSegment.cpp, src/osgText/Text3D.cpp,
	  src/osgText/TextBase.cpp, src/osgUtil/PlaneIntersector.cpp,
	  src/osgUtil/PolytopeIntersector.cpp:

2014-05-13 08:43  robert

	* include/osg/Group, include/osg/Node, src/osg/Group.cpp,
	  src/osg/Node.cpp, src/osgPlugins/txp/TXPParser.cpp,
	  src/osgUtil/Optimizer.cpp: Changed the Node::ParentList to be a
	  list of osg::Node rather than osg::Group, and added addChild,
	  removeChild, replaceChild virtual method to Node to enable code
	  to user code compile with minimal modifications to account for
	  the new change to the Node ParentList.

2014-05-12 12:10  robert

	* include/osg/Drawable, include/osg/Geode, include/osg/Geometry,
	  include/osg/NodeVisitor, include/osgUtil/CullVisitor,
	  include/osgUtil/IncrementalCompileOperation,
	  src/osg/Drawable.cpp, src/osg/Geode.cpp, src/osg/NodeVisitor.cpp,
	  src/osgUtil/CullVisitor.cpp, src/osgUtil/GLObjectsVisitor.cpp,
	  src/osgUtil/IncrementalCompileOperation.cpp,
	  src/osgUtil/Statistics.cpp: From Farshid Lashkari, "As discussed,
	  I've added the ability to handle Drawable objects within the
	  NodeVisitor class. Here is an overview of the changes:
	  
	  - Added apply(Drawable) and apply(Geometry) to NodeVisitor
	  
	  - Added accept(NodeVisitor) method to Drawable/Geometry
	  
	  - Added traverse(NodeVisitor) to Geode which calls
	  accept(NodeVisitor) on all Drawables
	  
	  - Updated CullVisitor to use new apply(Drawable) to handle
	  drawables. The apply(Billboard) method still manually handles the
	  drawables since it is depends on the billboard settings. I needed
	  to disable the traverse within billboard to prevent duplicate
	  traversal of drawables.
	  
	  - Update other osgUtil node visitors (GLObjectsVisitor,
	  IncrementalCompileOperation, ..) to use new apply(Drawable)
	  method.
	  "

2014-05-12 11:27  robert

	* examples/osgtransferfunction/CMakeLists.txt,
	  examples/osgtransferfunction/TransferFunctionWidget.h,
	  include/osgUI, include/osgUI/AlignmentSettings,
	  include/osgUI/Export, include/osgUI/FrameSettings,
	  include/osgUI/Label, include/osgUI/LineEdit, include/osgUI/Style,
	  include/osgUI/TextSettings, include/osgUI/Widget,
	  src/CMakeLists.txt, src/osgUI, src/osgUI/AlignmentSettings.cpp,
	  src/osgUI/CMakeLists.txt, src/osgUI/FrameSettings.cpp,
	  src/osgUI/Label.cpp, src/osgUI/LineEdit.cpp, src/osgUI/Style.cpp,
	  src/osgUI/TextSettings.cpp, src/osgUI/Widget.cpp,
	  src/osgWrappers/serializers/CMakeLists.txt,
	  src/osgWrappers/serializers/osgUI,
	  src/osgWrappers/serializers/osgUI/AlignmentSettings.cpp,
	  src/osgWrappers/serializers/osgUI/CMakeLists.txt,
	  src/osgWrappers/serializers/osgUI/FrameSettings.cpp,
	  src/osgWrappers/serializers/osgUI/Label.cpp,
	  src/osgWrappers/serializers/osgUI/LineEdit.cpp,
	  src/osgWrappers/serializers/osgUI/TextSettings.cpp,
	  src/osgWrappers/serializers/osgUI/Widget.cpp: Added beginnings of
	  new osgUI library, a replacement for osgWidget that works fully
	  in 3D/stereo and is scriptable.

2014-05-06 16:38  robert

	* src/OpenThreads/pthreads/PThread.cpp: Replaced obsolete __linux
	  usage.

2014-05-06 09:43  robert

	* CMakeLists.txt: From Stephan Huber, "Xcode changed the default
	  std-lib-implementation again. Now it’s GNU++98 instead of C++11.
	  I adapted the cMakeList.txt files accordingly to add this new
	  option so we can set it explicitly and link against
	  3rdparty-c++-libs."

2014-05-06 08:37  robert

	* CMakeModules/FindQuickTime.cmake: From Stephan Huber, "Please
	  revert the change to FindQuickTime.cmake as this breaks
	  compilation for IOS and possibly OS X."

2014-05-02 09:12  robert

	* src/osgPlugins/dae/daeRMaterials.cpp: From Farshid Lashkari, "fix
	  for the Collada loader where it would access a null string in
	  some cases"

2014-05-02 09:11  robert

	* src/OpenThreads/win32/Win32Thread.cpp: From Ali Botorabi,
	  "recently I ran into a problem with Microsoft's Appverifier while
	  using OpenThreads on win32 platform. The Appverifier complained
	  about an invalid thread handle during starting of a new thread.
	  After looking closer into the problem it seemed that indeed a
	  potential root of problem may be in the thread startup code. See
	  the line below in Win32Thread.cpp (line number 347):
	  
	  pd->tid.set(
	  (void*)_beginthreadex(NULL,static_cast<unsigned>(pd->stackSize),ThreadPrivateActions::StartThread,static_cast<void
	  *>(this),0,&ID));
	  
	  the method "pd->tid.set" sets the thread id, however via the
	  startup function "ThreadPrivateActions::StartThread" that thread
	  id is used (see further down the call hierarchy the line "int
	  status = SetThreadPriority( pd->tid.get(), prio);".
	  
	  Until now I never ran into any problem in debug or release
	  builds, though. It seems that furtunately the tid.set method was
	  executed always before the tid.get method in the startup code.
	  However, this may make trouble in the furture. A simple solution
	  is the following: just replace the line above with following two
	  lines:
	  
	  pd->tid.set(
	  (void*)_beginthreadex(NULL,static_cast<unsigned>(pd->stackSize),ThreadPrivateActions::StartThread,static_cast<void
	  *>(this),CREATE_SUSPENDED,&ID));
	  ResumeThread(pd->tid.get());
	  
	  
	  The trick is just starting the thread in suspended mode so the
	  StartThread function does not get executed and we can safely
	  store the tid by pd->tid.set. Then start the Thread by calling
	  ResumeThread."

2014-05-01 15:50  robert

	* CMakeLists.txt: From Stephan Huber, fix for OSX build

2014-04-30 13:19  robert

	* CMakeLists.txt, include/osg/GL, src/osg/CMakeLists.txt,
	  src/osg/GL.in, src/osg/OpenGL.in: Renamed the new
	  include/osg/OpenGL automatically configured header file to
	  include/osg/GL replacing the original hand built GL header

2014-04-30 11:51  robert

	* include/osgDB/PropertyInterface: From Sebastian Messerschmidt,
	  "attached is the compile/linker fix for multiple definitions of
	  getTypeEnum when compiling the Lua with VisualStudio and
	  potentially other compilers.
	  "

2014-04-29 15:14  robert

	* include/osgAnimation/RigGeometry,
	  src/osgAnimation/RigGeometry.cpp,
	  src/osgWrappers/serializers/osg/ComputeBoundingBoxCallback.cpp,
	  src/osgWrappers/serializers/osg/UpdateCallback.cpp,
	  src/osgWrappers/serializers/osgAnimation/RigComputeBoundingBoxCallback.cpp,
	  src/osgWrappers/serializers/osgAnimation/UpdateVertex.cpp: From
	  Pjotr Svetachov, "have added some missing serializers for
	  RigGeomery. Withouth them I
	  ran into two issues.
	  
	  At first you get a bunch of warnings that
	  osg::ComputeBoundCallback
	  and osg::UpdateCallback were unsupported wrapper classes when
	  converting fbx models with skeletal animation to osg(t/b).
	  
	  The second issue was that when reading, the readers fail to read
	  the
	  ComputeBoundCallback and UpdateCallback and set them to NULL
	  which
	  messes up the RigGeometry.
	  
	  Because a RigGeometry makes his own classes in the constructor it
	  might be preferable to not write them at all, because now those
	  classes are being made two times when reading a RigGeometry. But
	  after
	  thinking about this that would place too much limits on them (you
	  won't be able to share or name them and save that information or
	  make
	  a new inherited class from them and write that one) So I ended up
	  thinking the best way was to just write the files.
	  "

2014-04-29 13:41  robert

	* include/osgDB/OutputStream: From Pjotr Svetachov, "Today I found
	  a bug in the IutputStream class when saving array
	  attributes in vec3b format. It looks like my compiler takes the
	  wrong
	  overload and outputs integers instead of characters. The problem
	  is
	  that vec3b is of type signed char and that is not the same as
	  char (
	  see
	  http://stackoverflow.com/questions/436513/char-signed-char-char-unsigned-char
	  ) and visual studio 2013 will promote it to integer when choosing
	  an
	  overload.
	  It looks like that the InputStream class already takes care of
	  this
	  issue (if it didn't it would have read everything ok and I would
	  have
	  not even stumbled upon this bug. :) )"

2014-04-29 12:19  robert

	* CMakeModules/FindFLTK.cmake, CMakeModules/FindFreetype.cmake,
	  CMakeModules/FindGDAL.cmake, CMakeModules/FindJasper.cmake,
	  CMakeModules/FindOpenThreads.cmake,
	  CMakeModules/FindQuickTime.cmake, CMakeModules/FindZLIB.cmake:
	  From Mattias Helsing, "I finally got to fix the cmake Modules
	  that have duplicates in later
	  version of cmake. See attached submission. I have tested the ones
	  that
	  I compile myself (GDAL, Freetype, ZLIB) on ubuntu 12.04 with
	  cmake-2.8.7."

2014-04-29 12:18  robert

	* CMakeLists.txt, CMakeModules/FindGLCORE.cmake,
	  CMakeModules/OsgMacroUtils.cmake: From Paul Martz, "There is no
	  standard place for gl/glcorearb.h on Windows. Previously, the
	  only way to get OSG to build for core profile was to append an
	  additional include directory ("/I") onto the CFLAGS variables
	  This submission adds a FindGLCORE.cmake script so that the path
	  to gl/glcorearb.h can be specified with a variable, GLCORE_ROOT,
	  either in CMake or the environment.
	  
	  Currently this submission is Windows-only. I don't think OSX or
	  Linux require any help in locating gl/glcorearb.h. But if they
	  do, this submission can be easily modified.
	  
	  Files:
	  - "CMakeLists.txt" is the top-level file.
	  - FindGLCORE.cmake" and "OsgMacroUtils.cmake" go in CMakeModules.
	  "

2014-04-28 14:58  robert

	* src/osg/Image.cpp: From Pjotr Svetachov, "I had the osgvolume
	  example crash on me when loading large volume
	  datasets due to an overflow in image.cpp after a unneeded cast
	  from
	  unsigned int to int. Here is a small fix."

2014-04-28 14:57  robert

	* src/osgDB/FileUtils.cpp: From Jason Beverage, "Here is a fix for
	  a small race condition in osgDB::makeDirectory. It attempts to
	  create all the directories in the given path and stops attempting
	  to make directories when one of them fails. I've added a check to
	  see if the failure occurred b/c the directory was created by
	  another thread or process.
	  
	  We were running into issues occasionally in osgEarth where
	  multiple threads were writing out files like /1/2/3.jpg and
	  /1/3/4.jpg. Both threads would try to create the /1 directory and
	  only one of them would succeed. So the first thread would write
	  out the full /1/2/3.jpg while the second thread wouldn't create
	  the /1/3 directory b/c /1 was already created and the writing of
	  /1/3/4.jpg would fail.
	  "

2014-04-28 11:53  robert

	* src/osgSim/SphereSegment.cpp: Fixed type error

2014-04-25 08:57  robert

	* applications/osgviewer/osgviewer.cpp, src/osg/CMakeLists.txt,
	  src/osgViewer/Renderer.cpp: From Pjotr Svetachov, "For me
	  osgviewer.cpp and Renderer.cpp were not compiling (visual studio
	  2013 with profile GL2) because they were still using GLuintEXT.
	  So I changed that, see the attached files.
	  
	  I also noticed that the generated OpenGL header were not copied
	  to the installation directory so my own application could not
	  find it."

2014-04-25 08:56  robert

	* CMakeLists.txt: Reordered the configuiration file blocks to make
	  it more understandable

2014-04-25 08:18  robert

	* CMakeLists.txt: From Paul Martz, fixed placement of OpenGL header
	  so that it gets generated and placed in the build directory as
	  per the Config file

2014-04-24 17:26  robert

	* src/osgPlugins/dae/daeRMaterials.cpp: From Farshid Lashkari,
	  "I've attached a small fix to the Collada loader which prevents a
	  null pointer access in some cases."

2014-04-24 17:23  robert

	* src/osg/Texture2DArray.cpp: From Lionel Lagarde, "In the ::apply
	  method, when the image data need to be re-uploaded, the
	  Texture2DArray checks if the TextureObject can be re-used. The
	  test was made using the constant 1 instead of the real texture
	  depth, so the TextureObject was never re-used."

2014-04-24 17:14  robert

	* examples/osgviewerQt/osgviewerQt.cpp,
	  include/osgGA/GUIEventAdapter, include/osgQt/GraphicsWindowQt,
	  src/osgGA/GUIEventAdapter.cpp,
	  src/osgGA/MultiTouchTrackballManipulator.cpp,
	  src/osgQt/GraphicsWindowQt.cpp,
	  src/osgViewer/CompositeViewer.cpp, src/osgViewer/Viewer.cpp: From
	  Kristofer Tingdahl, "I and my team have gone over the code again,
	  and we feel that we are comfortable in our current proposal for
	  change. It goes deeper than it did before, and I explain why:
	  
	  There was code in the osgViewer/Viewer.cpp and
	  osgViewer/CompositeViewer.cpp that transformed the Y-coordinates
	  of an event. The code in the composite viewer did however miss
	  the touch-data of the event. I thought that it should really be
	  the GUIEventAdapter that should know about this, and hence I
	  added the
	  GUIEventAdapter::setMouseYOrientationAndUpdateCoords which is
	  re-computing the coordinates. First I simply added a boolean to
	  the setMouseYOrientation function:
	  
	  setMouseYOrientation( MouseYOrientation, bool updatecooreds=false
	  );
	  
	  but then the serializer complained.
	  
	  This function is called from both the Viewer and the
	  CompositeViewer. We have not tested from the viewer, but I cannot
	  see it would not work from visual inspection.
	  
	  The other change is in
	  MultiTouchTrackballManipulator::handleMultiTouchDrag. I have
	  removed the normalisation. The reason for that is that it
	  normalised into screen coordinates from 0,0 to 1,1. The problem
	  with that is that if you have a pinch event and you keep the
	  distance say 300 pixels between your fingers, these 300 pixels
	  represent 0.20 of the screen in the horizontal domain, but 0.3 of
	  the screen in the vertical domain. A rotation of the
	  pinch-fingers will hence result in a zoom in, as the normalised
	  distance is changing between them.
	  
	  A consequence of this is that I have changed the pan-code to use
	  the same algorithm as the middle-mouse-pan.
	  
	  The rest of it is very similar from previous revision, and there
	  has been some fine-tuning here and there.
	  
	  "

2014-04-24 10:49  robert

	* CMakeModules/FindGDAL.cmake: From Mattias Helsing, "Seems I was
	  only half right given what you asked for. CMP0017 only
	  says that modules that are found and ran from cmake modules dir
	  should
	  prefer cmake-provided modules. find_package() and include() still
	  look
	  in CMAKE_MODULE_PATH first.
	  
	  After some investigating I've come up with a proposal examplified
	  in
	  the attached FindGDAL.cmake script. It simply calls the cmake
	  provided
	  FindGDAL.cmake if it exists and returns if it succeeds in finding
	  GDAL
	  using that, otherwise continue with our local cmake code.
	  Pro: Wont clutter our root CMakeLists.txt
	  Con: If we begin to write more advanced Findxxx modules (using
	  COMPONENTS, REQUIRED etc.) we may have to revise this scheme.
	  "

2014-04-24 10:38  robert

	* src/osgSim/SphereSegment.cpp: Fixed reference invalidation bug.

2014-04-24 07:22  robert

	* CMakeLists.txt: Fixed typo in OPENSCENEGRAPH_OPENGL_HEADER name

2014-04-24 07:20  robert

	* include/osg/OpenGL: Removed header as this CMake generated
	  configuration file is not required to be part of svn repository

2014-04-23 19:30  robert

	* include/osg/OpenGL, src/osg/OpenGL.in: Added src/osg/OpenGL.in
	  configuration file and include/osg/OpenGL header files

2014-04-23 09:08  robert

	* CMakeLists.txt, applications/osgviewer/osgviewer.cpp,
	  examples/CMakeLists.txt, include/osg/Drawable, include/osg/GL,
	  include/osg/State, include/osgQt/GraphicsWindowQt,
	  include/osgQt/QGraphicsViewAdapter, include/osgQt/QWidgetImage,
	  src/osg/Config.in, src/osg/Drawable.cpp, src/osg/State.cpp,
	  src/osgQt/GraphicsWindowQt.cpp: Introduced new scheme for setting
	  up which version of OpenGL/OpenGL ES the OSG is compiled for.
	  
	  To select standard OpenGL 1/2 build with full backwards and
	  forwards comtability use:
	  
	  ./configure
	  make
	  
	  OR
	  
	  ./configure -DOPENGL_PROFILE=GL2
	  
	  To select OpenGL 3 core profile build using GL3/gl3.h header:
	  
	  ./configure -DOPENGL_PROFILE=GL3
	  
	  To select OpenGL Arb core profile build using GL/glcorearb.h
	  header:
	  
	  ./configure -DOPENGL_PROFILE=GLCORE
	  
	  To select OpenGL ES 1.1 profile use:
	  
	  ./configure -DOPENGL_PROFILE=GLES1
	  
	  To select OpenGL ES 2 profile use:
	  
	  ./configure -DOPENGL_PROFILE=GLES2
	  
	  
	  Using OPENGL_PROFILE will select all the appropriate features
	  required so no other settings in cmake will need to be adjusted.
	  The new configuration options are stored in the
	  include/osg/OpenGL header that deprecates the old include/osg/GL
	  header.

2014-04-14 16:16  robert

	* include/osgManipulator/TranslatePlaneDragger: Fixed comment

2014-04-13 16:04  robert

	* CMakeLists.txt, CMakeModules/FindFreeType.cmake,
	  CMakeModules/FindFreetype.cmake: Renamed FindFreeType.cmake to
	  FindFreetype.cmake to enable CMake build to pick up on CMake's
	  own FindFreetype.cmake when it's available.

2014-04-09 17:40  robert

	* CMakeModules/FindFBX.cmake,
	  src/osgPlugins/fbx/ReaderWriterFBX.cpp: From Paul
	  Cheyrou-Lagreze, "Attached is fix/feature for FBX osgplugins
	  against latest trunk:
	  
	  - ReaderWriterFBX.cpp: add "z up scene axis" support: FBX
	  provides facility to convert model scene axis during conversion.
	  Currently fbx plugin convert axis to fbx:opengl axis system
	  (which is arbitrarily at Y up, as opengl is in reality axis
	  agnostic) and sometimes what is needed is Z up so added an option
	  for Z up conversion
	  
	  - FindFBX.cmake: add support for latest fbx sdk ( 2014.2 )"

2014-04-09 17:20  robert

	* src/osgPlugins/fbx/CMakeLists.txt: Disabled warnings to address
	  issues in FBX headers that generate lots of warnings that we
	  can't fix.

2014-04-08 19:42  robert

	* CMakeModules/FindFreeType.cmake: Added extra search paths to add
	  compatibility with Kubuntu/Ubuntu 14.04 now locaton for freetype

2014-04-08 17:45  robert

	* ChangeLog, applications/osgversion/Contributors.cpp: Updated
	  ChangeLog and fixed Contributors list

2014-04-08 12:00  robert

	* src/osgPlugins/tiff/ReaderWriterTIFF.cpp: From Remo Eichenberger,
	  "I have extended the TIFF plugin that allows you to write LZW or
	  JPEG compressed TIFF's. Options are:
	  
	  tiff_compression = lzw | jpeg"

2014-04-08 11:48  robert

	* include/osgGA/GUIActionAdapter: From Sebastian Messerschmidt, "n
	  the trunk version the osgGA::GUIActionAdapter has additional
	  functions for lineIntersection which use osgGA::GUIEventAdapter&,
	  but the class declaration is neither forwarded, nor is the header
	  included.
	  Using the trunk together with osgEarth 2.5 will fail to build,
	  due to the missing type.
	  
	  Attached is the file forward declaring osgGA::GUIEventAdapter."

2014-04-08 11:17  robert

	* src/osgWrappers/serializers/osgAnimation/Animation.cpp: From
	  Pjotr Svetachov, "We had a small problem converting skeleton
	  animations from fbx to osgt
	  format. Turned out that the serializer didn't handle bone names
	  with
	  spaces very well (the 3ds studio max biped for instance has
	  spaces by
	  default). Here is a small fix for the problem."

2014-04-08 11:08  robert

	* src/osgPlugins/obj/obj.cpp: From Pjotr Svetachov, previous obj
	  "commit broke compilation under visual studio 2013. To use
	  std::not1 you need to include the functional header. Here is a
	  fix."

2014-04-07 15:04  robert

	* include/osg/BoundingBox, include/osg/BoundingSphere: Fixed build
	  when using of double BoundingBox/BoundingSphere

2014-04-07 14:17  robert

	* src/osgPlugins/obj/obj.cpp: From Jan Peciva, "I am sending four
	  fixes to obj plugin:
	  
	  - materialName used to be not stripped of whitespace, making
	  number of models
	  fail to load materials; now fixed
	  - stripping was considering spaces only, thus models using tabs
	  had problems
	  to load correctly; fixed
	  - fixed references to textures; they did not performed conversion
	  to native
	  directory separators
	  - make d (dissolve) takes precedence over Tr (transparency);
	  there seems to be
	  a confusion about the Tr item - some claiming 1 to be opaque and
	  0
	  transparent, while number of models uses exactly the opposite. d
	  (dissolve),
	  if present in the model, does not suffer from this confusion,
	  thus using it
	  instead fixes the problem for many many models.
	  
	  I put many comments to the file concerning d and Tr item as
	  others may further
	  investigate. Let me know in the case of any problems."

2014-04-07 14:11  robert

	* src/OpenThreads/pthreads/PThread.cpp: From Marcel Pursche, "The
	  problem is that when OpenThreads is build with the Linux pthreads
	  implementation all threads inherit the processor affinity from
	  their parent thread.
	  This behavior is also described in the pthreads man page
	  (http://man7.org/linux/man-pages/man3/pthread_create.3.html):
	  
	  >
	  > Linux-specific details
	  > The new thread inherits copies of the calling thread's
	  capability
	  > sets (see capabilities(7)) and CPU affinity mask (see
	  > sched_setaffinity(2)).
	  >
	  
	  To prevent this behaviour I wrote a patch that explicitly sets
	  the affinity mask to all cores of the system, if no specific
	  affinity was defined with PThread::setProcessorAffinity(unsigned
	  int) .
	  
	  Thank you!
	  "

2014-04-07 14:03  robert

	* src/osgPlugins/3ds/lib3ds/lib3ds.h,
	  src/osgPlugins/3ds/lib3ds/lib3ds_chunktable.c,
	  src/osgPlugins/3ds/lib3ds/lib3ds_impl.h,
	  src/osgPlugins/3ds/lib3ds/lib3ds_material.c: From Bjorn Blessing,
	  "I got bored of the constant reports of “missing chunk 0xA08A”
	  when reading 3ds-files. After a bit of research I discovered that
	  this property is related to the advanced transparency settings
	  for the material in 3D studio. In this case the falloff
	  parameter. These controls affect the opacity falloff of a
	  transparent material. And the property chooses whether falloff is
	  in or out. I have added the property to the file reader BUT no
	  changes are made to make this property propagate into the
	  osgMaterial. But at least we get rid of this annoying error
	  message."

2014-04-07 13:52  robert

	* src/osgUtil/RayIntersector.cpp: From Bjorn Hein, "please find
	  attached a small fix for RayIntersector.cpp.
	  
	  * Changes are made against trunk
	  * Reason: crashes when using specific constructor from
	  RayIntersector
	  * Info: Line 42: added in constructor
	  RayIntersector::RayIntersector(const Vec3d& start, const Vec3d&
	  direction) missing initialisation of _parent
	  "

2014-04-07 13:48  robert

	* include/osg/GL2Extensions: From Paul Martz, "We discussed the
	  issue of GL_RED_SNORM and GL_RG_SNORM some time ago, but the
	  issue was never completely resolved. Please see the attached
	  submission to fix the issue.
	  
	  osg/GL2Extensions was incorrectly defining GL_RED_SNORM and
	  GL_RG_SNORM as part of the definitions for OpenGL v3.1. However,
	  a quick review of the 3.1 spec indicates that these are not part
	  of the 3.1 standard.
	  
	  My attached change moves these definitions out of the #ifndef
	  GL_VERSION_3_1 conditional block, and defines them conditionally
	  if not already defined. This allows the DDS plugin to build for
	  GL3.
	  "

2014-04-04 11:25  robert

	* src/osgVolume/Shaders/volume_accumulateSamples_iso_frag.cpp,
	  src/osgVolume/Shaders/volume_accumulateSamples_iso_tf_frag.cpp:
	  Fixed iso surface shaders

2014-04-01 18:56  robert

	* src/osgVolume/Property.cpp: Improved the setting of sample
	  density/ratio so that they are consistent

2014-04-01 18:33  robert

	* include/osgVolume/MultipassTechnique,
	  src/osgVolume/MultipassTechnique.cpp, src/osgVolume/Property.cpp,
	  src/osgVolume/Shaders/volume_accumulateSamples_iso_tf_frag.cpp,
	  src/osgVolume/Shaders/volume_accumulateSamples_lit_tf_frag.cpp,
	  src/osgVolume/Shaders/volume_accumulateSamples_mip_tf_frag.cpp,
	  src/osgVolume/Shaders/volume_accumulateSamples_standard_tf_frag.cpp,
	  src/osgVolume/Shaders/volume_compute_ray_color_frag.cpp,
	  src/osgVolume/VolumeScene.cpp: Fixed handling of volume tiles
	  with a region.

2014-03-27 12:47  robert

	* include/osgVolume/MultipassTechnique,
	  include/osgVolume/VolumeTechnique,
	  src/osgVolume/MultipassTechnique.cpp, src/osgVolume/Property.cpp,
	  src/osgVolume/Shaders/volume_accumulateSamples_iso_frag.cpp,
	  src/osgVolume/Shaders/volume_accumulateSamples_iso_tf_frag.cpp,
	  src/osgVolume/Shaders/volume_accumulateSamples_lit_frag.cpp,
	  src/osgVolume/Shaders/volume_accumulateSamples_lit_tf_frag.cpp,
	  src/osgVolume/Shaders/volume_accumulateSamples_mip_frag.cpp,
	  src/osgVolume/Shaders/volume_accumulateSamples_mip_tf_frag.cpp,
	  src/osgVolume/Shaders/volume_accumulateSamples_standard_frag.cpp,
	  src/osgVolume/Shaders/volume_accumulateSamples_standard_tf_frag.cpp,
	  src/osgVolume/Shaders/volume_compute_ray_color_frag.cpp,
	  src/osgVolume/Shaders/volume_multipass_cube_and_hull_frag.cpp,
	  src/osgVolume/Shaders/volume_multipass_cube_frag.cpp,
	  src/osgVolume/Shaders/volume_multipass_frag.cpp,
	  src/osgVolume/Shaders/volume_multipass_hull_frag.cpp,
	  src/osgVolume/VolumeScene.cpp: Added cube and hull rendering
	  support

2014-03-19 17:56  robert

	* include/osgVolume/MultipassTechnique,
	  include/osgVolume/VolumeScene, include/osgVolume/VolumeTechnique,
	  src/osgVolume/MultipassTechnique.cpp,
	  src/osgVolume/VolumeScene.cpp: Restructured the handling of
	  TileData to make it more extensible and flexible.

2014-03-18 18:14  robert

	* include/osgPresentation/deprecated/SlideShowConstructor,
	  include/osgVolume/Property,
	  src/osgPlugins/p3d/ReaderWriterP3D.cpp,
	  src/osgPresentation/deprecated/SlideShowConstructor.cpp,
	  src/osgVolume/MultipassTechnique.cpp, src/osgVolume/Property.cpp:
	  Addd ExteriorTransparencyFactorProperty for support of upcomming
	  functionality of rendering a cube volume with a hull volume
	  inside it.

2014-03-17 15:54  robert

	* include/osgPresentation/deprecated/SlideShowConstructor,
	  src/osgPlugins/p3d/ReaderWriterP3D.cpp,
	  src/osgPresentation/deprecated/SlideShowConstructor.cpp,
	  src/osgVolume/MultipassTechnique.cpp: Added support for animating
	  volume hulls.

2014-03-13 14:02  robert

	* src/osgPlugins/RestHttpDevice/RestHttpDevice.cpp: From Stephan
	  Huber, "attached is a fix for the rest-http-plugin which should
	  fix the font-issue reported by Phil. The old implementation did
	  forward all requests to the internal http-server via user-events.
	  This prevented error-reporting for missing files, as the request
	  was accidentally handled by the plugin. As a request for missing
	  font-file succeeds and returned an empty file, the curl-plugin
	  hands the data happily to the freetype-plugin which failed trying
	  to load an empty font-file, obviously.
	  
	  My fix was to rename the standard request handler to a
	  specialized user-event-handler which handles only requests for
	  "/user-event“
	  
	  So fonts should work on iOS when loaded remotely, even when a
	  local file is available and with the resthttp-plugin serving the
	  presentation.
	  "

2014-03-13 13:59  robert

	* src/osgPlugins/CMakeLists.txt: From Stephan Huber, fix for
	  building lua plugin from local source

2014-03-13 10:28  robert

	* include/osgPresentation/deprecated/SlideShowConstructor,
	  src/osgPlugins/p3d/ReaderWriterP3D.cpp,
	  src/osgPresentation/deprecated/SlideShowConstructor.cpp: Added
	  support for directly invoking scripts using <run-script> and
	  <run-script-file> to enable scripts to interact with each other.

2014-03-12 11:01  robert

	* src/osgGA/Widget.cpp,
	  src/osgPresentation/deprecated/SlideEventHandler.cpp,
	  src/osgWrappers/serializers/osgPresentation/PresentationInterface.cpp:
	  Improved support for passing events between scripts and Present3D
	  application

2014-03-11 10:52  robert

	* include/osgPresentation/PresentationInterface,
	  src/osgPresentation/CMakeLists.txt,
	  src/osgPresentation/PresentationInterface.cpp,
	  src/osgWrappers/serializers/osgPresentation/PresentationInterface.cpp:
	  Added PresentationInterface class to make it more convinient to
	  access the current presentation from scripting languages

2014-03-10 19:08  robert

	* include/osgPresentation/deprecated/SlideEventHandler,
	  src/osgPresentation/deprecated/SlideEventHandler.cpp: Added
	  scripting support for JumpData, KeyPosition, HomePosition and
	  parts of SlideEventHandler that enable dispatching of user
	  created events.

2014-03-07 11:09  robert

	* src/osgGA/Widget.cpp, src/osgPlugins/lua/LuaScriptEngine.cpp,
	  src/osgPlugins/lua/LuaScriptEngine.h,
	  src/osgWrappers/serializers/osg/Switch.cpp: Added ability to
	  replace callback objects via lua scripts to allow one to override
	  callbacks.
	  
